(function(win){
    var doc = win.document,
        version_select   = doc.getElementById('user-selector-select-version'),
        exttable_body    = doc.getElementById('user-selector-extensions-table'),
        exttable_save    = doc.getElementById('user-selector-table-save'),
        exttable_default = doc.getElementById('user-selector-table-default'),
        infobox          = doc.getElementById('infobox').innerHTML;

    if ( infobox ) {
        displayIt('warn',infobox);
    }

    exttable_save.onclick = function(e){
        var selected_version = version_select.options[version_select.selectedIndex].firstChild.nodeValue,
            checkbox_list    = exttable_body.getElementsByTagName('input'),
            selected_temp    = {},
            selected_boxes   = [],
            request = new XMLHttpRequest(),
            request_data = {'version':selected_version,'action':'extsave'};
        if ( typeof(username) !== 'undefined' ) {
            request_data['username'] = username;
        }
        for ( var i in checkbox_list ) {
            if ( checkbox_list[i].name !== undefined
                && checkbox_list[i].name.indexOf('cbx_') == 0
                && !checkbox_list[i].disabled && checkbox_list[i].checked ) {
                selected_temp[ checkbox_list[i].name.substring(4) ] = 1;
            }
        }
        for ( var k in selected_temp ) {
            selected_boxes.push(k);
        }
        request_data['extset'] = selected_boxes.join(',');
        request.open("POST",uri);
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var data = JSON.parse(request.responseText);
                if ( 'message' in data ) {
                    displayIt(data['status'].toLowerCase(), data['message'] )
                }
                else {
                    displayIt('info', 'module set saved');
                }
                if ( 'data' in data ) {
                    for ( var i in data['data'] ) {
                        if ( typeof(data['data'][i].title) === 'undefined' )
                            continue;
                        var extname   = 'cbx_' + data['data'][i].title,
                            extstatus = data['data'][i].status;
                        selector_ext_form[extname].checked = (extstatus == '1' ? true : false);
                    }
                }
            }
        };
        request.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
        request.send(encodeFormData(request_data));
    };

    exttable_default.onclick = function(e){
        var selected_version = version_select.options[version_select.selectedIndex].firstChild.nodeValue,
            checkbox_list    = exttable_body.getElementsByTagName('input'),
            request = new XMLHttpRequest(),
            request_data = {'version':selected_version,'action':'extdefaults'};
        if ( typeof(username) !== 'undefined' ) {
            request_data['username'] = username;
        }
        request.open( "POST", uri );
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var data_dictionary = {};
                var data = JSON.parse(request.responseText);
                if ( data !== undefined ) {
                    if ( 'message' in data ) {
                        displayIt(data['status'].toLowerCase(), data['message'] )
                    }
                    else {
                        displayIt('info', 'module set saved');
                    }
                    if ( 'data' in data ) {
                        for ( var i in data['data'] ) {
                            if ( typeof data['data'][i].title != 'string' ) {
                                continue;
                            }
                            var extname = 'cbx_' + data['data'][i].title;
                            data_dictionary[extname] = 1;
                        }
                        for ( var i in checkbox_list ) {
                            if ( checkbox_list[i].name === undefined || checkbox_list[i].name.indexOf('cbx_') == -1 ) {
                                continue;
                            }
                            if ( checkbox_list[i].name in data_dictionary ) {
                                selector_ext_form[ checkbox_list[i].name ].checked = true;
                            }
                            else {
                                selector_ext_form[ checkbox_list[i].name ].checked = false;
                            }
                        }
                    }
                }           
            }
        };
        request.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
        request.send(encodeFormData(request_data));
    };

    version_select.onchange = function(e){
        var selected_version = version_select.options[version_select.selectedIndex].firstChild.nodeValue,
            request = new XMLHttpRequest(),
            request_data = {"version":selected_version,"action":"extlist"};
        if ( typeof(username) !== 'undefined' ) {
            request_data['username'] = username;
        }
        request.open("POST", uri); // uri defined in template
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var data = JSON.parse(request.responseText),
                    indexes = [];
                if ( data['data'] !== undefined ) {
                    while ( exttable_body.firstChild ) {
                        exttable_body.removeChild(exttable_body.firstChild);
                    }
                    if ( data['status'] !== 'OK' && 'message' in data ) {
                        displayIt(data['status'].toLowerCase(), data['message'] )
                    }
                    for ( var i in data['data'] ){
                        if ( typeof(data['data'][i].title) === 'undefined' )
                            continue;
                        indexes.push(data['data'][i]);
                    }
                    var rownum = Math.floor( indexes.length / 5 );
                    if ( indexes.length % 5 != 0 ) {
                        rownum += 1;
                    }
                    for ( var r=1; r<=rownum; r++ ) {
                        var row = doc.createElement('tr');                        
                        row.style.borderBottom = selector_styles['row_border_bottom'];
                        if ( 'end_row_border_bottom' in selector_styles && r == rownum ) {
                            row.style.borderBottom = selector_styles['end_row_border_bottom'];
                        }
                        for ( var c=0; c<5; c++ ) {
                            var ext  = doc.createElement('td'),
                                stat = doc.createElement('td'),
                                id = (rownum * c + r - 1);
                            if ('label_cell_left_border' in selector_styles ) {
                                ext.style.borderLeft = selector_styles['label_cell_left_border'];
                            }
                            ext.style.padding = selector_styles['label_cell_left_padding'];
                            if ('ctrl_cell_padding' in selector_styles ) {
                                stat.style.padding = selector_styles['ctrl_cell_padding'];
                            }
                            if ( 'label_cell_minwidth' in selector_styles ) {
                                ext.style.minWidth = selector_styles['label_cell_minwidth'];
                            }
                            if ( c == 0 ) {
                                if ( 'label_cell_border' in selector_styles ) {
                                    ext.style.borderLeft = selector_styles['label_cell_border'];
                                }
                                if ( 'label_cell_padding' in selector_styles ) {
                                    ext.style.padding = selector_styles['label_cell_padding'];
                                }
                            }
                            if ( indexes[id] ) {
                                var ctrl = doc.createElement('input');
                                ext.appendChild( doc.createTextNode(indexes[id].title) );
                                ext.title = moddesc[indexes[id].title] || 'no info';
                                ctrl.type = 'checkbox';
                                ctrl.title = moddesc[indexes[id].title] || 'no info';
                                ctrl.name = 'cbx_' + indexes[id].title;
                                var mstate = indexes[id]['status'];
                                if ( mstate == 1 ) {
                                    ctrl.checked = true;
                                }
                                else if ( mstate == 0 ) {
                                    ctrl.checked = false;
                                }
                                if ( selected_version === 'native' )
                                    ctrl.disabled = 1;
                                stat.appendChild(ctrl);
                            }
                            stat.className = 'cbx-ctrl';
                            row.appendChild(ext);
                            row.appendChild(stat);
                        }
                        exttable_body.appendChild(row);
                    }
                    if ( selected_version === 'native' ) {
                        while( exttable_body.firstChild ) {
                            exttable_body.removeChild(exttable_body.firstChild);
                        }
                        exttable_save.disabled = true;
                        exttable_default.disabled = true;
                    }
                    else {
                        exttable_save.removeAttribute('disabled');
                        exttable_default.removeAttribute('disabled');
                    }
                }

            }
        };
        request.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
        request.send(encodeFormData(request_data));
    };
}(window));
