// # CloudLinux LVE Manager VERSION:0.83
(function(win){
    var doc = win.document,
        vdiv = doc.getElementById('version-table'),
        lvesel = doc.getElementById('cagefs-php-selection'),
        altstatlink = doc.getElementById('alternatives-status-link'),
        altverlink = doc.getElementById('alternatives-version-link'),
        altversel = doc.getElementById('selector-version-select'),
        altmodsave = doc.getElementById('cagefsoptions-submit-apply'),
        altmodreset = doc.getElementById('cagefsoptions-submit-reset'),
        altmoddefault = doc.getElementById('cagefsoptions-submit-default'),
        vbody = doc.getElementById('version-table-body'),
        selverlist = doc.getElementById('selector-versions-list'),
        selverconfirm = doc.getElementById('selector-version-confirmation'),
        sel_dropdown = doc.getElementById('selector-dropdown'),
        lvebody = doc.getElementById('lve-form-body'),
        altctrl = doc.getElementById('selector-version-control'),
        altctrldialog = doc.getElementById('selector-control-dialog'),
        infobox = doc.getElementById('infobox'),
        ie = navigator.userAgent.toLowerCase().indexOf('msie') >= 0 ? true : false,
        uri   = win.location.href.split("?"),
        message_box = doc.getElementById('message-box'),
        removeElem = function(){
            var elid = doc.getElementById('popup');
            if (elid) {
                elid.parentNode.removeChild(elid);
            }
        },
        fadeOutPopup = function(){
            var timeout = 32,
                opacity = 9,
                popup = doc.getElementById('popup'),
                fading = window.setInterval(countDown, timeout);
            function countDown(){
                if ( popup ) {
                    popup.style.opacity = '0.' + opacity;
                    opacity--;
                    if ( opacity < 0 ) {
                        window.clearInterval(fading);
                        removeElem();
                    }
                }
            }
        },
        findLeftOffset = function(obj) {
            var curleft = 0;
            if(obj.offsetParent) {
                while (1) {
                    curleft += obj.offsetLeft;
                    if ( !obj.offsetParent )
                        break;
                    obj = obj.offsetParent;
                }
            }
            else if(obj.x) {
                curleft += obj.x;
            }
            return curleft;
        },
        findTopOffset = function(obj){
            var curtop = 0;
            if(obj.offsetParent) {
                while (1) {
                    curtop += obj.offsetTop;
                    if ( !obj.offsetParent )
                        break;
                    obj = obj.offsetParent;
                }
            }
            else if (obj.y) {
                curtop += obj.y;
            }
            return curtop;
        };

    if (!win.getComputedStyle) {
        win.getComputedStyle = function(el, pseudo) {
            this.el = el;
            this.getPropertyValue = function(prop) {
                var re = /(\-([a-z]){1})/g;
                if (prop == 'float') prop = 'styleFloat';
                if (re.test(prop)) {
                    prop = prop.replace(re, function () {
                        return arguments[2].toUpperCase();
                    });
                }
                return el.currentStyle[prop] ? el.currentStyle[prop] : null;
            }
            return this;
        }
    }

    function displayIt(type, msg){
        var body = doc.getElementsByTagName('body')[0],
            msgbox = doc.createElement('div'),
            msgelem = doc.createTextNode(msg),
            leftOffset = findLeftOffset(message_box),
            topOffset = findTopOffset(message_box),
            scrollOffset = (win.pageYOffset ? win.pageYOffset : 0),
            pageWidth = (ie ? win.getComputedStyle(message_box).getPropertyValue('width') : win.getComputedStyle(message_box).width),
            maxLen = 0;
        pageWidth = (pageWidth == 'auto' ? 751 : parseInt(pageWidth));
        msg_array = msg.split('\n').filter(function(x){return /^\w+/.test(x)}).map(function(x){return x.replace(/(?:ERROR|WARN):/g,"");});
        removeElem();
        msgbox.setAttribute('id','popup');
        msgbox.style.fontWeight = "bold";
        msgbox.style.position = "absolute";
        msgbox.style.boxShadow = "0 3px 6px #3F3F3F";
        msgbox.style.top = (topOffset + scrollOffset + 32) + 'px';
        msgbox.style.height = (1.2 * msg_array.length + 1.2) + 'em';
        msgbox.style.zIndex = 99999;
        if ( type == 'error' ) {
            msgbox.style.color = "#F00";
            msgbox.style.backgroundColor = "#FFEFEF";
            msgbox.style.border = "1px solid #F00";
        }
        else if ( type == 'warn' ) {
            msgbox.style.color = "#FF8002";
            msgbox.style.backgroundColor = "#FFF7EF";
            msgbox.style.border = "1px solid #FF8002";
        }
        else if ( type == 'info' ) {
            msgbox.style.color = "#1E7F2B";
            msgbox.style.backgroundColor = "#F1FFEF";
            msgbox.style.border = "1px solid #1E7F2B";
        }
        for ( var i in msg_array ) {
            if ( typeof(msg_array[i]) != 'string' )
                continue;
            if ( msg_array[i].length > maxLen )
                maxLen = msg_array[i].length;
            var d = doc.createElement('div'),
                ds = doc.createTextNode(msg_array[i]);
            d.appendChild(ds);
            d.style.margin = '.28em 0 0 2em';
            msgbox.appendChild(d); 
        }
        var stringLen = Math.ceil(maxLen * 8) + 64,
            boxOffset = (pageWidth - stringLen) / 2;

        msgbox.style.left = (leftOffset + boxOffset) + 'px';
        msgbox.style.width = stringLen + 'px';
        message_box.appendChild(msgbox);
        setTimeout(fadeOutPopup, 2000);
    }

    if ( infobox ) {
        var mess = infobox.firstChild.nodeValue;
        displayIt('warn', mess);
    }

    message_box.onclick = function(){
        while ( message_box.firstChild ) {
            message_box.removeChild(message_box.firstChild);
        }
    };
    altstatlink.onclick = function(e){
        var status = this.firstChild.data === 'enabled' ? 1 : 0,
            new_status = (status ? 'disabled' : 'enabled');
        if ( confirm('Are you sure you want to ' + (status ? 'disable' : 'enable') + ' PHP Selector?') ) {
            var request = new XMLHttpRequest();
            request.open("GET", uri[0]+"?cgiaction=selectorhelper&helperaction=toggleselector&altsetstatus=" + new_status);
            request.onreadystatechange = function(){
                if ( request.readyState === 4 && request.status === 200 ) {
                    var request_type = request.getResponseHeader("Content-Type");
                    if ( request_type === 'application/json' ) {
                        var data = ie ? json_parse(request.responseText) : JSON.parse(request.responseText);
                        if ( data['status'] === 'OK' ) {
                            altstatlink.firstChild.data = new_status;
                        }
                    }
                }
            };
            request.send(null);
        }
    };
    altverlink.onclick = function(e){
        altctrl.style.display = 'none';
        altctrldialog.style.display = 'table-cell';
    };
    doc.getElementById('selector-version-send-button').onclick = function(){
        var version = altversel.options[altversel.selectedIndex].firstChild.nodeValue,
            url = uri[0]+"?cgiaction=selectorhelper&helperaction=setselectorversion&altversion="+version,
            request = new XMLHttpRequest();
        request.open("GET",url);
            request.onreadystatechange = function(){
                if ( request.readyState === 4 && request.status === 200 ) {
                    var request_type = request.getResponseHeader("Content-Type");
                    if ( request_type === 'application/json' ) {
                        var data = ie ? json_parse(request.responseText) : JSON.parse(request.responseText);
                        if ( data['status'] === 'OK' ) {
                            altverlink.firstChild.nodeValue = version;
                            altctrldialog.style.display = 'none';
                            altctrl.style.display = 'table-cell';
                        }
                    }
                }
            };
        request.send(null);
    };
    doc.getElementById('selector-version-cancel-button').onclick = function(){
        altctrl.style.display = 'table-cell';
        altctrldialog.style.display = 'none';
    };
    selverlist.onclick = function(e){
        if ( e.target.className.indexOf('selector-version') == 0 ) {
            var tgt = e.target,
                version = tgt.firstChild.nodeValue,
                action = tgt.className.indexOf('enabled') > 0 ? 'disable' : 'enable';
            if ( altverlink.firstChild.nodeValue == version && action == 'disable' ) {
                displayIt('warn', "You cannot disable version currently set as default. Change default and try again.");
                return false;
            }
            var decision = confirm("Do you really want to "+action+" "+version+" version?");
            if ( decision ) {
                var request = new XMLHttpRequest();
                request.open("GET",uri[0]+"?cgiaction=selectorhelper&helperaction=selectorversiontoggle&altversion="+version+'&altaction='+action);
                request.onreadystatechange = function(){
                    if ( request.readyState === 4 && request.status === 200 ) {
                        var request_type = request.getResponseHeader("Content-Type");
                        if ( request_type === 'application/json' ) {
                            var data = ie ? json_parse(request.responseText) : JSON.parse(request.responseText);
                            if ( data['status'] === 'OK' ) {
                                tgt.className = 'selector-version-'+action+'d';
                                tgt.title = 'version '+action+'d';
                                tgt.style.color = action == 'enable' ? '#014D5F' : '#7BA4AD';
                                var options = doc.getElementById('selector-version-select').options;
                                for ( var i in options ) {
                                    if ( ! options[i].firstChild ) continue;
                                    if ( options[i].firstChild.nodeValue == version ) {
                                        options[i].disabled = action == 'enable' ? false : true;
                                    }
                                }
                            }
                        }
                    }
                };
                request.send(null);
            }
        }
        e.preventDefault();
        e.stopPropagation();
    };
    altmodsave.onclick = function(e){
        var checkbox_list = vbody.getElementsByTagName('input'),
            check_selected = [];
        for ( var i in checkbox_list ) {
            if ( checkbox_list[i].name !== undefined && checkbox_list[i].name.indexOf('cbx_') == 0 && !checkbox_list[i].disabled && checkbox_list[i].checked ) {
                check_selected.push(checkbox_list[i].name.substring(4));
            }
        }
        var request = new XMLHttpRequest();
        request.open("GET", uri[0]+"?cgiaction=selectorhelper&helperaction=saveselectormodules&selectormoduleset="+check_selected.join(',')+"&altversion="+lvesel.options[lvesel.selectedIndex].firstChild.nodeValue);
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var request_type = request.getResponseHeader("Content-Type");
                if ( request_type === 'application/json' ) {
                    var data = ie ? json_parse(request.responseText) : JSON.parse(request.responseText);
                    if ( data['status'] === 'OK' ) {
                        displayIt('info', 'module set saved');
                    }
                    else if ( data['status'] === 'WARN' ) {
                        if ( 'data' in data ) {
                            var extarray = data['data'].split(';');
                            for ( var i in extarray ) {
                                if ( typeof extarray[i] != 'string' )
                                    continue;
                                var extitem = extarray[i].split(':'),
                                    extname = 'cbx_' + extitem[0];
                                doc.forms.lveselectorform[extname].checked = (extitem[1] == '1' ? true : false);
                            }
                        }
                        if ( 'msg' in data )
                            displayIt('warn', data['msg']);
                    }
                    else if ( data['status'] === 'ERROR' ) {
                        if ( 'msg' in data )
                            displayIt('error', data['msg']);
                        else
                            displayIt('error','An error occured while saving modules');
                    }
                }
            }
        };
        request.send(null);
    };
    altmodreset.onclick = function(e){
        var request = new XMLHttpRequest(),
            sel_val = lvesel.value;
        request.open("GET", uri[0]+"?cgiaction=selectorhelper&helperaction=resettodefaults&lveversion=" + sel_val);
        request.onreadystatechange = function(){
            var indexes = [];
            if ( request.readyState === 4 && request.status === 200 ) {
                var request_type = request.getResponseHeader("Content-Type");
                if ( request_type === 'application/json' ) {
                    var data = ie ? json_parse(request.responseText) : JSON.parse(request.responseText);
                    if ( data !== undefined ) {
                        var data_dict = {},
                            checkbox_list = vbody.getElementsByTagName('input');
                        for ( var i in data ){
                            data_dict[data[i].title] = data[i].status;
                        }
                        for ( var i in checkbox_list ) {
                            if ( checkbox_list[i].name !== undefined && checkbox_list[i].name.indexOf('cbx_') == 0 ) {
                                var mstate = data_dict[checkbox_list[i].name.substring(4)];
                                if ( mstate == 1 ) {
                                    checkbox_list[i].checked = true;
                                    checkbox_list[i].disabled = false;
                                }
                                else if ( mstate == -1 ) {
                                    checkbox_list[i].checked = true;
                                    checkbox_list[i].disabled = true;
                                }
                                else if ( mstate == 0 ) {
                                    checkbox_list[i].checked = false;
                                    checkbox_list[i].disabled = false;
                                }
                            }
                        }
                    }
                }
            }
        };
        request.send(null);
    };
    altmoddefault.onclick = function(e){
        var request = new XMLHttpRequest(),
            sel_val = lvesel.value;
        request.open("GET", uri[0]+"?cgiaction=selectorhelper&helperaction=resettocpanelbuiltin");
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var request_type = request.getResponseHeader("Content-Type");
                if ( request_type === 'application/json' ) {
                    var data = ie ? json_parse(request.responseText) : JSON.parse(request.responseText);
                    if ( data !== undefined ) {
                        var data_dict = {},
                            checkbox_list = vbody.getElementsByTagName('input');
                        for ( var i in data ){
                            data_dict[ 'cbx_'+data[i]['title'] ] = true;
                        }
                        for ( var i in checkbox_list ) {
                            if ( checkbox_list[i].name in data_dict ) {
                                checkbox_list[i].checked = true
                            }
                            else {
                                if ( !checkbox_list[i].disabled ) {
                                    checkbox_list[i].checked = false;
                                }
                            }
                        }
                    }
                }
            }
        };
        request.send(null);
    };
    lvesel.onchange = function(e){
        var request = new XMLHttpRequest(),
            sel_val = lvesel.options[lvesel.selectedIndex].firstChild.nodeValue,
            moddesc = {},
            resource = "?cgiaction=selectorhelper&helperaction=selectormodchange&altversion="+sel_val;

        for ( var i in desc_data )
            moddesc[ desc_data[i].title ] = desc_data[i].description;

        request.open("GET", uri[0]+resource);
        request.onreadystatechange = function(){
            var indexes = [];
            if ( request.readyState === 4 && request.status === 200 ) {
                var request_type = request.getResponseHeader("Content-Type");
                if ( request_type === 'application/json' ) {
                    var data = ie ? json_parse(request.responseText) : JSON.parse(request.responseText);
                    if ( data !== undefined ) {
                        while ( vbody.firstChild ) {
                            vbody.removeChild(vbody.firstChild);
                        }
                    }
                    for ( var i in data ){
                        if ( data[i].title === undefined ) continue;
                        indexes.push(data[i]);
                    }
                    var rownum = Math.floor( indexes.length / 5 );
                    if ( indexes.length % 5 != 0 ) {
                        rownum += 1;
                    }
                    for ( var r=1; r<=rownum; r++ ) {
                        var row = doc.createElement('tr');
                        for ( var c=0; c<5; c++ ) {
                            var ext  = doc.createElement('td'),
                                stat = doc.createElement('td'),
                                id = (rownum * c + r - 1);
                            if ( indexes[id] ) {
                                var ctrl = doc.createElement('input');
                                ext.appendChild( doc.createTextNode(indexes[id].title) );
                                ext.title = moddesc[indexes[id].title] || 'no info';
                                ctrl.type = 'checkbox';
                                ctrl.title = moddesc[indexes[id].title] || 'no info';
                                ctrl.name = 'cbx_' + indexes[id].title;
                                var mstate = indexes[id]['status'];
                                if ( mstate == 1 ) {
                                    ctrl.checked = true;
                                    ctrl.disabled = false;
                                }
                                else if ( mstate == -1 ) {
                                    ext.style.fontStyle = 'italic';
                                    ctrl.checked = true;
                                    ctrl.disabled = true;
                                }
                                else if ( mstate == 0 ) {
                                    ctrl.checked = false;
                                    ctrl.disabled = false;
                                }
                                if ( sel_val === 'native' )
                                    ctrl.disabled=1;
                                if ( id['disabled'] )
                                    ctrl.disabled=1;
                                stat.appendChild(ctrl);
                            }
                            stat.className = 'cbx-ctrl';
                            row.appendChild(ext);
                            row.appendChild(stat);
                        }
                        vbody.appendChild(row);
                    }

                    if ( sel_val === 'native' ) {
                        altmodsave.disabled = 1;
                        altmodreset.disabled = 1;
                        altmoddefault.disabled = 1;
                    }
                    else {
                        altmodsave.removeAttribute('disabled');
                        altmodreset.removeAttribute('disabled');
                        altmoddefault.removeAttribute('disabled');
                    }
                }
            }
        };
        request.send(null);
    };

}(window));
