// # CloudLinux LVE Manager VERSION:0.83
(function(win){
    var doc     = win.document,
        headitems   = doc.getElementById("lve-table-head")
                         .getElementsByTagName("td"),
        tbody       = doc.getElementById("lve-table-body"),
        col2array   = function(collection){
            var nodes = [];
            for ( var i=0; i<collection.length; i++ ) {
                nodes.push(collection[i]);
            }
            return nodes;
        },
        ie          = navigator.userAgent.toLowerCase().indexOf('msie') >= 0 ? true : false,
        trows       = col2array(tbody.getElementsByTagName("tr"));

        for ( var h in headitems ) {
            if ( headitems[h].className === undefined || headitems[h].className.indexOf('lve-sortable') < 0 ) continue;
            headitems[h].onclick = function(e){
                var findSortKey,
                    dir = 0,
                    colindex = 0,
                    tgt = ie ? win.event.srcElement : e.target,
                    pSib = tgt,
                    i,
                    tClassName;

                while ( pSib.previousElementSibling ) {
                    pSib = pSib.previousElementSibling;
                    colindex += 1;
                }

                if ( tgt.className.indexOf('lve-non-sorted') >= 0 ) {
                    for ( var hi in headitems ) {
                        if ( headitems[hi].className === undefined || headitems[hi].className.indexOf('lve-sortable') < 0 ) continue;
                        tClassName = headitems[hi].className;
                        tClassName = tClassName.replace('lve-sorted-asc',"");
                        tClassName = tClassName.replace('lve-sorted-desc',"");
                        if ( tClassName.indexOf('lve-non-sorted') < 0 )
                            tClassName += 'lve-non-sorted';
                        headitems[hi].className = tClassName;
                    }
                    tClassName = tgt.className;
                    tClassName = tClassName.replace('lve-non-sorted',"");
                    tClassName += 'lve-sorted-desc';
                    tgt.className = tClassName;
                    dir = -1;
                }
                else if ( tgt.className.indexOf('lve-sorted-asc') >= 0 ) {
                    tClassName = tgt.className;
                    tClassName = tClassName.replace('lve-sorted-asc',"");
                    tClassName += 'lve-sorted-desc';
                    tgt.className = tClassName;
                    dir = -1;
                }
                else if ( tgt.className.indexOf('lve-sorted-desc') >= 0 ) {
                    tClassName = tgt.className;
                    tClassName = tClassName.replace('lve-sorted-desc',"");
                    tClassName += 'lve-sorted-asc';
                    tgt.className = tClassName;
                    dir = 1;
                }
                if ( tgt.className.indexOf('alpha') >= 0 ) {
                    findSortKey = function(cellitem){
                        var ct = cellitem.firstChild.nodeValue;
                        return ct.toUpperCase();
                    };
                }
                else if ( tgt.className.indexOf('num') >= 0 ) {
                    findSortKey = function(cellitem){
                        var ct = cellitem.firstChild.nodeValue;
                        return isNaN(ct) ? 0 : parseInt(ct);
                    };
                }
                else if ( tgt.className.indexOf('date') >= 0 ) {
                    findSortKey = function(cellitem){
                        var stripZeroes = function(val){
                           if ( ( val.length > 1 ) && ( val.substr(0,1) == "0" ) ) {
                               return val.substr(1);
                           }
                           else {
                               return val;
                           }
                        };
                        var ct  = cellitem.firstChild.nodeValue,
                            d   = new Date(),
                            year= d.getFullYear(),
                            parts = ct.match(/(\\d+)-(\\d+)\\s(\\d+):(\\d+)/) || [],
                            month = stripZeroes( isNaN(parts[1]) ? 0 : parseInt(parts[1],10) - 1 ),
                            day   = stripZeroes( isNaN(parts[2]) ? 0 : parseInt(parts[2],10) ),
                            hour  = stripZeroes( isNaN(parts[3]) ? 0 : parseInt(parts[3],10) ),
                            min   = stripZeroes( isNaN(parts[4]) ? 0 : parseInt(parts[4],10) );
                        return parseInt(( Date.UTC( year, month, day, hour,min,0 ) / 1000.0 ),10);
                    };
                }
                for ( i=0; i<trows.length; i++ ) {
                    trows[i].sortKey = findSortKey(trows[i].getElementsByTagName("td")[colindex]);
                }
                trows.sort(function(a,b){
                    if(a.sortKey > b.sortKey) return dir == 1 ? -1 : 1;
                    if(a.sortKey < b.sortKey) return dir == 1 ? 1 : -1;
                    return 0;
                });

                while(tbody.firstChild)
                    tbody.removeChild(tbody.firstChild);
                
                for ( i=0; i<trows.length; i++ ) {
                    var oddity = i % 2 ? 'odd' : 'even';
                    var rowclass = trows[i].className;
                    trows[i].className = rowclass.replace(/(?:odd|even)/,oddity);
                    tbody.appendChild(trows[i]);
                    trows[i].sortKey = null;
                }
            };
        }
}(window));
