#!/bin/sh
eval 'if [ -x /usr/local/cpanel/3rdparty/bin/perl ]; then exec /usr/local/cpanel/3rdparty/bin/perl -x -- $0 ${1+"$@"}; else exec /usr/bin/perl -x -- $0 ${1+"$@"};fi'
if 0;
#!/usr/bin/perl
# CloudLinux - whostmgr/docroot/cgi/CloudLinux.cgi Copyright(c) 2010 CloudLinux, Inc.
#                                                                All rights Reserved.
#                                                           http://www.cloudlinux.com
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# CloudLinux LVE Manager VERSION:0.83

BEGIN { unshift @INC, '/usr/local/cpanel'; }

use strict;
use Whostmgr::ACLS          ();
use Whostmgr::HTMLInterface ();
use Cpanel::Encoder::Tiny   ();
use Cpanel::Form            ();

Whostmgr::ACLS::init_acls();

my %FORM      = Cpanel::Form::parseform();
my $cgiaction = $FORM{'cgiaction'} || 'default';
my $theme     = Whostmgr::Theme::gettheme();
my $self      = 'CloudLinux.cgi';

my %dispatchTable = (
    lvetop             => \&LVEtop,
    lveset             => \&LVEset,
    lveedit            => \&LVEedit,
    lvereset           => \&LVEreset,
    lvestat            => \&LVEstat,
    lvehistory         => \&LVEhistory,
    lvepacklist        => \&listPackages,
    lvepackedit        => \&editPackage,
    lvechart           => \&showChart,
    makechart          => \&makechart,
    lveoptions         => \&lveoptions,
    selectoropts       => \&show_PHPselector,
    selectorhelper     => \&PHP_selector_helper,
    jsonhandler        => \&JSONhandler,
    cagefsmodsave      => \&cagefsmodsave,
    cagefsmoddefault   => \&cagefsmoddefault,
    cagefsmodsel       => \&cagefsmodselect,
    cagefsaltenable    => \&cagefsaltenable,
    cagefsaltver       => \&cagefsaltver,
    cagefsaltvertoggle => \&cagefsaltvertoggle,
    cagefsverselect    => \&cagefsverselect,
    default            => \&LVEtop,
);

wrapper($cgiaction);

sub wrapper {
    my $action = shift;
    my %args = ( action => $action );
    $args{key} = $FORM{key} if exists $FORM{key};
    my $result = resolve(%args);
    if ($result) {
        $action = 'default' unless exists $dispatchTable{$action};
        $dispatchTable{$action}->();
    }
    else {
        print_message()
    }
}

sub resolve {
    my %args = @_;
    my @params = ('/usr/bin/cldetect');
    if (exists $args{action} and $args{action} eq 'clrecheck') {
        push @params, '--update-license';
        Cpanel::SafeRun::Errors::saferunallerrors(@params);
    }
    elsif (exists $args{key}) {
        push @params, qq#--update-new-key "$args{key}"#;
        Cpanel::SafeRun::Errors::saferunallerrors(@params);
    }
    push @params, '--check-license';
    my $result = Cpanel::SafeRun::Errors::saferunallerrors(@params);
    chomp $result;
    if ($result eq 'OK') {
        return 1;
    }
    return 0;
}

sub print_message {
    my @params = (
        '/usr/bin/cldetect',
        '--no-valid-license-screen',
    );
    my $result = Cpanel::SafeRun::Errors::saferunallerrors(@params);
    chomp $result;
    my $recheck_link = qq#<a href=$self?cgiaction=clrecheck>check again</a>#;
    $result =~ s/%RE-CHECK%/$recheck_link/;
    sendWHMHeader();
    print qq#<form action="$self" method="POST">#,
          $result,
          q#</form>#;
    sendWHMFooter();
}

sub sendWHMHeader {
    print "Content-type: text/html\n\n";

    Whostmgr::HTMLInterface::starthtml( undef, undef, addStyle() );
    Whostmgr::HTMLInterface::defheader( 'LVE Manager', '/images/CloudLinux_logo.png', '/cgi/CloudLinux.cgi' );
    # Check privileges
    if ( !Whostmgr::ACLS::hasroot() ) {
        print qq{<div align="center"><h1>Permission denied</h1></div></body></html>};
        exit;
    }
    print qq{<div id="lve-main">};
}

sub sendWHMFooter {
    print "</div></body></html>\n";
}


sub LVEtop {
    my ( $timer, $reload ) = ( $FORM{timer}, $FORM{reload} );

    $timer ||= 3;
    $reload ||= 'no';
    my $data = get_current_state($timer);
    my $start =<<EOL;
<div id="lve-body">
<form id="reloadform" method="POST" action="$self">
<div>
<select id="delay-dropdown-list" title="refresh interval in seconds">
<option value="0">--</option>
<option value="1">1</option>
<option value="2">2</option>
<option value="3">3</option>
<option value="4">4</option>
<option value="5">5</option>
<option value="10">10</option>
<option value="15">15</option>
<option value="30">30</option>
<option value="60">60</option>
</select>
<input type="button" id="start-button" value="enable"/>
<input type="button" id="stop-button" value="disable"/>
<input type="text" id="refreshing" value="0" readonly="readonly" size="12"/>
<input type="button" id="refresh-button" value="refresh page"/>
</div>
<div id="toparea">
<table id="toptable">
<tbody id="topbody">
EOL

    my $end =<<EOL;
</tbody>
</table>
</div>
</form>
</div><!-- end of lve-body -->
<script type="text/javascript">
var passed_timer = $timer;
</script>
<script type="text/javascript" src="/3rdparty/cloudlinux/jsonparse.js"></script>
<script type="text/javascript" src="/3rdparty/cloudlinux/lvetop.js"></script>
EOL
    if ( $reload eq 'yes' ) {
        if ( Whostmgr::ACLS::hasroot() ) {
            send_JSON($data);
        }
        else {
            send_JSON({ status => 'ERROR', message => 'Operation not permitted' });
        }
    }
    else {
        sendWHMHeader();
        printLinks('usage');
        print $start;
		my $header = shift @{ $data };
		print '<tr>';
		for my $col ( @{ $header } ) {
			print qq#<td class="topheader">$col</td>#;
		}
		print '</tr>';
		my $count = 1;
        for my $row ( @{ $data } ) {
			my $class = $count % 2 ? 'odd' : 'even';
			print qq#<tr class="$class">#;
			for my $col ( @{ $row } ) {
				print "<td>$col</td>";
			}
			print "</tr>";
			$count += 1;
		}
        print $end;
        sendWHMFooter();
    }
}

sub LVEset {

    sendWHMHeader();
    printLinks('settings');

    print <<END;
<div id="lve-body">
<div id="lve-list">
END
    my $data = get_cpanel_info('users');
    my $quota = process_quotas();
    for my $key ( keys %{ $data } ) {
        $data->{$key}->{INODES}
            = join(q{|}, $quota->{$key}->{inodes_soft}, $quota->{$key}->{inodes_hard})
    }
    print_simple_table({data=>$data, users=>getpassdb(), domains=>getUserDomains()});

    print <<END;
</div></div>
<script type="text/javascript" src="/3rdparty/cloudlinux/lvetablesort.js"></script>
<script type="text/javascript" src="/3rdparty/cloudlinux/lvetablefilter.js"></script>
END
    sendWHMFooter();
}

sub listPackages {
    sendWHMHeader();
    printLinks('packlist');
    my $data   = get_cpanel_info('packages');
    my $quota = process_quotas(packlist=>1);
    for my $key ( keys %{ $data } ) {
        my $k = $key eq 'VE_DEFAULT' ? 'default' : $key;
        $data->{$key}->{INODES}
            = join(q{|}, $quota->{$k}->{inodes_soft}, $quota->{$k}->{inodes_hard})
    }
    print <<END;
<div id="lve-body">
<div id="lve-list">
<div class="checkbox">
<label for="toggle-resellers">Show resellers packages</label>
<input id="toggle-resellers" type="checkbox" checked="checked"/>
</div>
END
    print_simple_table({data=>$data});

    print <<END;
</div></div>
<script type="text/javascript" src="/3rdparty/cloudlinux/lvetablesort.js"></script>
<script type="text/javascript" src="/3rdparty/cloudlinux/packagehide.js"></script>
END
    sendWHMFooter();

}

sub print_simple_table {

    my ( $args ) = @_;
    my %titles = (
        CPU  => 'CPU Limit',
        NCPU  => 'Number of CPUs',
        EP   => 'maxEntryProc limit',
        NPROC   => 'Number of processes limit',
        lMEM  => 'Memory Limit',
        PMEM => 'Physical Memory Limit',
        VMEM => 'Virtual Memory Limit',
        IO   => 'I/O Limit',
        INODES => 'Inodes quota limits'
    );
    my $list = $args->{data};
    my $users = $args->{users};
    my $domains = $args->{domains};

    print <<END;
<table id="lve-table">
<thead id="lve-table-head">
<tr class="lower">
END
    if ( $users and $domains ) {
        print <<END;
<td class="lve-sortable num lve-sorted-desc" title="LVE ID">LVE id</td>
<td class="lve-sortable alpha lve-non-sorted" title="Username">Username</td>
<td class="lve-sortable alpha lve-non-sorted" title="Domain">Domain</td>
END
    }
    else {
        print q#<td class="lve-sortable alpha lve-sorted-desc" title="Package">Package ID</td>#;
    }

    my @headers = qw/ CPU NCPU VMEM PMEM EP NPROC IO INODES/;

    # print Settings tab table headers
    for my $i ( @headers ) {

        my $item = index($i,'MEM') >= 0
            ? qq#$i&nbsp;(MB)#
            : index($i,'IO') >= 0
                ? qq#$i&nbsp;(kBps)#
                : $i
            ;
        my $title = $titles{$i} || q{};
        print qq{<td class="lve-sortable num lve-non-sorted" title="$title">$item</td>};
    }
    
    if ( $users and $domains ) {
        print <<END;
<td class="lve-sortable alpha lve-non-sorted" title="Package">PACKAGE</td>
<td colspan="3" class="filter">
<input type="text" id="instant-filter" title="filter table values at place"/>
</td>
END
    }
    else {
        print q#<td></td>#;
    }

    print q#</tr></thead><tbody id="lve-table-body">#;

    # Count for oddity caclucation
    my $count = 0;

    # Iterating through rows
    for my $id ( sort { $a <=> $b } keys %{ $list } ) {

        my $align_class = 'rhs';
        my $oddity = $count % 2 ? 'odd' : 'even';

        if ( $users and $domains ) {    # 'Settings' tab
            if ( $id == 0 ) {           # Default
                print qq#<tr class="$oddity">#
                    . q#<td class="first-cell rhs" title="LVE ID">DEFAULT</td>#
                    . q#<td class="chs" title="Username">&nbsp;-&nbsp;</td>#
                    . q#<td class="chs" title="Domain">&nbsp;-&nbsp;</td>#;
            }
            else {
                my $domain = $domains->{ $users->{$id} } || '&nbsp;-&nbsp;';
                print qq#<tr class="$oddity">#
                    . qq#<td class="first-cell rhs" title="LVE ID">$id</td>#
                    . qq#<td class="lhs" title="Username">$users->{$id}</td>#
                    . qq#<td class="lhs" title="Domain">$domain</td>#;
            }
        }
        else {  # 'Packages' tab
            if ( $id eq 'VE_DEFAULT' ) {
                print qq#<tr class="$oddity"><td class="first-cell lhs" title="Package">DEFAULT</td>#;    
            }
            else {
                print qq#<tr class="$oddity"><td class="first-cell lhs" title="Package">$id</td>#;
            }
        }
        my @query_items = ();
        # Iterate through columns of the row
        for my $col ( @headers ) {

            $align_class = 'rhs';

            # output value
            my $val = $list->{$id}->{$col};

            # Removing last 'M' (concerns memory units like '1024M')
            #$val =~ s/^(\d+)\S?$/$1/;
            $val =~ s/[A-Za-z]+//g;

            # Highlight class. Off by default
            my $highlight_class = q{};

            # '*' in value means difference in values. Remove '*'
            # and set highlight class on
            if ( substr( $val, 0, 1 ) eq '*' ) {
                $val = substr( $val, 1 );
                $highlight_class=q{ tdh};
                #$title .= " Value differs from defaults";
            }
            
            push @query_items, lc($col) . qq#=$val#;

            if ( $col =~ /(?:mem|proc)/i and $val == 0 ) {
                $align_class = 'chs';
                $val = '-';
            }
            if ($col =~ /inodes/i) {
                $align_class = 'chs';
                if ($val =~ /(\d+)\|(\d+)/) {
                    my $s = $1 != 0 ? $1 : '-';
                    my $h = $2 != 0 ? $2 : '-';
                    $val = "$s|$h";
                }
            }
            my $title=$titles{$col} || q{};
            print qq#<td class="$align_class$highlight_class" title="$title">$val</td>#;
        }
        
        if ( $users and $domains ) {    # 'Settings' tab
            print qq#<td class="lhs" title="Package">$list->{$id}->{PACKAGE}</td>#;
            # Outputting 'Edit', 'Reset' and 'History' links for the row
            if ( $id == 0 ) { # default
                print qq#<td><a href="$self?cgiaction=lveedit&lveid=default&#
                    . join( q{&}, @query_items )
                    .qq#">Edit</a></td><td></td><td></td>#
                    .qq#</tr>#;
            }
            else {
                my $user = $users->{$id};
                my $domain = $domains->{ $users->{$id} } || q{};
                print qq#<td><a href="$self?cgiaction=lveedit&lveid=$id&#
                    . join( q{&}, @query_items )
                    . qq#&user=$user#
                    . qq#&domain=$domain" #
                    . q#title="Edit LVE's settings">Edit</a></td>#
                    . qq#<td><a href="$self?cgiaction=lvereset&lveid=$id#
                    . qq#&user=$user#
                    . qq#&domain=$domain" #
                    . q#title="Reset LVE's limits to package's defaults">Reset</a></td>#
                    . qq#<td><a href="$self?cgiaction=lvehistory&lveid=$id#
                    . qq#&user=$users->{$id}#
                    . qq#&domain=$domain" #
                    . q#title="View LVE's historical usage and charts">History</a></td>#
                    . q#</tr>#;
            }
        }
        else {  # 'Packages' tab
            if ( $id eq 'VE_DEFAULT' ) {
                print q#<td></td>#;
            }
            else {
                print q#<td title="Edit package's settings">#
                    . qq#<a href="$self?cgiaction=lvepackedit#
                    . qq#&packname=$id&#
                    . join( q{&}, @query_items )
                    . q#">Edit</a></td>#;
            }
        }
        # Update oddity counter      
        $count += 1; 
    }
    print q#</tbody></table></div></div>#;
    sendWHMFooter();
}

# Apply edit form settings
sub LVEedit {
    my ( $lveid, $cpu, $vmem, $ep, $ncpu, $vmemunits, $pmem, $pmemunits, $nproc, $io, $user, $domain )
        = ( $FORM{lveid}, $FORM{cpu}, $FORM{vmem}, $FORM{ep}, $FORM{ncpu}, $FORM{vmemunits}, $FORM{pmem}, $FORM{pmemunits},
            $FORM{nproc}, $FORM{io}, $FORM{user}, $FORM{domain} ); 
    if ( Whostmgr::ACLS::hasroot() ) {
    
        my ( $soft, $hard );
        if ( exists $FORM{inodes} ) {
            ( $soft, $hard ) = split( /\|/, $FORM{inodes} );
        }
        elsif ( exists $FORM{qsoft} and exists $FORM{qhard} ) {
            ( $soft, $hard ) = ( $FORM{qsoft}, $FORM{qhard} );
        }
    
        # 'Apply' button has been clicked. Apply settings and return to 'Settings' tab
        if ( $FORM{'lve-submit-apply'} eq 'Apply' ) {
            my @params = ('/usr/sbin/lvectl', 'set', $lveid );
            my @quota_params = ('/usr/bin/cl-quota', '--user-id='.($lveid eq 'default' ? 0 : $lveid));
            if ( $cpu =~ /^.*?(\d+).*$/) {
                push @params, '--cpu='.$1;
            }
            if ( $vmem =~ /^.*?(\d+).*$/) {
                push @params, '--vmem='.$1.$vmemunits;
            }
            if ( $ep =~ /^.*?(\d+).*$/) {
                push @params, '--maxEntryProcs='.$1;
            }
            if ( $ncpu =~ /^.*?(\d+).*$/) {
                push @params, '--ncpu='.$1;
            }
            if ( $pmem =~ /^.*?(\d+).*$/) {
                push @params, '--pmem='.$1.$pmemunits;
            }
            if ( $nproc =~ /^.*?(\d+).*$/) {
                push @params, '--nproc='.$1;
            }
            if ( $io =~ /^.*?(\d+).*$/) {
                push @params, '--io='.$1;
            }
            
            if ( $soft =~ /(\d+)/ ) {
                push @quota_params, '--soft-limit='.$1;
            }
            if ( $hard =~ /(\d+)/ ) {
                push @quota_params, '--hard-limit='.$1;
            }
            open my $t, '>', '/tmp/clinfo.txt';
            #for my $k ( keys %{ $quota }) {
            print $t "@quota_params\n";
            #}
            close $t;
            Cpanel::SafeRun::Errors::saferunallerrors(@params);
            Cpanel::SafeRun::Errors::saferunallerrors(@quota_params) if @quota_params > 2;
            if ( $lveid eq 'default' ) {
                Cpanel::SafeRun::Errors::saferunallerrors( '/usr/sbin/lvectl', 'apply', 'all' );
                Cpanel::SafeRun::Errors::saferunallerrors( '/etc/init.d/lvectl', 'reload' );
            }
            print "Status: 302 Moved\nLocation: $self?cgiaction=lveset\n\n";
        }
        # 'Cancel' button has been clicked. Return to 'Settings' tab
        elsif ( $FORM{'lve-submit-cancel'} eq 'Cancel' ) {
            print "Status: 302 Moved\nLocation: $self?cgiaction=lveset\n\n";
        }
        # New request. Display 'Edit' form.
        else {
            printEditForm('settings', $lveid, $cpu, $vmem, $ep, $ncpu, $pmem, $nproc, $io, $soft, $hard, $user, $domain);
        }
    }
    else {
        print "Status: 302 Moved\nLocation: $self?cgiaction=lveset\n\n";
    }
}

sub editPackage {
        my ( $package, $cpu, $vmem, $ep, $ncpu, $vmemunits, $pmem, $pmemunits, $nproc, $io )
                = ( $FORM{packname}, $FORM{cpu}, $FORM{vmem}, $FORM{ep}, $FORM{ncpu}, $FORM{vmemunits}, $FORM{pmem}, $FORM{pmemunits}, $FORM{nproc}, $FORM{io});
    
    if ( Whostmgr::ACLS::hasroot() ) {
        my ( $soft, $hard );
        if ( exists $FORM{inodes} ) {
            ( $soft, $hard ) = split( /\|/, $FORM{inodes} );
        }
        elsif ( exists $FORM{qsoft} and exists $FORM{qhard} ) {
            ( $soft, $hard ) = ( $FORM{qsoft}, $FORM{qhard} );
        }
        
        if ( $FORM{'lve-submit-apply'} eq 'Apply' ) {
            my @params = ('/usr/sbin/lvectl', 'package-set', $package );
            my @quota_params = ('/usr/bin/cl-quota', "--package=$package");
            if ( $cpu =~ /^.*?(\d+).*$/) {
                push @params, '--cpu='.$1;
            }
            if ( $vmem =~ /^.*?(\d+).*$/) {
                push @params, '--vmem='.$1.$vmemunits;
            }
            if ( $ep =~ /^.*?(\d+).*$/) {
                push @params, '--maxEntryProcs='.$1;
            }
            if ( $ncpu =~ /^.*?(\d+).*$/) {
                push @params, '--ncpu='.$1;
            }
            if ( $pmem =~ /^.*?(\d+).*$/) {
                push @params, '--pmem='.$1.$pmemunits;
            }
            if ( $nproc =~ /^.*?(\d+).*$/) {
                push @params, '--nproc='.$1;
            }
            if ( $io =~ /^.*?(\d+).*$/) {
                push @params, '--io='.$1;
            }
            
            if ( $soft =~ /(\d+)/ ) {
                push @quota_params, '--soft-limit='.$1;
            }
            if ( $hard =~ /(\d+)/ ) {
                push @quota_params, '--hard-limit='.$1;
            }
            
            
            Cpanel::SafeRun::Errors::saferunallerrors(@params);
            Cpanel::SafeRun::Errors::saferunallerrors(@quota_params) if @quota_params > 2;
            print "Status: 302 Moved\nLocation: $self?cgiaction=lvepacklist\n\n";
        }
        elsif ( $FORM{'lve-submit-cancel'} eq 'Cancel' ) {
            print "Status: 302 Moved\nLocation: $self?cgiaction=lvepacklist\n\n";
        }
        else {
            printEditForm('packages', $package, $cpu, $vmem, $ep, $ncpu, $pmem, $nproc, $io, $soft, $hard);
        }
    }
    else {
        print "Status: 302 Moved\nLocation: $self?cgiaction=lvepacklist\n\n";
    }
}

# reset lve to defaults
sub LVEreset {
    my ( $lveid, $user, $domain ) = ( $FORM{lveid}, $FORM{user}, $FORM{domain} );
    if ( Whostmgr::ACLS::hasroot() ) {

        # 'Reset' has been clicked. Reset and redirect to 'Settings' tab
        if ( $FORM{'lve-submit-delete'} eq 'Reset' ) {
            Cpanel::SafeRun::Errors::saferunallerrors( '/usr/sbin/lvectl', 'delete', $lveid);
            print "Status: 302 Moved\nLocation: $self?cgiaction=lveset\n\n";
        }
        # 'Cancel' has been clicked. Redirect to 'Settings' tab
        elsif ( $FORM{'lve-submit-cancel'} eq 'Cancel' ) {
            print "Status: 302 Moved\nLocation: $self?cgiaction=lveset\n\n";
        }
        # show the form
        else {
            sendWHMHeader();
            printLinks('del');
            my $extended = $user ? $domain ? qq#($user - $domain)# : qq#($user)# : '';
            print <<END;
<div id="lve-body">
<div id="lve-form-masthead">Do you really want to set LVE $lveid $extended to defaults?</div>
<div id="lve-form-body">
<form action="$self" method="GET">
<input type="hidden" name="cgiaction" value="lvereset"/>
<input type="hidden" name="lveid" value="$lveid"/>
<div class="formsubmit">
<input name="lve-submit-delete" type="submit" value="Reset"/>
<input name="lve-submit-cancel" type="submit" value="Cancel"/>
</div>
</form>
</div>
</div>
END
            sendWHMFooter();
        }
    }
    else {
        print "Status: 302 Moved\nLocation: $self?cgiaction=lveset\n\n";
    }
}

sub LVEstat {
    sendWHMHeader();
    printLinks('stats');

    if ( $FORM{'lve-stat-submit'} eq 'Show' ) {
        # display header form with submitted parameters
        LVEStatHeader( action=>$FORM{selstat},
                       tcond=>$FORM{'lve-top-condition'},
                       tlim=>$FORM{'lve-top-limit'},
                       lcond=>$FORM{'lve-limit-condition'},
                       lval=>$FORM{'lve-limit-value'},
                       fcond=>$FORM{'lve-fault-condition'},
                       fthresh=>$FORM{'lve-fault-threshold'},
                       period=>$FORM{'lve-timespan'} );
        
        my $action = $FORM{selstat};
        my @lveinfo = ('/usr/sbin/lveinfo', '--csv');

        if ( $action eq 'lvebytop' ) {
            push @lveinfo, '--order-by='.$FORM{'lve-top-condition'},
                '--limit='.$FORM{'lve-top-limit'}, '--period='.$FORM{'lve-timespan'};
        }
        elsif ( $action eq 'lvebylimit' ) {
            push @lveinfo, '--by-usage='.$FORM{'lve-limit-condition'},
                '--percentage='.$FORM{'lve-limit-value'}, '--period='.$FORM{'lve-timespan'};
        }
        elsif ( $action eq 'lvebyfault' ) {
            push @lveinfo, '--by-fault='.$FORM{'lve-fault-condition'},
                '--threshold='.$FORM{'lve-fault-threshold'}, '--period='.$FORM{'lve-timespan'};
        }
        my $data = Cpanel::SafeRun::Errors::saferunallerrors(@lveinfo);

        # print table
        print_complex_table({ data=>$data, user=>getpassdb(), domain=>getUserDomains() });
    }
    else {
        # display header form
        LVEStatHeader();
    }
    print q#<script type="text/javascript" src="/3rdparty/cloudlinux/lvetablesort.js"></script>#;
    sendWHMFooter();
}

sub LVEhistory {
    my ( $lveid, $user, $domain ) = ( $FORM{lveid}, $FORM{user}, $FORM{domain} );

    sendWHMHeader();
    printLinks('history');
    my $extended = $user ? $domain ? qq#($user - $domain)# : qq#($user)# : '';
    print <<END;
<div id="lve-body">
<div id="lve-form-masthead">History for LVE $lveid $extended</div>
<div id="control-form-div" style="height:48px">
<div class="lhs">&nbsp;</div>
<div class="rhs">
<form id="control-form" action="$self" method="GET">
<input type="hidden" name="cgiaction" value="lvehistory"/>
<input type="hidden" name="lveid" value="$lveid"/>
<label for="lve-timespan">Timeframe:</label>
<select name="lve-timespan">
<option value="10m">Last 10 minutes</option>
<option value="30m">Last 30 minutes</option>
<option value="1h">Last hour</option>
<option value="4h">Last 4 hours</option>
<option value="today">Today</option>
<option value="yesterday">Yesterday</option>
<option value="7d">Last 7 days</option>
<option value="30d">Last 30 days</option>
</select>
<input type="submit" name="lve-history-submit" value="Show"/>
</div>
</form>
</div><!-- end of control-form-div -->
END
    if ( $FORM{'lve-history-submit'} eq 'Show' ) {

        my @params = ('/usr/sbin/lveinfo', '--csv', '--period='.$FORM{'lve-timespan'}, '--id='.$FORM{'lveid'} );
        my $data = Cpanel::SafeRun::Errors::saferunallerrors(@params);
        print <<END;
<div style="text-align:center;margin-bottom:1em;">
<form method="GET" action="$self">
<input type="hidden" name="cgiaction" value="lvechart"/>
<input type="hidden" name="lveid" value="$FORM{lveid}"/>
<input type="hidden" name="period" value="$FORM{'lve-timespan'}"/>
<input type="submit" value="Show chart for selected period"/>
</form>
</div>
END
        print_complex_table({ data=>$data,user=>undef,domain=>undef });
    }
    sendWHMFooter();
}

sub showChart {
    my ( $lveid, $period ) = ( $FORM{lveid}, $FORM{period} );
    sendWHMHeader();
    printLinks('chart');
    print <<END;
<div id="lve-body">
<div id="lve-form-masthead">Chart for LVE $lveid</div>
<img src="${self}?cgiaction=makechart&lveid=$lveid&timeframe=$period">
</div>
END
}

sub makechart {
    my ( $lveid, $period ) = ( $FORM{lveid}, $FORM{timeframe} );
    my @params = ('/usr/sbin/lvechart');
    if ( defined $lveid and $lveid =~ /(\d+)/ ) {
        push @params, "--id=$1";
    }
    if ( defined $period and $period =~ /(today|yesterday|\d+[mhd])/ ) {
        push @params, "--period=$1";
    }
    else {
        push @params, '--period=1d';
    }
    if ( Whostmgr::ACLS::hasroot() and @params == 3) {
        my $out=Cpanel::SafeRun::Errors::saferunallerrors(@params);
        print "Content-type: image/png\n\n";
        print $out; 
    }
    else {
        print "Content-type: text/plain\n\n";
        print "Operation not permitted!";
    }
}


sub print_complex_table {
    my ( $args ) = @_;
    my %titles = (
        ID      => 'LVE Id or username',
        CPU     => 'CPU Usage',
        aCPU    => 'Average CPU usage',
        mCPU    => 'Max CPU usage',
        lCPU    => 'CPU Usage Limit',
        aEP     => 'Average Entry Processes',
        mEP     => 'Max Entry Processes',
        lEP     => 'Entry Processes limit',
        aVMem   => 'Average Virtual Memory Usage',
        mVMem   => 'Max Virtual Memory Usage',
        lVMem   => 'Vrtual Memory Usage Limit',
        vMEM    => 'Virtual Memory Usage',
        pMEM    => 'Physical Memory Usage',
        aPMem   => 'Average Physical Memory Usage',
        mPMem   => 'Max Physical Memory Usage',
        lPMem   => 'Physical Memory Usage Limit',
        aNproc  => 'Average Number of processes',
        mNproc  => 'Max Number of processes',
        lNproc  => 'Number of processes Limit',
        aIO     => 'Average I/O Usage',
        mIO     => 'Max I/O Usage',
        lIO     => 'I/O Limit',
        IO      => 'I/O Statistics',
        EP      => 'Entry Processes',
        nPROC   => 'Processes',
        VMemF   => 'Out of Virtual Memory Faults',
        PMemF   => 'Out of Physical Memory Faults',
        EPf     => 'Entry Processes faults',
        NprocF  => 'Processes faults',
    );
    my $user = $args->{user};
    my $domain = $args->{domain};
    my $data = $args->{data};
   
    my ( $header_string, $rest ) = split(/\n/, $data, 2);
    my @header_items = split /,/, $header_string;

    my @parameters = qw/CPU vMEM pMEM EP nPROC IO VMemF PMemF EPf NprocF/;
    my %simple_columns = (VMemF => 'lVMem', PMemF => 'lPMem', EPf => 'lEP', NprocF => 'lNproc');
    my %column_groups = (
        CPU   => {aCPU   =>{v=>'a',n=>0},mCPU   =>{v=>'m',n=>1},lCPU   =>{v=>'l',n=>2}},
        EP    => {aEP    =>{v=>'a',n=>0},mEP    =>{v=>'m',n=>1},lEP    =>{v=>'l',n=>2}},
        vMEM  => {aVMem  =>{v=>'a',n=>0},mVMem  =>{v=>'m',n=>1},lVMem  =>{v=>'l',n=>2}},
        pMEM  => {aPMem  =>{v=>'a',n=>0},mPMem  =>{v=>'m',n=>1},lPMem  =>{v=>'l',n=>2}},
        nPROC => {aNproc =>{v=>'a',n=>0},mNproc =>{v=>'m',n=>1},lNproc =>{v=>'l',n=>2}},
        IO    => {aIO    =>{v=>'a',n=>0},mIO    =>{v=>'m',n=>1},lIO    =>{v=>'l',n=>2}},
    );
    my @unlimited;
    my %limit_counters = ( lCPU=>0, lEP=>0, lVMem=>0, lPMem=>0, lNproc=>0, lIO=>0 );
    my @table_data;       
    for my $i ( split( /\n/, $rest ) ) {
        my @row = split /,/, $i;
        my $row_data = { map { $header_items[$_] => $row[$_] } 0 .. $#header_items };
        push @table_data, $row_data;
        # increment values for limits columns
        for my $k ( keys %limit_counters ) {
            $limit_counters{$k} += $row_data->{$k};
        }
    }

    unless ( @table_data ) {
        print <<END;
<div style="text-align:center;color:#014D5F;font-weight:bold;width:100%;">
<span>There is no data to display</span>
</div></div>
END
        return;
    }


    print <<END;
<div id="lve-list">
<table id="lve-table">
<thead id="lve-table-head">
<tr class="upper">
<td></td>
<td></td>
<td></td>
END
    # print top header row
    for my $col ( @parameters ) {
        if ( exists $column_groups{$col} ) { # parameter is comprised of 3 columns (a, m, l)
            # no limits set for the parameter (group of columns) so skip it
            if ( grep { exists $column_groups{$col}->{$_} and $limit_counters{$_} == 0 } keys %limit_counters ) {
                push @unlimited, $col;
                next;
            }
            my $colspan = keys %{ $column_groups{$col} };   # numbers of columns in group to specify in 'colspan' parameter
            my $val = index($col,'MEM') >= 0                # if column contains 'MEM'
                ? qq#$col&nbsp;(MB)#                        # append '(MB)'
                : index($col, 'IO') >= 0                    # else if contains 'IO'
                    ? qq#$col&nbsp(kBps)#                   # append '(kBps)'
                    : $col                                  # else append nothing
                ;
            my $title = $titles{$col} || q{};
            print qq#<td class="filled" colspan="$colspan" title="$title">$val</td>#;
        }
        else {  # parameter contains no subcolumns
            # skip faults columns if corresponding parameter is unlimited
            next if $limit_counters{ $simple_columns{$col} } == 0;
            print q#<td></td>#;
        }
    }
    if ( $user ) {
        print <<END;
<td></td></tr>
<tr class="lower"><td class="lve-sortable num lve-sorted-desc" title="">$header_items[0]</td>
<td class="lve-sortable alpha lve-non-sorted" title="Username">Username</td>
<td class="lve-sortable alpha lve-non-sorted" title="Domain">Domain</td>
END
    }
    else {
        print <<END;
</tr><tr class="lower">
<td class="lve-sortable alpha lve-non-sorted" title="Username">From</td>
<td class="lve-sortable alpha lve-non-sorted" title="Domain">To</td>
END

    }
    # print bottom header row
    for my $col ( @parameters ) {   
        if ( exists $column_groups{$col} ) {    # parameter is comprised of 3 columns (a, m, l)
            # no limits set for the parameter (group of columns) so skip it
            next if ( grep { exists $column_groups{$col}->{$_} and $limit_counters{$_} == 0 } keys %limit_counters );
            # iterating over sub columns (a,m,l). They should be sorted.
            for my $sub_col ( sort { $column_groups{$col}->{$a}->{n} <=> $column_groups{$col}->{$b}->{n} } keys %{ $column_groups{$col} } ) {
                my $title = $titles{$sub_col} || q{};
                print qq#<td class="lve-sortable num lve-non-sorted" title="$title">$column_groups{$col}->{$sub_col}->{v}</td>#;
            }
        }
        else {  # parameter contains no subcolumns
            # skip faults columns if corresponding parameter is unlimited
            next if $limit_counters{ $simple_columns{$col} } == 0;
            my $title = $titles{$col} || q{};
            print qq#<td class="lve-sortable num lve-non-sorted" title="$title">$col</td>#;
        }
    }
    
    # placeholder for chart links
    print q#<td></td># if $user;

    print <<END;
</tr></thead>
<tbody id="lve-table-body">
END
        my $count = 0;

        # print the body of the table
        # iterate through table rows
        for my $row ( @table_data ) {
            my $oddity = $count % 2 ? 'odd' : 'even';
            if ( exists $row->{ID} ) {
                my $dns = $domain->{ $user->{ $row->{ID} } } || '&nbsp;-&nbsp;';
                my $user = $user->{ $row->{ID} } || '&nbsp;-&nbsp;';
                print qq#<tr class="$oddity">#
                    . qq#<td class="first-cell rhs" title="ID">$row->{ID}</td>#
                    . qq#<td class="lhs" title="Username">$user</td>#
                    . qq#<td class="lhs" title="Domain">$dns</td>#;
            }
            else {
                print qq#<tr class="$oddity">#
                    . qq#<td class="first-cell lhs" title="From">$row->{From}</td>#
                    . qq#<td class="lhs" title="To">$row->{To}</td>#;
            }
            for my $col ( @parameters ) {    # iterate through parameter columns
                if ( exists $column_groups{$col} ) {
                    # skip if unlimited (column == 0)
                    next if ( grep { exists $column_groups{$col}->{$_} and $limit_counters{$_} == 0 } keys %limit_counters );
                    for my $sub_col ( sort { $column_groups{$col}->{$a}->{n} <=> $column_groups{$col}->{$b}->{n} } keys %{ $column_groups{$col} } ) {
                        # memory values should be divided to display in megabytes
                        my $val = ( index($col,'MEM') >= 0 ) ? int($row->{$sub_col} / 1048576) : $row->{$sub_col};
                        my $class = 'rhs';
                        if ( $col =~ /(?:mem|proc)/i and $val == 0) {
                            $class = 'chs';
                            $val = '-';
                        }
                        my $title = $titles{$sub_col} || q{};
                        print qq#<td class="$class" title="$title">$val</td>#;
                    }
                }
                else {
                    my $title = $titles{$col} || q{};
                    next if $limit_counters{ $simple_columns{$col} } == 0;
                    print qq#<td class="rhs" title="$title">$row->{$col}</td>#;
                }
            }
            if ( exists $row->{ID} ) {
                print qq#<td title="Statistics chart"><a href="$self?cgiaction=lvechart#
                    . qq#&lveid=$row->{ID}#
                    . qq#&period=$FORM{'lve-timespan'}">Chart</a></td>#;
            }
            print q#</tr>#;
            $count += 1;
        }
        print q#</tbody></table>#;
        if ( @unlimited ) {
            print q#<ul class="lve-unlim-list">#;
            for my $i ( @unlimited ) {
                print qq#<li>$i&nbsp;-&nbsp;unlimited</li>#;
            }
            print q#</ul>#;
        }
        print q#</div></div>#;

}

sub lveoptions {
    if ( Whostmgr::ACLS::hasroot() ) {
        if ( $FORM{'lveoptions-submit-apply'} eq 'Apply' ) {
            my %data = (
                lve_hideuserstat => $FORM{'lve-hideuserstat'} eq 'on' ? 1 : 0,
                lve_showinodeusage => $FORM{'lve-showinodeusage'} eq 'on' ? 1 : 0,
            );
            if ( $FORM{'lve-resetinodelimits'} eq 'on' ) {
                my @params = ('/usr/bin/cl-quota', '--sync');
                Cpanel::SafeRun::Errors::saferunallerrors(@params);
            }
            my $ret = process_cpanel_config(%data);
            if ( ref $ret ) {
                unless ( exists $ret->{lve_hideuserstat} ) {
                    process_dynamicui_conf($data{lve_hideuserstat});
                }   
                print "Status: 302 Moved\nLocation: $self?cgiaction=lveset\n\n";
            }
            else {
                my $message = qq#An error occurred while saving '/var/cpanel/cpanel.config':<br/>#
                              .qq#$ret.<br/>#
                              .qq#Please contact <a href="https://helpdesk.cloudlinux.com" target="_blank">support</a>#;
                lveoptions_form($message);
            }
        }
        elsif ( $FORM{'lveoptions-submit-cancel'} eq 'Cancel' ) {
            print "Status: 302 Moved\nLocation: $self?cgiaction=lveset\n\n";
        }
        else {
            print_options_form();
        }
    }
    else {
        print "Status: 302 Moved\nLocation: $self?cgiaction=lveset\n\n";
    }
}

sub print_options_form {
    my ( $message ) = @_;

    sendWHMHeader();
    printLinks('options');

    if ( defined $message ) {
        print <<END;
<div id="lve-body">
<div>$message</div>
</div>
END
    }
    else {
        my $rv = process_cpanel_config(
            lve_hideuserstat => undef,
            lve_showinodeusage => undef
        );
        my $ru_stat = $rv->{lve_hideuserstat}
            ? q#checked="checked"#
            : q{};
        my $quota_stat = $rv->{lve_showinodeusage}
            ? q#checked="checked"#
            : q{};
        print <<END;
<div id="lve-body">
<div id="lve-form-body">
<form action="$self" method="GET">
<input type="hidden" name="cgiaction" value="lveoptions"/>
<table style="width:100%">
<tr>
<td style="text-align:right"><label for="lve-hideuserstat">Hide LVE end user usage statistics</label></td>
<td style="text-align:left;min-width:32%"><input name="lve-hideuserstat" type="checkbox" $ru_stat/></td>
</tr>
<tr>
<td style="text-align:right"><label for="lve-showinodeusage">Show end-user inodes usage</label></td>
<td style="text-align:left;min-width:32%"><input name="lve-showinodeusage" type="checkbox" $quota_stat/></td>
</tr>
<tr>
<td style="text-align:right"><label for="lve-resetinodelimits">Reset inode limits</label></td>
<td style="text-align:left;min-width:32%"><input name="lve-resetinodelimits" type="checkbox"></td>
</tr>
</table>
<div class="formsubmit">
<input name="lveoptions-submit-apply" type="submit" value="Apply"/>
<input name="lveoptions-submit-cancel" type="submit" value="Cancel"/>
</div>
</form>
</div>
</div>
END
    }
    sendWHMFooter();
}

sub show_PHPselector {
    sendWHMHeader();
    my $selector_summary = process_selector_data();
    my $msg;
    $msg = delete $selector_summary->{msg} if exists $selector_summary->{msg};
    my ( $def_version ) = grep { exists $selector_summary->{$_}->{default} } keys %{ $selector_summary };
    my $extensions_summary = process_extensions($def_version);
        my $status = process_cpanel_config('lve_hide_selector'=>undef)->{lve_hide_selector}
        ? 'disabled'
        : 'enabled';
    my $desc = eval `/usr/bin/cl-phpextdesc --perl`;
    $desc = [] unless ref $desc eq 'ARRAY';
    my $colnum = 5;
    my %desc_data = map { $_->{title} => $_->{description} } @{ $desc };
    printLinks('selector');

    print <<END;
<div id="lve-body">
<div id="message-box"></div>
<div id="lve-form-body">
<div id="selector-common-control">
<div>
<span>Selector is:</span>
<a href="#" style="font-weight:bold;" id="selector-status-link">$status</a>
</div>
<div>
<span>Default PHP version:</span>
<a href="#" style="font-weight:bold;" id="selector-version-link">$def_version</a>
<span id="selector-version-control" style="display:none;">
<select id="selector-version-select">
END

    for my $k ( sort keys %{ $selector_summary } ) {
        if ( exists $selector_summary->{$k}->{default} ) {
            print qq#<option selected="selected">$k</option>#;
        }
        elsif ( exists $selector_summary->{$k}->{disabled} ) {
            print qq#<option disabled="disabled">$k</option>#;
        }
        else {
            print qq#<option>$k</option>#;
        }
    }

    my $version_list = join( q{,&nbsp;},
        map {
            $_ eq $def_version
                ? qq{<span style="font-weight:bold;color:#014D5F;text-decoration:none" title="version set as default">$_</span>}
                : exists $selector_summary->{$_}->{disabled}
                    ? qq{<a style="color:#7BA4AD;" title="disabled version" class="selector-version-disabled" href="#">$_</a>}
                    : qq{<a style="color:#014D5F;" title="enabled version" class="selector-version-enabled" href="#">$_</a>}
        } sort keys %{ $selector_summary } );

print <<END;
</select>
<input id="selector-version-save" type="button" value="Save"/>
<input id="selector-version-cancel" type="button" value="Cancel"/>
</span>
</div>
<div>
Supported versions:&nbsp;<span id="supported-versions-list">$version_list</span>
</div>
</div>
<div style="text-align:center;">
<form id="extensions-selector-form" name="extensions-selector-form" action="$self" method="POST">
<table style="border-collapse:collapse;">
<thead>
<tr><td colspan="$colnum">
<label for="selector-modules-select">Choose default modules for: </label>
<select id="selector-modules-select" name="selector-modules-select">
END
    for my $k ( sort keys %{ $selector_summary } ) {
        if ( exists $selector_summary->{$k}->{default} ) {
            print qq#<option selected="selected">$k</option>#;
        }
        else {
            print qq#<option>$k</option>#;
        }
    }
    print "</select></div>";
    print <<END;
</td>
</tr>
</thead>
<tbody id="selector-extensions-table">
END

    my $disabled = $def_version eq 'native' ? q#disabled="disabled"# : q{};
    my @keys = sort keys %{ $extensions_summary };
    my $rownum = int( scalar @keys / $colnum );
    $rownum += 1 if scalar @keys % $colnum;
    for ( my $r=1; $r<=$rownum; $r++ ) {
        my $border_color = $r == $rownum ? '#444444' : '#D8D8D8';
        print qq#<tr style="border-bottom:1px solid $border_color">#;
        for ( my $c=0; $c<$colnum; $c++ ) {
            my $cellid = ($rownum * $c + $r - 1);
            if ( $cellid < @keys ) {
                my $m = $keys[$cellid];
                my $status = $extensions_summary->{$m} == 1
                    ? q#checked="checked"#
                    : $extensions_summary->{$m} == -1
                        ? q#checked="checked" disabled="disabled"#
                        : q{}
                    ;
                my $style = $extensions_summary->{$m} == -1
                    ? qq#style="padding:.4em 0 0 0;text-align:left;font-style:italic"#
                    : qq#style="padding:.4em 0 0 0;text-align:left;"#
                    ;
                my $item_title = ($desc_data{$m} or 'no info');
                print qq#<td $style title="$item_title">$m</td><td style="padding:0 1.6em 0 .8em;"><input name="cbx_$m" title="$item_title" type="checkbox" $status/></td>#;
            }
            else {
                print qq#<td></td><td></td>#;
            }
        }
        print q#</tr>#;
    }

    print <<END;
</tbody>
</table>
<div class="formsubmit">
<input id="selector-table-save" type="button" title="Save checked modules" value="Save" $disabled/>
<input id="selector-table-reset" type="button" title="Uncheck all but defaults. Click &quot;Save&quot; to apply" value="Reset" $disabled/>
<input id="selector-table-default" type="button" title="Uncheck all but panel builtins. Click &quot;Save&quot; to apply" value="Panel Defaults" $disabled/>
</div>
</form>
</div>
</div>
</div>
</div>
END
    if ( $msg ) {
        chomp $msg;
        print qq#<div id="infobox" style="display:none;">$msg</div>#;
    }
    print q#<script type="text/javascript">#;
    print q#desc_data=# . Cpanel::SafeRun::Errors::saferunallerrors('/usr/bin/cl-phpextdesc', '--json');
    print q#</script>#;
    print <<END;
<script type="text/javascript">
var uri               = (window.location.href.split("?"))[0],
    selector_ext_form = document.getElementById('extensions-selector-form'),
    message_box       = document.getElementById('message-box'),
    ie                = navigator.userAgent.toLowerCase().indexOf('msie') >= 0 ? true : false,
    moddesc           = {},
    selector_styles   = {
        "row_border_bottom":"1px solid #D8D8D8",
        "label_cell_left_padding":".4em 0 0 0",
        "label_cell_text_align":"left",
        "label_cell_minwidth":"100px",
        "end_row_border_bottom":"1px solid #444444",
        "ctrl_cell_padding":"0 1.6em 0 .8em",
        "default_version_underline":"none",
        "default_version_color":"#014D5F",
        "default_version_fontweight":"bold",
        "non_default_version_fontweight":"bold",
        "non_default_disabled_version_fontweight":"bold",
        "non_default_version_color":"#014D5F",
        "non_default_disabled_version_color":"#7BA4AD"
    };
if ( typeof(desc_data) !== 'undefined' ) {
    for ( var i in desc_data ) {
        moddesc[ desc_data[i]['title'] ] = desc_data[i]['description'];
    }
}
</script>
END
    print q#<script type="text/javascript" src="/3rdparty/cloudlinux/jsonparse.js"></script>#;
    print q#<script type="text/javascript" src="/3rdparty/cloudlinux/cl-message-handler.js"></script>#;
    print q#<script type="text/javascript" src="/3rdparty/cloudlinux/cl-selector-toggle.js"></script>#;
    print q#<script type="text/javascript" src="/3rdparty/cloudlinux/extension-selector.js"></script>#;
    sendWHMFooter();
}

sub PHP_selector_helper {
    my $action = $FORM{action};
    my $data;
    if ( Whostmgr::ACLS::hasroot() ) {
        if ( $action eq 'extreset' ) {
            my $ext_list = process_extensions( $FORM{version} );
            $data= { data => [ map +{ title=>$_, status=>$ext_list->{$_} },
                     sort keys %{ $ext_list } ] };
        }
        elsif ( $action eq 'extbuiltin' ) {
            my $ext_list = process_extensions('native');
            $data= { data => [ map +{ title=>$_, status=>$ext_list->{$_} },
                keys %{ $ext_list } ] };
        }
        elsif ( $action eq 'statetoggle' ) {
            my $status = $FORM{'setstate'};
            handle_enduser_config($status);
            process_cpanel_config('lve_hide_selector' => $status eq 'disabled' ? 1 : 0);
            $data = {status=>'OK'};
        }
        elsif ( $action eq 'versionsave' ) {
            my $version = $FORM{'version'};
            Cpanel::SafeRun::Errors::saferunallerrors('/usr/bin/cl-selector', '--interpreter=php', "--version=$version");
            $data = {status=>'OK'};
        }
        elsif ( $action eq 'versiontoggle' ) {
            my ( $version, $state ) = ( $FORM{'version'}, $FORM{'state'} );
            my $action_arg = $state eq 'disabled' ? "--set-enabled=$version" : "--set-disabled=$version";
            open my $t,'>', '/tmp/phpinfo.txt';
            print $t $action_arg;
            close $t;
            my $r = Cpanel::SafeRun::Errors::saferunallerrors('/usr/bin/cl-selector','--interpreter=php', $action_arg);
            $data = {status=>'OK'};
        }
        elsif ( $action eq 'extsave' ) {
            my ( $version, $moduleset ) = ( $FORM{'version'}, $FORM{'extset'} );
    
            if ( $version ne 'native' ) {
                my $return_string = Cpanel::SafeRun::Errors::saferunallerrors(
                    '/usr/bin/cl-selector',
                    '--interpreter=php',
                    "--version=$version",
                    "--update-default-extensions=$moduleset"
                );
                if ( $return_string ) { # we have messages
                    if ( $return_string =~ /ERROR:(.*)$/ ) {
                        $data = { status => 'ERROR',message => $1 };
                    }
                    else {
                        my %extlist_hash;
                        for my $line ( split( /\n/, $return_string ) ) {
                            # get extension itself, what's happened to it and conflicts or dependencies
                            my ( $ext, $action, $arg ) = $line =~ /WARN:(\S+)\s(\S+).*?(?:\((.*)\))?\.?$/;
    
                            # if extension was skipped (for conflict), remove it
                            $extlist_hash{$ext} = 0 if $action eq 'skipped';
        
                            # if extension was enabled (for dependency), add it
                            $extlist_hash{$ext} = 1 if $action eq 'enabled';
        
                            # if extension was left (for dependency), add it
                            $extlist_hash{$ext} = 1 if $action eq 'left';
                        }
                        $return_string =~ s/WARN://gm;
                        chomp $return_string;
                        $data = {
                            status => 'WARN',
                            message => [ split( /\n/, $return_string ) ],
                            data=>[ map +{ title=>$_, status=>$extlist_hash{$_} }, keys %extlist_hash],
                        };
                    }
                }
                else {
                    $data = {status=>'OK'};
                }
            }
        }
        elsif ( $action eq 'extlist' ) {
            my $version = $FORM{'version'};
            my $ext_list = process_extensions( $version );
            $data = { data => [ map +{ title=>$_, status=>$ext_list->{$_} },
                     sort keys %{ $ext_list } ] };
        }
    }
    else {
        $data = { status => 'ERROR', message => 'Operation not permitted' };
    }
    send_JSON($data);
}


sub JSONhandler {
    my $action = $FORM{handler};
    my %dispatchTable = (
        paneluserslimits => sub {
            return [
                '/usr/sbin/lvectl',
                'paneluserslimits',
            ];
        },
        list => sub {
            return [
                '/usr/sbin/lvectl',
                'list',
            ];
        },
        'list-user' => sub {
            return [
                '/usr/sbin/lvectl',
                'list-user',
            ];
        },
        set => sub {
            my ( $lveid, $cpu, $vmem, $ep, $ncpu, $pmem, $nproc, $io )
                = @FORM{ 'lveid', 'cpu', 'vmem', 'maxentryprocs', 'ncpu', 'pmem', 'nproc', 'io' };
            my @params = ('/usr/sbin/lvectl', 'set' );
            
            if ( defined $lveid and $lveid =~ /^.*?(\d+).*$/ ) {
                push @params, $1;
            }
            if ( defined $cpu and $cpu =~ /^.*?(\d+).*$/) {
                push @params, '--cpu='.$1;
            }
            if ( defined $vmem and $vmem =~ /^.*?(\d+)([mgMG])?.*$/) {
                my $unit = defined $2 ? uc($2) : 'M';
                push @params, '--vmem='.$1.$unit;
            }
            if ( defined $ep and $ep =~ /^.*?(\d+).*$/) {
                push @params, '--maxEntryProcs='.$1;
            }
            if ( defined $ncpu and $ncpu =~ /^.*?(\d+).*$/) {
                push @params, '--ncpu='.$1;
            }
            if ( defined $pmem and $pmem =~ /^.*?(\d+)([mgMG])?.*$/) {
                my $unit = defined $2 ? uc($2) : 'M';
                push @params, '--pmem='.$1.$unit;
            }
            if ( defined $nproc and $nproc =~ /^.*?(\d+).*$/) {
                push @params, '--nproc='.$1;
            }
            if ( defined $io and $io =~ /^.*?(\d+).*$/) {
                push @params, '--io='.$1;
            }
            return \@params;
        },
        'set-user' => sub {
            my ( $username, $cpu, $vmem, $ep, $ncpu, $pmem, $nproc, $io )
                = @FORM{ 'username', 'cpu', 'vmem', 'maxentryprocs', 'ncpu', 'pmem', 'nproc', 'io' };
            my @params = ('/usr/sbin/lvectl', 'set-user' );
            
            if ( defined $username and $username =~ /^.*?([A-Za-z][A-Za-z0-9\-_\.]*).*$/ ) {
                push @params, $1;
            }
            if ( defined $cpu and $cpu =~ /^.*?(\d+).*$/) {
                push @params, '--cpu='.$1;
            }
            if ( defined $vmem and $vmem =~ /^.*?(\d+)([mgMG])?.*$/) {
                my $unit = defined $2 ? uc($2) : 'M';
                push @params, '--vmem='.$1.$unit;
            }
            if ( defined $ep and $ep =~ /^.*?(\d+).*$/) {
                push @params, '--maxEntryProcs='.$1;
            }
            if ( defined $ncpu and $ncpu =~ /^.*?(\d+).*$/) {
                push @params, '--ncpu='.$1;
            }
            if ( defined $pmem and $pmem =~ /^.*?(\d+)([mgMG])?.*$/) {
                my $unit = defined $2 ? uc($2) : 'M';
                push @params, '--pmem='.$1.$unit;
            }
            if ( defined $nproc and $nproc =~ /^.*?(\d+).*$/) {
                push @params, '--nproc='.$1;
            }
            if ( defined $io and $io =~ /^.*?(\d+).*$/) {
                push @params, '--io='.$1;
            }
            return \@params;
        },
        'package-list' => sub {
            return [
                '/usr/sbin/lvectl',
                'package-list',
            ];
        },
        'package-set' => sub {
            my ( $package, $cpu, $vmem, $ep, $ncpu, $pmem, $nproc, $io )
                = @FORM{ 'package', 'cpu', 'vmem', 'maxentryprocs', 'ncpu', 'pmem', 'nproc', 'io' };
            my @params = ('/usr/sbin/lvectl', 'package-set' );

            if ( defined $package ) {
                push @params, $package;
            }
            if ( defined $cpu and $cpu =~ /^.*?(\d+).*$/) {
                push @params, '--cpu='.$1;
            }
            if ( defined $vmem and $vmem =~ /^.*?(\d+)([mgMG])?.*$/) {
                my $unit = defined $2 ? uc($2) : 'M';
                push @params, '--vmem='.$1.$unit;
            }
            if ( defined $ep and $ep =~ /^.*?(\d+).*$/) {
                push @params, '--maxEntryProcs='.$1;
            }
            if ( defined $ncpu and $ncpu =~ /^.*?(\d+).*$/) {
                push @params, '--ncpu='.$1;
            }
            if ( defined $pmem and $pmem =~ /^.*?(\d+)([mgMG])?.*$/) {
                my $unit = defined $2 ? uc($2) : 'M';
                push @params, '--pmem='.$1.$unit;
            }
            if ( defined $nproc and $nproc =~ /^.*?(\d+).*$/) {
                push @params, '--nproc='.$1;
            }
            if ( defined $io and $io =~ /^.*?(\d+).*$/) {
                push @params, '--io='.$1;
            }
            return \@params;
        },
        'package-delete' => sub {
            my $package = $FORM{package};
            my @params = (
                '/usr/sbin/lvectl',
                'package-delete',
            );
            if ( defined $package ) {
                push @params, $package;
            }
            return \@params;
        },
        limit => sub {
            my ( $lveid, $pid ) = @FORM{ 'lveid', 'pid' };
            my @params = ('/usr/sbin/lvectl', 'limit' );
        
            if ( defined $pid and $pid =~ /^.*?(\d+).*$/) {
                push @params, $1;
            }
            if ( defined $lveid and $lveid =~ /^.*?(\d+).*$/ ) {
                push @params, $1;
            }
            return \@params;
        },
        release => sub {
            my $pid = $FORM{pid};
            my @params = (
                '/usr/sbin/lvectl',
                'release',
            );
            if ( defined $pid and $pid =~ /^.*?(\d+).*$/ ) {
                push @params, $1;
            }
            return \@params;
        },
        delete => sub {
            my $lveid = $FORM{lveid};
            my @params = (
                '/usr/sbin/lvectl',
                'delete',
            );
            if ( defined $lveid and $lveid =~ /^.*?(\d+).*$/ ) {
                push @params, $1;
            }
            return \@params;
        },
        'delete-user' => sub {
            my $username = $FORM{username};
            my @params = (
                '/usr/sbin/lvectl',
                'delete-user',
            );
            if ( defined $username and $username =~ /^.*?([A-Za-z][A-Za-z0-9\-_\.]*).*$/ ) {
                push @params, $1;
            }
            return \@params;
        },
        limits => sub {
            my $lveid = $FORM{lveid};
            my @params = (
                '/usr/sbin/lvectl',
                'limits',
            );
            if ( defined $lveid and $lveid =~ /^.*?(\d+|all).*$/ ) {
                push @params, $1;
            }
            return \@params;
        },
        apply => sub {
            my $lveid = $FORM{lveid};
            my @params = (
                '/usr/sbin/lvectl',
                'apply',
            );
            if ( defined $lveid and $lveid =~ /^.*?(\d+).*$/ ) {
                push @params, $1;
            }
            return \@params;
        },
        destroy => sub {
            my $lveid = $FORM{lveid};
            my @params = (
                '/usr/sbin/lvectl',
                'destroy',
            );
            if ( defined $lveid and $lveid =~ /^.*?(\d+).*$/ ) {
                push @params, $1;
            }
            return \@params;
        },
        'apply-all' => sub {
            return [
                '/usr/sbin/lvectl',
                'apply',
                'all',
            ];
        },
        'destroy-all' => sub {
            return [
                '/usr/sbin/lvectl',
                'destroy',
                'all',
            ];
        },
        'lve-version' => sub {
            return [
                '/usr/sbin/lvectl',
                '--lve-version',
            ];
        },
    );
    if ( Whostmgr::ACLS::hasroot() ) {
        my @params = @{ $dispatchTable{$action}->() || $dispatchTable{list}->() };
        push @params, '--json';
        print "Content-type: application/json\n\n";
        print Cpanel::SafeRun::Errors::saferunallerrors( @params );
    }
    else {
        send_JSON( { status => 'ERROR', message => 'Operation not permitted' } );
    }
}

# =============== UTILITY FUNCTIONS ======================

sub process_selector_data {
    my ( $args ) = @_;
    my %data;
    my $s = Cpanel::SafeRun::Errors::saferunallerrors('/usr/bin/cl-selector','--summary=php');
    if ( $s =~ s/(WARN:.*?\n)// ) {
        $data{msg} = substr($1,5);
    }
    elsif ( $s =~ s/(ERROR:.*?\n)// ) {
        $data{msg} = substr($1,6);
        return \%data;
    }
    for my $r ( split /\n/, $s ) {
        my ( $version, $state, $default ) = split( /\s+/, $r );
        $data{$version} = {};
        $data{$version}->{disabled} = 1 if $state ne 'e';
        $data{$version}->{default} = 1 if $default eq 'd';
    }
    return \%data;
}

sub process_extensions {
    my ( $version, $extensions ) = @_;
    my %data;
    my $s = Cpanel::SafeRun::Errors::saferunallerrors('/usr/bin/cl-selector','--list-extensions=php', qq#--version=$version#);
    for my $r ( split /\n/, $s ) {
        my ( $state, $extension ) = split( /\s+/, $r );
        $data{$extension}
            = $state eq '+'
                ? 1
                : $state eq '~'
                    ? -1
                    : 0
                ;
    }
    return \%data;
}

# send JSON data
sub send_JSON {
    require Data::Dumper;
    my ( $data ) = @_;
    print "Content-type: application/json\n\n";
    my $d = Data::Dumper->new( [ $data ] );
    print $d->Terse(1)->Pair(':')->Useqq(1)->Deepcopy(1)->Dump;
}

# Print menu
sub printLinks {
    my $cur_page = shift;
    my @items = (
        {
            usage       => {
                title   => 'Current Usage',
                href    => qq{<a href="$self?cgiaction=lvetop">Current Usage</a>},
            },
        },
        {
            settings    => {
                title   => 'Settings',
                href    => qq{<a href="$self?cgiaction=lveset">Settings</a>},
            },
        },
        {
            stats       => {
                title   => 'Statistics',
                href    => qq{<a href="$self?cgiaction=lvestat">Statistics</a>},
            },
        },
        {
            packlist    => {
                title   => 'Packages',
                href    => qq{<a href="$self?cgiaction=lvepacklist">Packages</a>},
            },
        },
        {
            options     => {
                title   => 'Options',
                href    => qq{<a href="$self?cgiaction=lveoptions">Options</a>},
            },
        }
	);

	if ( Cpanel::SafeRun::Errors::saferunallerrors('rpm','-q','cagefs') =~ /^cagefs/ ) {
		push @items,
		{
            selector      => {
                title   => 'Selector',
                href    => qq{<a href="$self?cgiaction=selectoropts">Selector</a>},
            },
        };
    }

	my @stubs = (
        {
            edit        => 'Edit LVE',
        },
        {
            del         => 'Delete LVE',
        },
        {
            history     => 'LVE History',
        },
        {
            packedit    => 'Edit Package',
        },
        {
            chart       => 'Chart',
        },

    );

	push @items, @stubs;

    print <<END;
<div id="lve-nav">
<div  id="lve-nav-list">
<div class="lve-nav-list-stub"></div>
END

    for my $i ( @items ) {
        for my $k ( keys %{ $i } ) {
            my $val = ref $i->{$k} eq 'HASH'
                ? $i->{$k}->{ $k eq $cur_page ? 'title' : 'href' }
                : $i->{$k}
                ;
            my $class = $k eq $cur_page ? 'lve-nav-list-item-selected' : 'lve-nav-list-item';
            next if $k ne $cur_page and ref $i->{$k} ne 'HASH';

            print <<END;
<div class="$class">
$val
</div><!-- end of lve-nav-list-item -->
END
        }
    }

    print <<END;
</div><!-- end of lve-nav-list -->
</div><!-- end of lve-nav -->
END

}

# Returns lveps output
sub get_current_state {
    my ( $timer ) = @_;
	my @out;
    open my $p, "/usr/sbin/lveps -d -c $timer|" or return [];
    my ( $header_string ) = <$p> =~ /^\s*(\S.*\S)\s*$/;
    my @header = split( /\s+/, $header_string );
    push @out, [ grep { $_ ne 'PNO' } @header ];
    while ( my $line = <$p> ) {
    	chomp $line;
    	my ( $stripped_line ) = $line =~ /^\s*(\S.*\S)\s*$/;
    	my @tokens = split( /\s+/, $stripped_line );
    	my @stack;
    	for my $i ( reverse @header ) {
    	    if ( $i eq 'PNO') {
    	        pop @tokens;
    	    }
    	    else {
    		    unshift @stack, pop @tokens;
    		}
   		}
        if ( @tokens ) {
        	$stack[0] = join( q{ }, @tokens ) . q{ } . $stack[0];
        }
        push @out, \@stack;
   }
   close $p;
   return \@out;
}

sub getUserDomains {
    my $path = "/var/cpanel/users";
    my %domains;

    opendir my $dir, $path or return {};
    while ( my $f = readdir $dir ) {
        next if $f eq '.' or $f eq '..';
        open my $fh, "$path/$f" or next;
        my ( $dns ) = do { local $/; <$fh>; } =~ /DNS=(\S+)/g;
        $domains{$f} = $dns if $dns;
        close $fh;
    }
    closedir $dir;
    return \%domains;
}

sub getpassdb {
    my %passdb;
    while ( my @entry = getpwent() ) {
        $passdb{ $entry[2] } = $entry[0];
    }
    return \%passdb;
}

sub get_cpanel_info {
    my ( $param ) = @_;
    my %data;
    if ( $param eq 'users' ) {
        open my $p, '/usr/sbin/lvectl paneluserslimits|' or return;
        my ( $titles_line ) = <$p> =~ /^\s+?(\w.*\w)$/;
        my @titles = split /\s+/, $titles_line;
        while ( my $line = <$p> ) {
            $line =~ s/^\s+?(\S.*\S)$/$1/;
            chomp $line;
            my @v = split /\s+/, $line, scalar @titles;
            $data{$v[0]} = { map { $titles[$_] => $v[$_] } 1 .. $#titles };
        }
        close $p;
    }
    else {
        open my $p, '/usr/sbin/lvectl package-list|' or return;
        my ( $titles_line ) = <$p> =~ /^\s+?(\w.*\w)$/;
        my @titles = reverse split /\s+/, $titles_line;
        while ( my $line = <$p> ) {
            $line =~ s/^\s+?(\S.*\S)\s*$/$1/;
            my @v = split /\s+/, $line;
            my @stack;
            for my $t ( @titles ) {
               push @stack, { title=>$t, value=>pop(@v) };
            }
            my $key = +pop(@stack)->{value};
            $key = join(q{ }, @v) . q{ } . $key if @v;
            $data{$key} = { map { $_->{title} => $_->{value} } @stack };
        }
        close $p;
    }
    return \%data;
}

sub process_quotas {
    my %args = @_;
    my @params = ('/usr/bin/cl-quota', '--csv');
    my %out;
    if (exists $args{user}) {
        push @params, "--user-id=$args{user}";
    }
    if (exists $args{package}) {
        push @params, "--package=$args{package}";
    }
    if (exists $args{hard}) {
        push @params, "--hard-limit=$args{hard}";
    }
    if (exists $args{soft}) {
        push @params, "--soft-limit=$args{soft}";
    }
    if (exists $args{packlist}) {
        push @params, "--package-limits";
    }
    my $rv = Cpanel::SafeRun::Errors::saferunallerrors(@params);
    my ($header, $data) = split(/\n/, $rv, 2);
    my @header = split(/,/, $header);
    for my $line ( split(/\n/, $data) ) {
        chomp $line;
        my @items = split(/,/, $line);
        $out{$items[0]} = { map { $header[$_] => $items[$_] } 1 .. $#header };
    }
    return \%out;
}

sub process_cpanel_config {
    my %args = @_;
    my %data;
    my $config = '/var/cpanel/cpanel.config';
    my @header;
    my $rv = {};
    my $to_write = grep {defined} values %args;
    open my $i, '<', $config or return $!;
    while ( my $line = <$i> ) {
        if ( $line =~ /^(?:#|;|$)/ or index($line, '=') < 0 ) {
            push @header, $line;
            next;
        }
        my ( $key, $val ) = split( /\s*=\s*/, $line, 2 );
        chomp $val;
        $data{$key} = $val;
    }
    close $i;
    return { map { $_ => ($data{$_} || 0) } grep { !defined $args{$_} } keys %args }
        unless $to_write;
    open my $o, '>', $config or return $!;
    for my $i (@header) {
        print $o $i;
    }
    for my $key ( keys %args ) {
        if ( defined $args{$key} ) {
            if ( exists $data{$key} and $data{$key} == $args{$key} ) {
                $rv->{$key} = $args{$key};
            }
            else {
                $data{$key} = $args{$key}
            }
        }
    }
    for my $k (keys %data) {
        print $o "$k=$data{$k}\n";
    }
    close $o;
    return $rv;
}

sub get_themes_list {
    my ( $themes_location ) = @_;
    opendir my $t, $themes_location or return [];
    my @themes;
    for my $d ( readdir $t ) {
        next if $d eq '.' or $d eq '..';
		my $path = join( q{/}, $themes_location, $d );
        next if -l $path;
        next unless -d $path;
        push @themes, $d;
    }
    closedir $t;
    return \@themes;
}

sub process_dynamicui_conf {
    my ( $param ) = @_;
    my $themes_location = q#/usr/local/cpanel/base/frontend#;
    my $themes = get_themes_list($themes_location);
    return unless @{ $themes };
    my @filenames = ( q#dynamicui.conf#, q#dynamicui/dynamicui_enduserlve.conf# );
    for my $theme ( @{ $themes } ) {
        for my $filename ( @filenames ) {
            my $config = join( q{/}, $themes_location, $theme, $filename );
            next unless -e $config;
            open my $f, '+<', $config or next;
            my $found = 0;
            my $pos = tell $f;
            my $string = $param == 1 ? qq/file=>enduserlve,skipobj=>1\n\n/ : qq/#file=>enduserlve,skipobj=>1\n/;
            while ( my $line = <$f> ) {
                chomp $line;
                my $changed = $line =~ s/^#?file=>enduserlve,skipobj=>1$/$string/;
                if ( $changed ) {
                    $found = 1;
                    seek( $f, $pos, 0);
                    print $f "$line\n";
                }
                $pos = tell $f;
            }
            if ( ! $found and $param == 1 ) {
                print $f "\n####Added by lvemanager####\nfile=>enduserlve,skipobj=>1\n\n";
            }
            close $f;
        }
    }
    return 1;
}

sub handle_enduser_config {
    my $status = shift;
    my @filenames = ( 'dynamicui.conf', 'dynamicui/dynamicui_lvephpsel.conf' );
    my $themes_location = q#/usr/local/cpanel/base/frontend#;
    my $themes = get_themes_list($themes_location);
    return unless @{ $themes };
    for my $theme ( @{ $themes } ) {
        for my $filename ( @filenames ) {
            my $config = join( q{/}, $themes_location, $theme, $filename );
            next unless -e $config;
            open my $c, '+<', $config or next;
            my $found = 0;
            my $pos = tell $c;
            my $str = $status eq 'enabled' ? "#file=>lvephpsel,skipobj=>1" : "file=>lvephpsel,skipobj=>1\n";
            while ( my $line = <$c> ) {
                my $changed = $line =~ s/^#?file=>lvephpsel,skipobj=>1/$str/;
                if ( $changed ) {
                    $found = 1;
                    seek $c, $pos, 0;
                    print $c $line;
                }
                $pos = tell $c;
            }
            print $c "\n\n####Added by CageFS plugin####\n$str\n" unless $found;
            close $c;
        }
    }
}

# ============== VERBOSE HTML/CSS FUNCTIONS ================

sub LVEStatHeader {
    my %ivalues = @_;
    print <<END;
<div id="lve-body">
<div id="control-form-div">
<form id="control-form" action="$self" method="GET">
<input type="hidden" name="cgiaction" value="lvestat"/>
<div class="radioboxitem">
<label for="lvebytop">Top LVEs</label>
END
    my $checked = ( $ivalues{action} and $ivalues{action} eq 'lvebytop' ) ? q#checked="checked"# : q{};
    print <<END;
<input type="radio" checked="checked" name="selstat" id="lvebytop" value="lvebytop" $checked/>
<span>by</span>
<select name="lve-top-condition">
END
    my %sel = (
        cpu_max         =>'Max CPU',
        cpu_avg         =>'Average CPU',
        vmem_max        =>'Max VMem',
        vmem_avg        =>'Average VMem',
        pmem_max        =>'Max PMem',
        pmem_avg        =>'Average PMem',
        mep_max         =>'Max EP',
        mep_avg         =>'Average EP',
        nproc_max       =>'Max nProc',
        nproc_avg       =>'Average nProc',
        io_max          =>'Max IO',
        io_avg          =>'Average IO',
        total_vmem_faults=>'VMem Faults',
        total_pmem_faults=>'PMem Faults',
        total_ep_faults=>'Entry Procs Faults',
        total_nproc_faults=>'Processes Faults',
        any_faults      =>'Any Faults',
    );
    for my $k ( sort keys %sel ) {
        my $s = ( $ivalues{tcond} and $ivalues{tcond} eq $k ) ? q# selected="selected"# : q{};
        print qq#<option value="$k"$s>$sel{$k}</option>#;
    }
    %sel = ();
    print <<END;
</select>
<div class="rhs">
<span>Limit:</span>
<select name="lve-top-limit">
END
    for my $i ( 25, 50, 75, 100 ) {
        my $s = ( $ivalues{tlim} and $ivalues{tlim} eq $i ) ? q# selected="selected"# : q{};
        print qq#<option value="$i"$s>$i</option>#;
    }
    print <<END;
</select>
</div><!-- end of rhs -->
</div><!-- end of radioboxitem -->
<div class="radioboxitem">
<label for="lvebylimit">LVEs approaching limit</label>
END
    $checked = ( $ivalues{action} and $ivalues{action} eq 'lvebylimit' ) ? q#checked="checked"# : q{};
    print <<END;
<input type="radio" name="selstat" id="lvebylimit" value="lvebylimit" $checked/>
<span>by</span>
<select name="lve-limit-condition">
END
    %sel = (
        cpu_max         =>'Max CPU',
        cpu_avg         =>'Average CPU',
        vmem_max        =>'Max VMem',
        vmem_avg        =>'Average VMem',
        pmem_max        =>'Max PMem',
        pmem_avg        =>'Average PMem',
        mep_max         =>'Max EP',
        mep_avg         =>'Average EP',
        nproc_max       =>'Max nProc',
        nproc_avg       =>'Average nProc',
        io_max          =>'Max IO',
        io_avg          =>'Average IO',
    );
    for my $k ( sort keys %sel ) {
        my $s = ( $ivalues{lcond} and $ivalues{lcond} eq $k ) ? q# selected="selected"# : q{};
        print qq#<option value="$k"$s>$sel{$k}</option>#;
    }
    %sel = ();
    print <<END;
</select>
<div class="rhs">
<span>Using:</span>
<select name="lve-limit-value">
END
   for my $i ( 50, 75, 90, 95 ) {
        my $s = ( $ivalues{lval} and $ivalues{lval} eq $i ) ? q# selected="selected"# : q{};
        print qq#<option value="$i"$s>$i%</option>#;
    }
    print <<END;
</select>
</div><!-- end of rhs -->
</div><!-- end of radioboxitem -->
<div class="radioboxitem">
<label for="lvebyfault">Fault LVE</label>
END
    $checked = ( $ivalues{action} and $ivalues{action} eq 'lvebyfault' ) ? q#checked="checked"# : q{};
    print <<END;
<input type="radio" name="selstat" id="lvebyfault" value="lvebyfault" $checked/>
<span>by</span>
<select name="lve-fault-condition">
END
    %sel = (
        mep=>'Max Entry Processes Limit',
        vmem=>'Max VMem Limit',
        pmem=>'Max PMem Limit',
        nproc=>'Max Processes Limit',
        any=>'Any Limit',
    );
    for my $k ( sort keys %sel ) {
        my $s = ( $ivalues{fcond} and $ivalues{fcond} eq $k ) ? q# selected="selected"# : q{};
        print qq#<option value="$k"$s>$sel{$k}</option>#;
    }
    %sel = ();
    print <<END;
</select>
<div class="rhs">
<span>Threshold</span>
<select name="lve-fault-threshold">
END
    for my $i ( 1, 10, 50, 100, 1000 ) {
        my $s = ( $ivalues{fthresh} and $ivalues{fthresh} eq $i ) ? q# selected="selected"# : q{};
        print qq#<option value="$i"$s>$i</option>#;
    }
    print <<END;
</select>
</div><!-- end of rhs -->
</div><!-- end of radioboxitem -->
<div class="radioboxitem">
&nbsp;
<div class="rhs">
<span>Timeframe</span>
<select name="lve-timespan">
END
    %sel = (
        '10m'=>'Last 10 minutes',
        '30m'=>'Last 30 minutes',
        '1h'=>'Last hour',
        '4h'=>'Last 4 hours',
        'today'=>'Today',
        'yesterday'=>'Yesterday',
        '7d'=>'Last 7 days',
        '30d'=>'Last 30 days',
    );
    for my $k ( qw/10m 30m 1h 4h today yesterday 7d 30d/ ) {
        my $s = ( $ivalues{period} and $ivalues{period} eq $k ) ? q# selected="selected"# : q{};
        print qq#<option value="$k"$s>$sel{$k}</option>#;
    }
    %sel = ();
    print <<END;
</select>
</div>
</div><!-- end of radioitem -->
<div class="formsubmit">
<input type="submit" name="lve-stat-submit" value="Show"/>
</div>
</form><!-- end of control-form -->
</div><!-- end of control-form-div -->
END
}


sub printEditForm {
    my ( $item, $id, $cpu, $vmem, $ep, $ncpu, $pmem, $nproc, $io, $qsoft, $qhard, $user, $domain ) = @_;
    sendWHMHeader();
    my $lveversion = Cpanel::SafeRun::Errors::saferunallerrors('/usr/sbin/lvectl', '--lve-version');
    $lveversion ||= 6;

    my ( $formname, $formvalue ) = ( 'lveid', 'lveedit' );
    if ( $item eq 'packages' ) {
        ( $formname, $formvalue ) = ( 'packname', 'lvepackedit' );
    }
    my $form_title = $item eq 'settings' ? 'edit' : 'packedit';
    printLinks($form_title);

    print <<END;
<div id="lve-body">
<div id="lve-form-body">
<form action="$self" method="GET">
<input type="hidden" name="cgiaction" value="$formvalue"/>
<input type="hidden" name="$formname" value="$id"/>
<table id="lve-form-table">
<tr><td colspan="2" class="form-table-header">
END

    if ( $item eq 'settings' ) {
        print qq#Settings for LVE <span class="item-in-question">$id</span>#
            . q# <span class="item-in-question">#
            . ( $user
                ? $domain
                    ? q#(#
                        . uc $user
                        . q{ - }
                        . uc $domain
                        . q#)#
                    : q#(#
                        . uc $user
                        . q#)#
                : q{} )
            . q#</span></div>#;
    }
    elsif ( $item eq 'packages' ) {
        print q#Settings for package <span class="item-in-question">#
            . uc $id
            . q#</span></div>#;
    }

    print <<END;
</td></tr>
<tr>
<td class="form-item-label">CPU usage (CPU)</td>
<td class="form-item-data"><input name="cpu" type="text" value="$cpu"/></td>
</tr>
<tr>
<td class="form-item-label">Number of cores for LVE (nCPU)</td>
<td class="form-item-data"><input name="ncpu" type="text" value="$ncpu"/></td>
</tr>
<tr>
<td class="form-item-label">Virtual Memory (vMEM)</td>
<td class="form-item-data"><input name="vmem" type="text" value="$vmem" size="14"/>
<select name="vmemunits">
<option value="G">GB</option>
<option value="M" selected="selected">MB</option>
</select>
<span class="lve-form-comment">
(0&nbsp;-&nbsp;unlimited)
</span>
</td>
</tr>
END

    if ( $lveversion > 4 ) {

    print <<END;
<tr>
<td class="form-item-label">Physical memory (pMEM)</td>
<td class="form-item-data"><input name="pmem" type="text" value="$pmem" size="14"/>
<select name="pmemunits">
<option value="G">GB</option>
<option value="M" selected="selected">MB</option>
</select>
<span class="lve-form-comment">
(0&nbsp;-&nbsp;unlimited)
</span>
</td>
</tr>
END
    }

    print <<END;
<tr>
<td class="form-item-label">Concurrent connections (EP)</td>
<td class="form-item-data"><input name="ep" type="text" value="$ep"/></td>
</tr>
END

    if ( $lveversion > 4 ) {

    print <<END;
<tr>
<td class="form-item-label">Number of processes (nPROC)</td>
<td class="form-item-data"><input name="nproc" type="text" value="$nproc"/>
<span class="lve-form-comment">
(0&nbsp;-&nbsp;unlimited)
</span>
</td>
</tr>
END

    }

    print <<END;
<tr>
<td class="form-item-label">I/O limit (IO)</td>
<td class="form-item-data"><input name="io" type="text" value="$io" size="13"/>
<select name="iounits">
<option value="K" selected="selected">KB/s</option>
</select>
<span class="lve-form-comment">
(0&nbsp;-&nbsp;unlimited)
</span>
</td>
</tr>
<tr>
<td class="form-item-label">Number of inodes (soft|hard)</td>
<td class="form-item-data">
<input name="qsoft" type="text" value="$qsoft" size="8"/>
<input name="qhard" type="text" value="$qhard" size="8"/>
<span class="lve-form-comment">
(0&nbsp;-&nbsp;unlimited)
</span>
</td>
</tr>
<tr>
<td class="form-column-left"><input name="lve-submit-apply" type="submit" value="Apply"/></td>
<td class="form-column-right"><input name="lve-submit-cancel" type="submit" value="Cancel"/></td>
</tr>
</table>
</form>
</div><!-- end of lve-form-body -->
</div><!-- end of lve-body -->
END
    sendWHMFooter();
}

sub addStyle {
    my $v = Cpanel::SafeRun::Errors::saferunallerrors(q#/usr/local/cpanel/cpanel -V#);
    my ( $form_width, $div_width ) = ( '43.2em', '51.2em' );
    if ( index($v,'11.34') == 0 ) {
        $form_width = '49em';
        $div_width = '49em';
    }
    my $style =<<END;
:focus {outline:none;}
::-moz-focus-inner {border:0;}
div#lve-main {
    margin: 10px;
}
div#lve-main a {
	color: #014D5F;
}
div#lve-body {
    padding: 8px;
    min-width: $div_width;
    border: 2px solid #014D5F;
}
div#lve-nav {
    height: 1.2em;
    min-width: $div_width;
}
div.lve-nav-list-item {
    float: left;
    height: 1.1em;
    padding: 0 12px;
}
div.lve-nav-list-item-selected {
    float: left;
    height: 1.2em;
    padding: 0 12px;
    background-color: #FFF;
    border-top: 2px solid #014D5F;
    border-left: 2px solid #014D5F;
    border-right: 2px solid #014D5F;
    border-top-left-radius: 5px;
    border-top-right-radius: 5px;
}
div.lve-nav-list-stub {
    height: 16px;
    float: left;
    width: 5%;
}
div#lve-list {
    max-height: 400px;
    overflow: auto;
    width: 100%;
}
table#lve-table {
    border-collapse: separate;
    border-spacing: 0;
}
table#lve-table thead tr.upper td.filled {
     border-bottom: 1px solid #014D5F;
     text-align: center;
     font-weight: bold;
     color: #014D5F;
}
table#lve-table thead tr.lower td {
    color: #014D5F;
    font-weight: bold;
    border-bottom: 2px solid #014D5F;
    height: 16px;
}
table#lve-table thead td.filter {
    text-align: right;
}
table#lve-table tbody td {
    padding-right: 4px;
    border-bottom: 1px solid #014D5F;
    border-right: 1px solid #014D5F;
}
table#lve-table tbody td.first-cell {
    border-left: 1px solid #014D5F;
}
td.tdh {
    color: #F00;
}
tr.trh {
    color: #00F;
}
td.rhs {
    text-align: right;
}
td.lhs {
    text-align: left;
}
td.chs {
    text-align: center;
}
table#lve-table tbody tr.odd {
    background-color: #E6F1F4;
}
td.lve-sortable {
    padding-left: 12px;
    cursor: pointer;
}
td.lve-sorted-asc {
    background: transparent url(/images/lve/lve_sorted_asc.png) no-repeat scroll 4px 6px;
}
td.lve-sorted-desc {
    background: transparent url(/images/lve/lve_sorted_desc.png) no-repeat scroll 4px 6px;
}
td.lve-non-sorted {
    background: transparent url(/images/lve/lve_non_sorted.png) no-repeat scroll 4px 6px;
}
div#lve-form-body {
    width: $form_width;
    margin-left: 2em;
}
div#lve-form-masthead {
    width: 100%;
    text-align: center;
    font-weight: bold;
    color: #014D5F;
    margin: 2% 0 1% 0;
}
table#lve-form-table td.form-item-label,
table#lve-form-table td.form-column-left {
    text-align: right;
}
table#lve-form-table td.form-item-data,
table#lve-form-table td.form-column-right {
    text-align: left;
}
table#lve-form-table td.form-table-header {
    text-align: center;
    font-weight: bold;
    color: #014D5F;
}
div#lve-form-body div.text,
div#lve-form-body div.complexbox,
div#lve-form-body div.select,
div#lve-form-body div.checkbox {
    margin:1px 0;
}
div#lve-form-body .text label,
div#lve-form-body .complexbox label,
div#lve-form-body .select label,
div#lve-form-body .checkbox label {
    display: block;
    float: left;
    width: 50%;
    text-align: right;
    padding-right: 1%;
    padding-top: 4px;
}
.radioboxitem label {
    display: block;
    float: left;
    width: 30%;
    text-align: right;
    padding-right: 1%;
}
.formsubmit {
    margin-left: 50%;
    padding-left: 1%;
    text-align: left;
}
div.rhs {
    float: right;
}
div.lhs {
    float: left;
}
div.rhs div {
    padding-top: 4px;
}
div#control-form-div {
    /* margin: 0 20% 0 6%; */
    margin-left: 6%;
    width: 46.4em;
    min-height: 24px;
}
input#instant-filter {
    width: 86px;
    font-size: 11px;
    height: 12px;
    border: 1px solid #014D5F;
    background: #E6F1F4 url(/images/lve/filter.png) no-repeat scroll 2px 3px;
    padding: 1px 1px 1px 14px;
}
.lve-form-comment {
    font-style: italic;
    color: #014D5F;
}
span.item-in-question {
    text-decoration: underline;
    color: #000;
}
ul.lve-unlim-list {
    color: #014D5F;
    font-style: italic;
    list-style: square;
}
/*
div.cagefs-popup {
	position: absolute;
	left: 30%;
	top: 25%;
	width: 20%;
	background-color: #FFF;
	border: 2px solid #014D5F;
	border-radius: 8px;
	-moz-box-shadow: 0 0 5px #888;
	-webkit-box-shadow: 0 0 5px#888;
	box-shadow: 0 0 8px #888;
	text-align: center;
	line-height:4em;
	font-size: 14px;
	color: #014D5F;
}
*/
div#toparea {
	margin: 8px 0 0 0;
	height: 360px;
	width: 640px;
	border: 1px solid #014D5F;
	padding: 8px;
	background-color: #F5F7F8;
        overflow: auto;
}
table#toptable {
	width: 640px;
	border-collapse: collapse;
}
table#toptable tr.even {
	background-color: #E6F1F4;
}
tbody#topbody td {
	text-align: center;
}
tbody#topbody td.topheader {
	font-weight: bold;
	color: #000;
	text-align: center;
	border-bottom: 1px solid #014D5F;
}
a.selector-version-enabled,
a.selector-version-disabled {
	font-weight: bold;
}
div#selector-common-control {
    border-bottom: 1px solid black;
    margin-bottom: 2px;
}
td.selector-control-label {
    text-align: right;
}
td#selector-control-dialog {
	display: none;
    height: 28px;
    font-size: .6em;
}
END
    return $style;
}

