function removeElem(){
    var elid = document.getElementById('popup');
    if (elid) {
        elid.parentNode.removeChild(elid);
    }
}

function fadeOutPopup(){
    var timeout = 32,
        opacity = 9,
        popup = document.getElementById('popup'),
        fading = window.setInterval(countDown, timeout);
    function countDown(){
        if ( popup ) {
            popup.style.opacity = '0.' + opacity;
            opacity--;
            if ( opacity < 0 ) {
                window.clearInterval(fading);
                removeElem();
            }
        }
    }
}

function findLeftOffset(obj){
    var curleft = 0;
    if(obj.offsetParent) {
        while (1) {
            curleft += obj.offsetLeft;
            if ( !obj.offsetParent )
                break;
            obj = obj.offsetParent;
        }
    }
    else if(obj.x) {
        curleft += obj.x;
    }
    return curleft;
}

function findTopOffset(obj){
    var curtop = 0;
    if(obj.offsetParent) {
        while (1) {
            curtop += obj.offsetTop;
            if ( !obj.offsetParent )
                break;
            obj = obj.offsetParent;
        }
    }
    else if (obj.y) {
        curtop += obj.y;
    }
    return curtop;
}

function encodeFormData(data){
    if (!data) return "";
    var pairs = [];
    for ( var name in data ) {
        if ( !data.hasOwnProperty(name) ) continue;
        if ( typeof data[name] === "function" ) continue;
        var value = data[name].toString();
        name = encodeURIComponent( name.replace(" ", "+") );
        value = encodeURIComponent( value.replace(" ", "+") );
        pairs.push( name + "=" + value );
    }
    return pairs.join('&');
}

if ( ! window.getComputedStyle ) {
    window.getComputedStyle = function(el, pseudo) {
        this.el = el;
        this.getPropertyValue = function(prop) {
            var re = /(\-([a-z]){1})/g;
            if (prop == 'float') prop = 'styleFloat';
            if (re.test(prop)) {
                prop = prop.replace(re, function () {
                    return arguments[2].toUpperCase();
                });
            }
            return el.currentStyle[prop] ? el.currentStyle[prop] : null;
        }
        return this;
    }
}

function displayIt(type, msg){
    var body = document.getElementsByTagName('body')[0],
        msgbox = document.createElement('div'),
        msgelem = document.createTextNode(msg),
        leftOffset = findLeftOffset(message_box),
        topOffset = findTopOffset(message_box),
        scrollOffset = (window.pageYOffset ? window.pageYOffset : 0),
        pageWidth = (ie ? window.getComputedStyle(message_box).getPropertyValue('width') : window.getComputedStyle(message_box).width),
        maxLen = 0;
    pageWidth = (pageWidth == 'auto' ? 751 : parseInt(pageWidth));
    if ( Object.prototype.toString.call( msg ) === '[object Array]') {
        msg_array = msg;
    }
    else {
    msg_array = msg.split('\n').filter(
            function(x){return /^\w+/.test(x)}
        ).map(
            function(x){return x.replace(/(?:ERROR|WARN):/g,"");}
        );
    }
    removeElem();
    msgbox.setAttribute('id','popup');
    msgbox.style.fontWeight = "bold";
    msgbox.style.fontFamily = "trebuchet ms,arial,helvetica,sans-serif";
    msgbox.style.fontSize = "13px";
    msgbox.style.position = "absolute";
    msgbox.style.boxShadow = "0 3px 6px #3F3F3F";
    msgbox.style.top = (topOffset + scrollOffset + 32) + 'px';
    msgbox.style.height = (1.2 * msg_array.length + 1.2) + 'em';
    msgbox.style.zIndex = 99999;
    if ( type == 'error' ) {
        msgbox.style.color = "#F00";
        msgbox.style.backgroundColor = "#FFEFEF";
        msgbox.style.border = "1px solid #F00";
    }
    else if ( type == 'warn' ) {
        msgbox.style.color = "#FF8002";
        msgbox.style.backgroundColor = "#FFF7EF";
        msgbox.style.border = "1px solid #FF8002";
    }
    else if ( type == 'info' ) {
        msgbox.style.color = "#1E7F2B";
        msgbox.style.backgroundColor = "#F1FFEF";
        msgbox.style.border = "1px solid #1E7F2B";
    }
    for ( var i in msg_array ) {
        if ( typeof(msg_array[i]) != 'string' )
            continue;
        if ( msg_array[i].length > maxLen )
            maxLen = msg_array[i].length;
        var d = document.createElement('div'),
            ds = document.createTextNode(msg_array[i]);
        d.appendChild(ds);
        d.style.margin = '.28em 0 0 2em';
        msgbox.appendChild(d);
    }
    var stringLen = Math.ceil(maxLen * 8) + 64,
        boxOffset = (pageWidth - stringLen) / 2;

    msgbox.style.left = (leftOffset + boxOffset) + 'px';
    msgbox.style.width = stringLen + 'px';
    message_box.appendChild(msgbox);
    setTimeout(fadeOutPopup, 2000);
}