(function(win){
    var doc = win.document,
        selector_link    = doc.getElementById('selector-version-link'),
        selector_ctrl    = doc.getElementById('selector-version-control'),
        version_control  = doc.getElementById('selector-version-select'),
        select_save      = doc.getElementById('selector-version-save'),
        select_cancel    = doc.getElementById('selector-version-cancel'),
        version_select   = doc.getElementById('selector-modules-select'),
        exttable         = doc.getElementById('selector-extensions-table'),
        exttable_save    = doc.getElementById('selector-table-save'),
        exttable_reset   = doc.getElementById('selector-table-reset'),
        exttable_default = doc.getElementById('selector-table-default'),
        version_list     = doc.getElementById('supported-versions-list');

    version_list.onclick = function(e){
        var tgt = e.target;
        if ( tgt.nodeName == 'A' ) {
            var version_enabled = tgt.className === 'selector-version-enabled' ? true : false,
                selected_version = tgt.firstChild.nodeValue,
                request_data = {'cgiaction':'selectorhelper','action':'versiontoggle','version':selected_version,'state':version_enabled ? 'enabled' : 'disabled'};
            if ( confirm('Do you really want to ' + (version_enabled ? 'disable' : 'enable') + ' version ' + selected_version + '?') ) {
                var request = new XMLHttpRequest();
                request.open("POST",uri);
                request.onreadystatechange = function(){
                    if ( request.readyState === 4 && request.status === 200 ) {
                        var data = JSON.parse(request.responseText);
                        if ( data['status'] === 'OK' ) {
                            if ( version_enabled ) {
                                tgt.className = 'selector-version-disabled';
                                //tgt.style.color = '#898989';
                                tgt.style.color = selector_styles['non_default_disabled_version_color'];
                                tgt.setAttribute('title', 'disabled version');
                            }
                            else {
                                tgt.className = 'selector-version-enabled';
                                //tgt.style.color = '#0050B4';
                                tgt.style.color = selector_styles['non_default_version_color'];
                                tgt.setAttribute('title', 'enabled version');
                            }
                            var options = version_control.options;
                            for ( var i in options ) {
                                if ( ! options[i].firstChild ) continue;
                                if ( options[i].firstChild.nodeValue == selected_version ) {
                                    //options[i].disabled = version_enabled == 'enabled' ? true : false;
                                    options[i].disabled = version_enabled;
                                }
                            }
                        }
                    }
                };
                request.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
                request.send(encodeFormData(request_data));
            }
        }
    };
    selector_link.onclick = function(){
        this.style.display = "none";
        selector_ctrl.style.display = "inline";
    };
    select_cancel.onclick = function(){
        selector_ctrl.style.display = "none";
        selector_link.style.display = "inline";
    };
    select_save.onclick = function(){
        var selected_version = version_control.options[version_control.selectedIndex].firstChild.nodeValue,
            request_data = {'cgiaction':'selectorhelper','action':'versionsave','version':selected_version},
            request = new XMLHttpRequest();
            list_nodes = version_list.childNodes,
            new_default = doc.createElement('span'),
            old_default = doc.createElement('a');
        for (var node in list_nodes) {
            var item = list_nodes[node];
            if ( item.nodeType != 1 ) {
                continue;
            }
            if ( item.nodeName === 'A' && item.firstChild.nodeValue === selected_version ) {
                var link2replace = item;
            }
            else if ( item.nodeName === 'SPAN' ) {
                var span2replace = item;
            }
        }
        if ( selected_version == span2replace.firstChild.nodeValue ) {
            return;
        }
        request.open("POST",uri);
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var data = JSON.parse(request.responseText);
                if ( data['status'] === 'OK' ) {
                    var previous_version = selector_link.firstChild.nodeValue;
                    selector_link.firstChild.nodeValue = selected_version;
                    new_default.style.fontWeight = selector_styles['default_version_fontweight'];
                    new_default.style.color = selector_styles['default_version_color'];
                    new_default.style.textDecoration = selector_styles['default_version_underline'];
                    new_default.title = 'version set as default';
                    new_default.appendChild(doc.createTextNode(selected_version));
                    old_default.style.fontWeight = selector_styles['non_default_version_fontweight'];
                    old_default.style.color = selector_styles['non_default_version_color'];
                    old_default.title = 'enabled version';
                    old_default.className = 'selector-version-enabled';
                    old_default.href = '#';
                    link2replace.parentNode.replaceChild(new_default,link2replace);
                    old_default.appendChild(doc.createTextNode(previous_version));
                    span2replace.parentNode.replaceChild(old_default,span2replace);
                    selector_ctrl.style.display = "none";
                    selector_link.style.display = "inline";
                }
                else {
                    displayIt('error', data['message']);
                }
            }
        };
        request.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
        request.send(encodeFormData(request_data));
    };
    exttable_save.onclick = function(){
        var checkbox_list    = exttable.getElementsByTagName('input'),
            selected_version = version_select.options[version_select.selectedIndex].firstChild.nodeValue,
            selected_dict    = {}
            selected_boxes   = [],
            request_data = {'cgiaction':'selectorhelper','action':'extsave','version':selected_version};
            request          = new XMLHttpRequest();

        for ( var i in checkbox_list ) {
            if ( checkbox_list[i].name !== undefined
                && checkbox_list[i].name.indexOf('cbx_') == 0
                && !checkbox_list[i].disabled && checkbox_list[i].checked ) {
                selected_dict[ checkbox_list[i].name.substring(4) ] = 1;
            }
        }
        for ( var key in selected_dict ) {
            selected_boxes.push( key );
        }
        request_data['extset'] = selected_boxes.join(',');
        request.open("POST",uri);
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var data = JSON.parse(request.responseText);
                if ( data['status'] === 'OK' ) {
                    displayIt('info', 'module set saved');
                }
                else {
                    displayIt( data['status'].toLowerCase(), data['message'] );
                    if ( 'data' in data ) {
                        for ( var i in data['data'] ) {
                            if ( typeof data['data'][i].title != 'string' )
                                continue;
                            selector_ext_form[ 'cbx_' + data['data'][i].title ].checked = ( data['data'][i].status == '1' ? true : false );
                        }
                    }
                }
            }
        };
        request.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
        request.send( encodeFormData( request_data ) );
    };
    exttable_reset.onclick = function(){
        var selected_version = version_select.options[version_select.selectedIndex].firstChild.nodeValue,
            request_data = {'cgiaction':'selectorhelper','action':'extreset','version':selected_version},
            request          = new XMLHttpRequest();

        request.open("POST",uri);
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var data = JSON.parse(request.responseText);
                if ( data !== undefined ) {
                    var checkbox_list = exttable.getElementsByTagName('input'),
                        data_dict = {},
                        indexes = [];
                    for ( var i in data['data'] ){
                        data_dict[data['data'][i].title] = data['data'][i].status;
                    }
                    for ( var i in checkbox_list ) {
                        if ( checkbox_list[i].name !== undefined && checkbox_list[i].name.indexOf('cbx_') == 0 ) {
                            var mstate = data_dict[ checkbox_list[i].name.substring(4) ];
                            if ( mstate == 1 ) {
                                checkbox_list[i].checked = true;
                                checkbox_list[i].disabled = false;
                            }
                            else if ( mstate == -1 ) {
                                checkbox_list[i].checked = true;
                                checkbox_list[i].disabled = true;
                            }
                            else if ( mstate == 0 ) {
                                checkbox_list[i].checked = false;
                                checkbox_list[i].disabled = false;
                            }
                        }
                    }
                    displayIt('info', 'Reset to defaults');
                }
            }
        };
        request.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
        request.send( encodeFormData( request_data ) );
    };
    exttable_default.onclick = function(){
        var selected_version = version_select.options[version_select.selectedIndex].firstChild.nodeValue,
            request_data = {'cgiaction':'selectorhelper','action':'extbuiltin','version':selected_version},
            request          = new XMLHttpRequest();

        request.open("POST",uri);
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var data = JSON.parse(request.responseText);
                if ( data !== undefined ) {
                    var checkbox_list = exttable.getElementsByTagName('input'),
                        data_dict = {};
                    for ( var i in data['data'] ){
                        data_dict[ 'cbx_' + data['data'][i].title ] = true
                    }
                    for ( var i in checkbox_list ) {
                        if ( checkbox_list[i].name in data_dict ) {
                            checkbox_list[i].checked = true
                        }
                        else {
                            if ( !checkbox_list[i].disabled ) {
                                checkbox_list[i].checked = false;
                            }
                        }
                    }
                    displayIt('info', 'Reset to panel built-ins');
                }
            }
        };
        request.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
        request.send( encodeFormData( request_data ) );
    };
    version_select.onchange = function(e){
        var selected_version = version_select.options[version_select.selectedIndex].firstChild.nodeValue,
            request = new XMLHttpRequest(),
            request_data = {'cgiaction':'selectorhelper','action':'extlist','version':selected_version};
        request.open("POST",uri);
        
        request.onreadystatechange = function(){
            if ( request.readyState === 4 && request.status === 200 ) {
                var data = JSON.parse(request.responseText),
                    indexes = [];
                if ( data['data'] !== undefined ) {
                    while ( exttable.firstChild ) {
                        exttable.removeChild(exttable.firstChild);
                    }
                }
                if ( 'data' in data ) {
                    for ( var i in data['data'] ){
                        if ( data['data'][i].title === undefined ) continue;
                        indexes.push(data['data'][i]);
                    }
                    var rownum = Math.floor( indexes.length / 5 );
                    if ( indexes.length % 5 != 0 ) {
                        rownum += 1;
                    }
                    for ( var r=1; r<=rownum; r++ ) {
                        var row = doc.createElement('tr');
                        row.style.borderBottom = r == rownum 
                            ? selector_styles['end_row_border_bottom']
                            : selector_styles['row_border_bottom'];
                        for ( var c=0; c<5; c++ ) {
                            var ext  = doc.createElement('td'),
                                stat = doc.createElement('td'),
                                id = (rownum * c + r - 1);
                            ext.style.padding = selector_styles['label_cell_left_padding'];
                            stat.style.padding = selector_styles['ctrl_cell_padding'];
                            if ( 'label_cell_text_align' in selector_styles ) {
                                ext.style.textAlign = selector_styles['label_cell_text_align'];
                            }
                            if ( indexes[id] ) {
                                var ctrl = doc.createElement('input');
                                ext.appendChild( doc.createTextNode(indexes[id].title) );
                                ext.title = moddesc[indexes[id].title] || 'no info';
                                ctrl.type = 'checkbox';
                                ctrl.title = moddesc[indexes[id].title] || 'no info';
                                ctrl.name = 'cbx_' + indexes[id].title;
                                var mstate = indexes[id]['status'];
                                if ( mstate == 1 ) {
                                    ctrl.checked = true;
                                    ctrl.disabled = false;
                                }
                                else if ( mstate == -1 ) {
                                    ext.style.fontStyle = "italic";
                                    ctrl.checked = true;
                                    ctrl.disabled = true;
                                }
                                else if ( mstate == 0 ) {
                                    ctrl.checked = false;
                                    ctrl.disabled = false;
                                }
                                if ( selected_version === 'native' )
                                    ctrl.disabled=1;
                                if ( id['disabled'] )
                                    ctrl.disabled=1;
                                stat.appendChild(ctrl);
                            }
                            stat.className = 'cbx-ctrl';
                            row.appendChild(ext);
                            row.appendChild(stat);
                        }
                        exttable.appendChild(row);
                    }
                    if ( selected_version === 'native' ) {
                        exttable_save.disabled = 1;
                        exttable_reset.disabled = 1;
                        exttable_default.disabled = 1;
                    }
                    else {
                        exttable_save.removeAttribute('disabled');
                        exttable_reset.removeAttribute('disabled');
                        exttable_default.removeAttribute('disabled');
                    }
                }
            }
        };
        request.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
        request.send(encodeFormData(request_data));
    };
}(window));
