<?php

/*
     * Title: LVEManager Module.
     * Version: 1.1.0 (04/Nov/2011)
     * Author: Krishtopin Anton. AKrishtopin@cloudlinux.com
     * Site: http://CloudLinux.com
*/
include_once('phpselector/Selector.class.php');
include_once('phpselector/style.css');

$Selector = new Selector();
$Selector->GetSelectorVersions();
$Selector->GetSelectorExtensions();
?>
<table id="my-main-table" width="100%" border="0" align="center" cellpadding="3" cellspacing="1" class="list">
    <tr>
      <td class="listtitle"><b>Selector</b></td>
    </tr>

    <tr>
        <td class="list">
            <div id="lve-main">
                <div id="lve-body">
                    <div id="message-box"></div>
                    <div id="lve-form-body">
                        <div id="selector-common-control">
                            <div>
                                <div>
                                    <span>Selector is:</span>
                                    <a href="#" style="font-weight:bold;" id="selector-status-link"><?php echo ($Selector->GetSelectorStatus() == 1) ? 'enabled' : 'disabled' ?></a>
                                </div>
                                <div>
                                    <span>Default PHP version:</span>
                                    <a href="#" style="font-weight: bold;" id="selector-version-link"><?=$Selector->GetDefaultVersion();?></a>
                                    <span id="selector-version-control" style="display: none;">
                                        <select id="selector-version-select">
                                            <?php
                                                foreach ($Selector->GetVersions() as $version):
                                                    echo '<option '.(($version['default'] == 'd') ? 'selected="selected"' : '').' >'.$version['version'].'</option>';
                                                endforeach;
                                            ?>
                                        </select>
                                        <input id="selector-version-save" type="button" value="Save">
                                        <input id="selector-version-cancel" type="button" value="Cancel">
                                    </span>
                                </div>
                                <div>
                                    Supported versions:&nbsp;
                                    <span id="supported-versions-list">
                                        
                                        <?php
                                            foreach ($Selector->GetVersions() as $version):
                                                if ($version['default'] == 'd'):
                                                    echo '<span style="font-weight:bold; color:#0050B4; text-decoration:none" title="version set as default">'.$version['version'].'</span>';
                                                elseif ($version['enabled'] == 'e'):
                                                    echo '<a style="color:#014D5F;" title="version-enabled" class="selector-version-enabled" href="#">'.$version['version'].'</a>';
                                                else:
                                                    echo '<a style="color:#898989;" title="version disabled" class="selector-version-disabled" href="#">'.$version['version'].'</a>';
                                                endif;
                                                if ($version['version'] != 'native') echo ',&nbsp;';
                                            endforeach;
                                        ?>
                                    </span>
                                </div>
                                
                                <div style="text-align:center;">
                                    <form id="extensions-selector-form" name="extensions-selector-form" action="Ajax.raw" method="POST">
                                        <label for="selector-modules-select">Choose default modules for: </label>
                                        <select id="selector-modules-select" name="selector-modules-select">
                                            <?php
                                                foreach ($Selector->GetVersions() as $version):
                                                    echo '<option '.(($version['default'] == 'd') ? 'selected="selected"' : '').'>'.$version['version'].'</option>';
                                                endforeach;
                                            ?>
                                        </select>
                                
                                        <br />
                                        <table style="border-collapse:collapse;" align="center" cellpadding="3">
                                            <tbody id="selector-extensions-table">
                                                <?php 
                                                    $Extensions = $Selector->ReturnSelectorExt();
                                                    for ($i=0;$i<$Selector->TableRows;$i++): 
                                                ?>
                                                    <tr>
                                                        <?php for ($j=0;$j<=4;$j++):
                                                            $key = trim((($Selector->TableRows)*$j)+$i);
                                                            if (array_key_exists($key,$Extensions)) { ?>
                                                                <td <?=($Extensions[$key]['status'] == '~') ? 'style="font-weight:bold;"' : ''?> title="<?=GetDescription($Extensions[$key]['name'])?>">
                                                                    <?=$Extensions[$key]['name']?>
                                                                </td>
                                                                <td class="cbx-ctrl">
                                                                    <input name="cbx_<?=$Extensions[$key]['name']?>" title="<?=GetDescription($Extensions[$key]['name'])?>" type="checkbox" <?=($Extensions[$key]['status'] == '~') ? 'checked="checked" disabled="disabled"' : (($Extensions[$key]['status'] == '+') ? 'checked="checked"' : '')?>/>
                                                                </td>
                                                            <? } else {
                                                                echo '<td colspan="2"></td>';
                                                            }
                                                        endfor; ?>
                                                    </tr>
                                                <?php endfor; ?>
                                            </tbody>
                                        </table>
                                        <br />
            
                                        <div class="formsubmit">
                                            <input id="selector-table-save" type="button" title="Save checked modules" value="Save" <?=($Selector->GetDefaultVersion() == 'native') ? 'disabled' : ''?>>
                                            <input id="selector-table-reset" type="button" title="Uncheck all but defaults. Click &quot;Save&quot; to apply" value="Reset" <?=($Selector->GetDefaultVersion() == 'native') ? 'disabled' : ''?>>
                                            <input id="selector-table-default" type="button" title="Uncheck all but panel builtins. Click &quot;Save&quot; to apply" value="Panel Defaults" <?=($Selector->GetDefaultVersion() == 'native') ? 'disabled' : ''?>>
                                        </div>
                                    </form>
                                </div>
            
                            </div>
                        </div>
        </td>
    </tr>
</table>
<?php echo '<script type="text/javascript">var moddesc='.$Selector->ReturnExtDescriptionJson().'</script>'; ?>
    <script type="text/javascript">
    var strip_resource = function(str) {
            last_idx = str.lastIndexOf('/');
            return str.substring(0, last_idx+1);
        },
        host_uri          = window.location.protocol + '//' + window.location.host,
        resource_uri      = 'Ajax.raw',
        uri               = strip_resource(window.location.href) + resource_uri,
        selector_ext_form = document.getElementById('extensions-selector-form'),
        message_box       = document.getElementById('message-box'),
        ie                = navigator.userAgent.toLowerCase().indexOf('msie') >= 0 ? true : false;
        selector_styles   = {
	        "row_border_bottom":"1px solid #D8D8D8",
	        "label_cell_left_padding":".4em 0 0 0",
	        "label_cell_minwidth":"100px",
	        "end_row_border_bottom":"1px solid #444444",
	        "ctrl_cell_padding":"0 1.6em 0 .8em",
	        "default_version_underline":"none",
	        "default_version_color":"#0050B4",
	        "default_version_fontweight":"bold",
	        "non_default_version_fontweight":"bold",
	        "non_default_disabled_version_fontweight":"bold",
	        "non_default_version_color":"#014D5F",
	        "non_default_disabled_version_color":"#898989"
	    };
    </script>
<?php echo '<script>';
      include_once('phpselector/cl-message-handler.js');
      include_once('phpselector/extension-selector.js');
      include_once('phpselector/cl-selector-toggle.js');
      echo '</script>';
