<?php
/*
     * Title: LVEManager Module.
     * Version: 1.1.0 (04/Nov/2011)
     * Author: Krishtopin Anton. AKrishtopin@cloudlinux.com
     * Site: http://CloudLinux.com
*/
require_once('/usr/local/directadmin/plugins/new_lvemanager/check_utils.php');
class LVE {
    private $ProcLVEVersion;
    
    public function __construct() {
        $result = self::CommandExecute('/usr/sbin/lveinfo');
        if (strstr($result,'lPMem')) {
            $this->ProcLVEVersion = 6;
        } else {
            $this->ProcLVEVersion = 4;
        }
        
    }
    
    // return ProcLVE version
    public function ReturnProcLVEVerion() {
        return $this->ProcLVEVersion;
    }
    
    // Execute Shell Command
    private function CommandExecute($command,$result = true) {
        if ($result) {
            ob_start();
            passthru($command);
            $return = ob_get_contents();
            ob_end_clean();
            return $return;
//            return explode(PHP_EOL,$return);
        } else {
            passthru($command);
            return true;
        }
    }

    // Create Table fields for different procLVE verions
    private function FormatFields($row) {
        $row = explode(',',$row);
        return $row;
    }
    
    // Get LveStats Data
    public function GetLVEStats($period) {
        $user = check_user($_SERVER['USER']);
        $period = check_period($period);
        $result = self::CommandExecute('/usr/sbin/lveinfo --csv --period='.$period.' --user='.$user);
        $result = explode(PHP_EOL,$result);
        $header = self::FormatFields($result[0]);
        unset($result[0]);
        
        $return = array();
        
        $j = 0;
        foreach ($result as $row) {
            $temp = explode(',',$row);
            $i = 0;
            if (count($temp) != 1)
                foreach ($temp as $item) {
                    $return[$j][trim($header[$i])] = trim($item);
                    $i++;
                }
            $j++;
        }
        
        return $return;
    }
}

$LVE = new LVE();