<?php
/*
     * Title: LVEManager Module.
     * Version: 1.1.0 (04/Nov/2011)
     * Author: Krishtopin Anton. AKrishtopin@cloudlinux.com
     * Site: http://CloudLinux.com
*/

function getNameToProc(){
$name_to_proc=array(
	 "CPU"=>"lCPU",
	 "NCPU"=>"nCPU",
	 "IO"=>"lIO",
	 "MEM"=>"lMEM",
	 "OTHER"=>"lEP",
	 "PMEM"=>"lPMEM",
	 "NPROC"=>"lNPROC",
	 "READ"=>"lIOR",
	 "WRITE"=>"lIOW"	                                                                                                                                 
);
return $name_to_proc;
}

function getnameToTitle(){
$name_to_title=array(
	 "CPU"=>"CPU",
	 "NCPU"=>"nCPU",
	 "IO"=>"IO",
	 "MEM"=>"vMem",
	 "OTHER"=>"EP",
	 "PMEM"=>"pMem",
	 "NPROC"=>"nPROC",
	 "READ"=>"IOR",
	 "WRITE"=>"IOW"	                                                                                                                                 
);
return $name_to_title;
}

function getUserLimits($user_id, $veCfg, $pckCfg, $vepckCfg, $avail_names){

	//Get default
	$var=array();
	for($i=0;$i<count($avail_names);$i++){
	    $var[$avail_names[$i]]=0;
	}
	foreach($veCfg["DEFAULTS"] as $key=>$value){
	    if(isset($var[$key])){
		$var[$key]=$value;
	    }
	}
	
	//Get package
	foreach($pckCfg as $plan=>$user){
	    $fnd_user=0;
	    for($i=0;$i<count($user);$i++){
		if($user_id==$user[$i]){
		    $fnd_user=1;
		    break;
		}
	    }
	    if ($fnd_user==1){
		if(isset($vepckCfg[$plan])){
		    foreach($vepckCfg[$plan] as $key=>$value){
			if(isset($var[$key])){
			    $var[$key]=$value;
			}
		    }
		}
	    }
	}

	//Get ve id
	if (isset($veCfg[$user_id])){
	    foreach($veCfg[$user_id] as $key=>$value){
		if(isset($var[$key])){
		    $var[$key]=$value;
		}
	    }
	}
	return $var;
	
}

function getDefaultLimits($user_id, $veCfg, $pckCfg, $vepckCfg, $avail_names){
    	//Get default
	$var=array();
	for($i=0;$i<count($avail_names);$i++){
	    $var[$avail_names[$i]]=0;
	}
	foreach($veCfg["DEFAULTS"] as $key=>$value){
	    if(isset($var[$key])){
		$var[$key]=$value;
	    }
	}
	
	//Get package
	foreach($pckCfg as $plan=>$user){
	    $fnd_user=0;
	    for($i=0;$i<count($user);$i++){
		if($user_id==$user[$i]){
		    $fnd_user=1;
		    break;
		}
	    }

	    if ($fnd_user==1){
		if(isset($vepckCfg[$plan])){
		    foreach($vepckCfg[$plan] as $key=>$value){
			if(isset($var[$key])){
			    $var[$key]=$value;
			}
		    }
		}
	    }
	}

	return $var;

}

function getDefaultPckg($pkgName, $veCfg, $pckCfg, $vepckCfg, $avail_names){
    	//Get default
	$var=array();
	for($i=0;$i<count($avail_names);$i++){
	    $var[$avail_names[$i]]=0;
	}
	foreach($veCfg["DEFAULTS"] as $key=>$value){
	    if(isset($var[$key])){
		$var[$key]=$value;
	    }
	}
	
	if(isset($vepckCfg[$pkgName])){
	    foreach($vepckCfg[$pkgName] as $key=>$value){
		if(isset($var[$key])){
		    $var[$key]=$value;
		}
	    }
	}


	return $var;

}

function getDefault($veCfg, $pckCfg, $vepckCfg, $avail_names){
    	//Get default
	$var=array();
	for($i=0;$i<count($avail_names);$i++){
	    $var[$avail_names[$i]]=0;
	}
	foreach($veCfg["DEFAULTS"] as $key=>$value){
	    if(isset($var[$key])){
		$var[$key]=$value;
	    }
	}
	
	return $var;

}


function getUserPackages(){
    $ul=array();
    return $ul;
}

function veParser()
{
$file = "/etc/container/ve.cfg";
$params=array();

if( $xml = simplexml_load_file($file) ) {
    foreach ($xml->children() as $lveid){
	if($lveid->getName()!="lve" && $lveid->getName()!="defaults") continue;
	$lve_name="";
	if ($lveid->getName()=="defaults")
	    $lve_name = "DEFAULTS";
	else {
	    foreach($lveid->attributes() as $a => $b){
		if ($a=="id"){
		    $lve_name=trim($b);
		    break;
		}
	    }
	}
	if($lve_name!=""){
	    foreach( $lveid as $element ){
		$value="";
		foreach($element->attributes() as $key=>$val){
		    $value=(string)$val;
		    break;
		}
		$params[$lve_name][strtoupper($element->getName())]=$value;
	    }
	}
    }
}
return $params;
}


function pckgParser(){
$file = "/etc/container/ve.cfg";
$params=array();

if( $xml = simplexml_load_file($file) ) {
    foreach ($xml->children() as $lveid){
	if($lveid->getName()!="package") continue;
	$lve_name="";
	foreach($lveid->attributes() as $a => $b){
	    if ($a=="id"){
		$lve_name=trim($b);
		break;
	    }
	}
	if($lve_name!=""){
	    foreach( $lveid as $element ){
		$value="";
		foreach($element->attributes() as $key=>$val){
		    $value=(string)$val;
		    break;
		}
		$params[$lve_name][strtoupper($element->getName())]=$value;
	    }
	}
    }
}
return $params;

}

function getAvailNames($ver){
    $avail_names=array(
	"CPU",
	"NCPU",
	//"IO",
	"MEM",
	"OTHER"
    );
    return $avail_names;

}

?>
