<?php
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
*/

include('nav.php');

class Ctrl_Nodeworx_LveEdit extends Ctrl_Nodeworx_Plugin 
{
	protected function _init() 
	{
		if( IW::NW()->isReseller() ) 
		{
			throw new IWorx_Exception_ActionBlocked( '##LG_ACTION_BLOCKED##' );
	  	}
	}

	public function indexAction() 
	{

	    include_once('LVE.class.php');
	    
	    $error_msg = false;
	    $changed = false;
	    
        if (isset($_POST['submit'])) {

            if ($_POST['uid'] == 'DEFAULT') {
                $_POST['uid'] = 0;
            }

            $params = '';
            
            if (isset($_POST['cpu'])) {
                if ((strlen($_POST['cpu']) != 0) && ((int)$_POST['cpu'] != 0) && ($_POST['cpu'] > 0) && ($_POST['cpu'] <= 100)) {
                    $params .= ' --cpu='.(int)$_POST['cpu'];
                } else {
                    $error_msg = 'Bad CPU limit given';
                }
            }
            
            if (isset($_POST['ncpu'])) {
                if ((strlen($_POST['ncpu']) != 0) && ((int)$_POST['ncpu'] != 0) && ($_POST['ncpu'] > 0)) {
                    $params .= ' --ncpu='.(int)$_POST['ncpu'];
                } else {
                    $error_msg = 'Bad nCPU limit given';
                }
            }
            
            if (isset($_POST['vmem'])) {
                if ((strlen($_POST['vmem']) != 0) && ($_POST['vmem'] >= 0)) {
                    $params .= ' --vmem='.(int)$_POST['vmem'].$_POST['vmem_dim'];
                } else {
                    $error_msg = 'Bad vMEM limit given';
                }
            }
            
            if (isset($_POST['pmem'])) {
                if ((strlen($_POST['pmem']) != 0) && ($_POST['pmem'] >= 0)) {
                    $params .= ' --pmem='.(int)$_POST['pmem'].$_POST['pmem_dim'];
                } else {
                    $error_msg = 'Bad pMEM limit given';
                }
            }
            
            if (isset($_POST['ep'])) {
                if ((strlen($_POST['ep']) != 0) && ((int)$_POST['ep'] != 0) && ($_POST['ep'] > 0)) {
                    $params .= ' --maxEntryProcs='.(int)$_POST['ep'];
                } else {
                    $error_msg = 'Bad EntryProcs limit given';
                }
            }
            
            if (isset($_POST['nproc'])) {
                if ((strlen($_POST['nproc']) != 0) && ($_POST['nproc'] >= 0)) {
                    $params .= ' --nproc='.(int)$_POST['nproc'];
                } else {
                    $error_msg = 'Bad nPROC limit given';
                }
            }
            
            if (isset($_POST['io'])) {
                if ((strlen($_POST['io']) != 0) && ($_POST['io'] >= 0)) {
                    $params .= ' --io='.(int)$_POST['io'];
                } else {
                    $error_msg = 'Bad I/O limit limit given';
                }
            }
            
            
            if (!$error_msg) {
                if (strlen($params) != 0) {
                    $LVE->SetupLVE($_POST['uid'],$params);
                    $changed = true;
                }
            }
        }

		$this->getView()->assign( 'title', 'CloudLinux LVE manager' );
		$this->getView()->assign( 'template', 'admin/edit' );
		$this->getView()->assign( 'nav', nav('settings') );
        $this->getView()->assign( 'acc', $_REQUEST['acc'] );
        $this->getView()->assign( 'uid', $_REQUEST['uid'] );
        $this->getView()->assign( 'error_msg', $error_msg );
        $this->getView()->assign( 'changed', $changed );
        $this->getView()->assign( 'ProcLVEVersion', $LVE->ReturnProcLVEVerion() );
        $this->getView()->assign( 'data', $LVE->GetEditData($_REQUEST['uid']) );

 	}
}

?>
