<?php
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved                                                                                                   
 *                                                                                                                                                           
 * Licensed under CLOUD LINUX LICENSE AGREEMENT                                                                                                              
 * http://cloudlinux.com/docs/LICENSE.TXT                                                                                                                    
*/ 

require_once('modules/pm.php');

require_once('modules/plesk-lvemanager/selectoruser.php');
require_once('modules/plesk-lvemanager/phpset.php');

class ModuleSelectorUserForm extends pm_Form{

    private $_action;
    
    private $_activeTab = 'selector_user';
    private $_allowedTabs = array('selector_user', 'phpset');                
    
    public function setActiveTab($tabId)
    {
    if (in_array($tabId, $this->_allowedTabs)) {
        $this->_activeTab = $tabId;
        }
    }
    
    public function setAction($act){
    $this->_action = $act;
    }

    public function define()                                                                                                                                 
    {                                                                                                                                                        
            $this->addTemplates(array(                                                                                                                       
                'main' => 'main.tpl',                                                                                                                        
                'form' => 'form.tpl',                                                                                                                        
                'lve-module' => "modules/plesk-lvemanager/{$this->_activeTab}.tpl",                                                                             
            ));                                                                                                                                              
                                                                                                                                                             
        parent::define();                                                                                                                                    
    }

    public function assign(){
    $tabs = new ScreenTabs($this->_activeTab);
    $tabs->addScreenTab('selector_user', 'General', '?tab=selector_user');
    $tabs->addScreenTab('phpset', 'PHP Settings', '?tab=phpset');

        $vars = array(
            'SCREEN_TABS' => $tabs->get(),
        );
    
//	$vars = array(                                                                                                                                       
//            'TEST' => "NO TABS"
//        ); 

	//switch($this->_action){
	switch($this->_activeTab){
	    case 'phpset':
		$hm = new PhpSetPage($this);
		$vars=$hm->getResult($vars);
	    break;
            default:                                                                                                                                  
                $hm = new SelectorUserPage($this);                                                                                                                
                $vars=$hm->getResult($vars);                                                                                                                  
	}
	$this->addVars($vars);
	parent::assign();
    }  

    public function parse()                                                                                                                                  
    {                                                                                                                                                                                                                                                                         
        //parent::parse('DOCUMENT', 'lve-module');                                                                                                                   
    	parent::parse('BODY', 'lve-module');
        parent::parse('DOCUMENT', 'main');
    }  
}