<?php
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved                                                                                                   
 *                                                                                                                                                           
 * Licensed under CLOUD LINUX LICENSE AGREEMENT                                                                                                              
 * http://cloudlinux.com/docs/LICENSE.TXT                                                                                                                    
*/ 

require_once('modules/plesk-lvemanager/roundmem.php');                                                                                                                                
require_once('modules/plesk-lvemanager/veParser.php');                                                                                                                                
require_once('modules/plesk-lvemanager/veProcParser.php');

class AccountPage{

    private $module_pointer;                                                                                                                                 
                                                                                                                                                             
    public function _construct($ptr){                                                                                                                        
        $module_pointer=$ptr;                                                                                                                                
    }
    
    private function getAccountsList(){
	$pass=file('/etc/psa/.psa.shadow');
	if(count($pass)>0){
	    $res=array();
	    $ps=trim($pass[0]);
	    $chandle = mysql_pconnect("localhost", 'admin', $ps);
	    mysql_select_db('psa', $chandle);
	    $result = mysql_query("select t2.login as account, t3.login as sys_user from domains as t1  join clients as t2 on t1.cl_id = t2.id join hosting as t4 on t4.dom_id = t1.id join sys_users as t3 on t4.sys_user_id = t3.id union select login as account, login as sys_user from clients where login<>'admin';");
	    while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
	            $res[$line['sys_user']]=$line['account'];
	    }
	    mysql_free_result($result);
	    mysql_close($chandle);
	    return $res;
	} else {
	    return array();
	}
    }
    
    private function getLveVesrion(){
	ob_start();
	passthru("/usr/sbin/lvectl --lve-version");
	$version=intval(ob_get_contents());
	ob_end_clean();
	return $version;
    }
    
    private function usersInfoRequest($value){
      $xmldoc = new DomDocument('1.0', 'UTF-8');
      $xmldoc->formatOutput = true;
      // <packet>
      $packet = $xmldoc->createElement('packet');
      $packet->setAttribute('version', '1.6.3.2');
      $xmldoc->appendChild($packet);
      // <packet/customer>
      $webuser = $xmldoc->createElement('webspace');
      $packet->appendChild($webuser);
      // <packet/domain/get>
      $get = $xmldoc->createElement('get');
      $webuser->appendChild($get);
      // <packet/domain/get/filter>
      $filter = $xmldoc->createElement('filter');
      $get->appendChild($filter);
      //if(is_array($value)){
        //foreach ($value as $item) {
    	    //$id = $xmldoc->createElement('owner-login', $item);
    	    //$filter->appendChild($id);
        //}
      //}
      $dataset = $xmldoc->createElement('dataset');
      $get->appendChild($dataset);
      $hosting = $xmldoc->createElement('hosting');
      $dataset->appendChild($hosting);
      
      return $xmldoc;
    }


    private function curlInit($host, $key){
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, "https://{$host}:8443/enterprise/control/agent.php");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($curl, CURLOPT_POST,           true);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
      curl_setopt($curl, CURLOPT_HTTPHEADER,
             array("Key: {$key}",
                    "HTTP_PRETTY_PRINT: TRUE",
                    "Content-Type: text/xml")
      );
      return $curl;
    }

    private function sendRequest($curl, $packet){
      curl_setopt($curl, CURLOPT_POSTFIELDS, $packet);
      $result = curl_exec($curl);
      if (curl_errno($curl)) {
             $errmsg  = curl_error($curl);
             $errcode = curl_errno($curl);
             curl_close($curl);
             throw new ApiRequestException($errmsg, $errcode);
      }
      curl_close($curl);
      return $result;
    }

    private function parseResponse($response_string){
      $xml = new SimpleXMLElement($response_string);
      if (!is_a($xml, 'SimpleXMLElement'))
             throw new ApiRequestException("Cannot parse server response: {$response_string}");
      return $xml;
    }

    private function checkResponse(SimpleXMLElement $response){
      $resultNode = $response->domain->get->result;
      // check if request was successful
      if ('error' == (string)$resultNode->status)
             throw new ApiRequestException("The Panel API returned an error: " . (string)$resultNode->result->errtext);
    }

    private function getInfo($id,$key){
	$host = gethostbyname($_SERVER['SERVER_NAME']);
	$curl = $this->curlInit($host, $key);
	try {
	      $response = $this->sendRequest($curl, $this->usersInfoRequest($id)->saveXML());
	      $responseXml = $this->parseResponse($response);

	      $this->checkResponse($responseXml);
	} catch (ApiRequestException $e) {
	     return array();
	}
	$usrs = array();
	// Explore the result
	foreach ($responseXml->xpath('/packet/webspace/get/result/data/hosting/vrt_hst/property') as $resultNode) {
	      if((string)$resultNode->name=="ftp_login"){
	      	$usrs[] = (string)$resultNode->value;
	      }
	}
	return $usrs;
    }  

    
    public function getResult($vars){
	$ovars=$vars;	
	
//-------------------Parse here-------------------------------------
	$result = "";
	$ver = getLveVesrion();
	$veCfg = veParser();
	$pckCfg = getUserPackages();
	$vepckCfg = pckgParser();

	$avail_names = getAvailNames($ver);
	$name_to_titles = getnameToTitle();

	$result = "<tr><th>User name</th><th>Owner</th><th>LVEId</th>";
	for($i=0;$i<count($avail_names);$i++){
	    $result.="<th>".$name_to_titles[$avail_names[$i]]."</th>";
	}
	$result.="<th colspan=\"2\">Options</th></tr>";
	$result.= "<tr><td>DEFAULT</td><td>-</td><td>-</td>";
	$df=getdefault($ver, $veCfg, $pckCfg, $vepckCfg, $avail_names);
	for($i=0;$i<count($avail_names);$i++){
	    if(($avail_names[$i]=="MEM")||($avail_names[$i]=="PMEM")){
		$result.="<td>".roundMemB($df[$avail_names[$i]]*4*1024)."</td>";
	    } else {
		$result.="<td>".$df[$avail_names[$i]]."</td>";
	    }
	}
	$result .= "<td><a href=\"?tab=accounts&action=edit&uid=default&acc=default\">[Edit]</a></td><td><a href=\"#\">&nbsp;</a></td></tr>";
	$handle = fopen('/etc/passwd', 'r');
	$acc_list=$this->getAccountsList();
	if ($handle) {
	    while (($passwd_line = fgets($handle, 4096)) != false) {
    	    list($user[0], $pass, $user[1], $gid, $extra, $path, $extra2) = explode(":", $passwd_line, 7);
    	    if (!isset($acc_list[$user[0]])) continue;
    	    $uId = intval($user[1]);
    	    if (($uId >= 10000) && ($uId < 4000000000)) {
    		$res=getUserLimits($uId, $ver, $veCfg, $pckCfg, $vepckCfg, $avail_names);
		$res2=getDefaultLimits($uId, $ver, $veCfg, $pckCfg, $vepckCfg, $avail_names);
		$result.= "<tr><td>".$user[0]."</td><td>".$acc_list[$user[0]]."</td><td>".$user[1]."</td>";
		for($i=0;$i<count($avail_names);$i++){
		    if(($avail_names[$i]=="MEM")||($avail_names[$i]=="PMEM")){
			$result.="<td".($res2[$avail_names[$i]]!=$res[$avail_names[$i]]?" style=\"color:red\"":"").">".roundMemB($res[$avail_names[$i]]*4*1024)."</td>";
		    } else {
			$result.="<td".($res2[$avail_names[$i]]!=$res[$avail_names[$i]]?" style=\"color:red\"":"").">".$res[$avail_names[$i]]."</td>";
		    }
		}
		$result .= "<td><a href=\"?tab=accounts&action=edit&uid={$user[1]}&acc={$user[0]}\">[Edit]</a></td><td><a href=\"?tab=accounts&action=history&uid={$user[1]}&acc={$user[0]}\">[History]</a></td></tr>";
	    }
	}
	if (!feof($handle)) {
    	    $result.= "Error: Unexpected fgets() fail\n";
	}
	fclose($handle);
    } else {
	$result.= "Error: unable to open /etc/passwd\n";
    }

    $ovars["LVE_LIST"]=$result;

//------------------------------------------------------------------
	

	return $ovars;
    }
}