<?php
require_once('modules/pm.php');
require_once('modules/plesk-lvemanager/dbdata.php');

function checkVersion($data) {
    preg_match("/(\d\.\d|native)/", $data, $captured);
    $version = 'native';
    if ( isset($captured[1]) && strlen($captured[1]) ) {
        $version = $captured[1];
    }
    return $version;
}

function checkUser($data) {
    preg_match("/([\w\-_.]+)/", $data, $captured);
    $user = '';
    if ( isset($captured[1]) && strlen($captured[1]) ) {
        $user = $captured[1];
    }
    return $user;
}

function checkDataSet($data) {
    preg_match("/([\w\-_\/,=+]+)/", $data, $captured);
    $dataset = '';
    if ( isset($captured[1]) && strlen($captured[1]) ) {
        $dataset = $captured[1];
    }
    return $dataset;
}

function checkState($data) {
    preg_match("/(enabled|disabled)/", $data, $captured);
    $state = 'disabled';
    if ( isset($captured[1]) && strlen($captured[1]) ) {
        $state = $captured[1];
    }
    return $state;
}

function getLogin($dropReseller=false) {
    $login = '';
    $session = new pm_Session();
    $client = $session->getClient();
    if ( $dropReseller ) {
        if ( $client->isReseller() ) {
            die("YOU ARE NOT AUTHORIZED TO ACCESS THE RESOURCE");
        }
    }
    $cid = $client->isClient() ? $client->getId() : $session->getImpersonatedClientId();
    $db = new DataSource();
    if ( isset($cid) ) {
        $logins = $db->get_user_by_id($cid);
        if ( count($logins) == 1 ) {
            $login = $logins[0];
        }
        else {
            $ftp_user = getSysUser();
            if ( in_array($ftp_user, $logins) ) {
                $login = $ftp_user;
            }
        }
    }
    else {
        $login = getSysUser();
        $clientId = $db->get_id_by_impersonated_user($login);
        if ( $clientId != $client->getId() ) {
            die("YOU ARE NOT AUTHORIZED TO ACCESS THE RESOURCE");
        }
    }
    $db->endSession();
    if ( !strlen($login) ) {
        die('Cannot find user ID. Please ensure that domain has subscription and system user.');
    }
    return $login;
}

function getUID($login) {
    $uid = exec('/usr/bin/getent passwd '.trim($login).' | cut -d: -f3');
    if ( $uid == '' ) {
        die('Cannot find user ID. Please ensure that domain has subscription and system user.');
    }
    return $uid;

}

function getSysUser() {
    preg_match("/([\w\-_.]+)/", $_GET['ftp_user'], $captured);
    if ( isset($captured[1]) ) {
        $_SESSION['system_user'] = $captured[1];
        return $captured[1];
    }
    $captured = array();
    preg_match("/([\w\-_.]+)/", $_SESSION['system_user'], $captured);
    if ( isset($captured[1]) ) {
        return $captured[1];
    }
    return '';
}

?>
