<?php
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved                                                                                                   
 *                                                                                                                                                           
 * Licensed under CLOUD LINUX LICENSE AGREEMENT                                                                                                              
 * http://cloudlinux.com/docs/LICENSE.TXT                                                                                                                    
*/ 

require_once('modules/plesk-lvemanager/checkInput.php');
require_once('modules/plesk-lvemanager/roundmem.php');
require_once('modules/plesk-lvemanager/veParser.php');
require_once('modules/plesk-lvemanager/veProcParser.php');

class DefaultPage {
    private $module_pointer;                                                                                                                                 
                                                                                                                                                             
    public function _construct($ptr){                                                                                                                        
        $module_pointer=$ptr;                                                                                                                                
    }  

    public function getResult($vars){                                                                                                                        
        $ovars=$vars; 
	if(isset($_POST['cpu']))
	{
    	    $cpu = checkNumber($_POST['cpu'], 1, 100);
    	    $ep = checkNumber($_POST['ep'], 1, 1000);
    	    $mem = checkNumber($_POST['mem'], 0, 16384, 1);
    	    $ncpu = checkNumber($_POST['ncpu'], 1, 5000);
    	    if(isset($_POST['persist']))
    	    {
                $save = 1;
    	    }
    	    else
    	    {
                $save = 0;
    	    }


    	    if($save == 1)
    	    {
                exec("/usr/bin/sudo /usr/sbin/lvectl set default --cpu=".trim($cpu)." --ncpu=".trim($ncpu)." --mem=".trim($mem)." --maxEntryProcs=".trim($ep)." --save");
    	    }
    	    else
    	    {
                exec('/usr/bin/sudo /usr/sbin/lvectl set default --cpu='.trim($cpu).' --ncpu='.trim($ncpu).' --mem='.trim($mem).' --maxEntryProcs='.trim($ep));
    	    }
	}

	$veProcParser = veProcParser();
	$veParser = veParser();
	
	$result="";
//---------------А здесь будем генерить HTML код----------------------------------------


	if( ($veProcParser[0]['lCPU'] != $veParser['DEFAULTS']['CPU']) || ($veProcParser[0]['lMEM'] != $veParser['DEFAULTS']['MEM']) || ($veProcParser[0]['nCPU'] != $veParser['DEFAULTS']['NCPU']) || ($veProcParser[0]['lEP'] != $veParser['DEFAULTS']['OTHER']) )
	{
         $ovars["LVE_PERSIST"]='<span style="color:red;"> You current live settings are not persists, and are different from saved config (/etc/container/ve.cfg).</span><br /> <br />';
	} else {
	 $ovars["LVE_PERSIST"]="";
	}

        $ovars["LVE_lCPU"]=$veProcParser[0]['lCPU'];
	$ovars["LVE_lMEM"]=$veProcParser[0]['lMEM']==0?'Disabled':roundMemB($veProcParser[0]['lMEM'] * 4096);
	$ovars["LVE_lEP"]=$veProcParser[0]['lEP'];
	$ovars["LVE_nCPU"]=$veProcParser[0]['nCPU'];
	$ovars["LVE_DEFCPU"]=$veParser['DEFAULTS']['CPU'];
	$ovars["LVE_DEFlMEM"]=$veParser['DEFAULTS']['MEM']==0?'Disabled':roundMemB($veParser['DEFAULTS']['MEM'] * 4096);
	$ovars["LVE_DEFOTHER"]=$veParser['DEFAULTS']['OTHER'];
	$ovars["LVE_DEFNCPU"]=$veParser['DEFAULTS']['NCPU']; 
	$ovars["LVE_MEMOPT"]="";
	if ($lmem == 0) { 
	   $ovars["LVE_MEMOPT"].='<option value="0M" selected="selected">'; 
	} else {
	   $ovars["LVE_MEMOPT"].='<option value="0M">';
	}
	$ovars["LVE_MEMOPT"].="Disabled</option>\n";
	$prev=0;
	$val = $veProcParser[0]['lMEM']/256;
	for ($mem = 128; $mem <= 16256; $mem+=128) {
	   if ($prev < $val && $val <= $mem) {
	     $ovars["LVE_MEMOPT"].='<option selected="selected">';
	   } else {
	     $ovars["LVE_MEMOPT"].='<option>';
	   }
	   $ovars["LVE_MEMOPT"].= $mem."M</option>\n";
           $prev=$mem;
	} 

	$ovars["LVE_NCPUOPT"]="";
	$cpus=0;
	foreach (file('/proc/cpuinfo') as $line) {
	  $pos = strpos($line, 'proc');
	  if ($pos !== false && $pos == 0) { $cpus++; }
	}
	for ($i=1; $i<=$cpus; $i++) {
	  if ($i == $veProcParser[0]['nCPU']) {
	    $ovars["LVE_NCPUOPT"].='<option selected="selected">';
	  } else {
	    $ovars["LVE_NCPUOPT"].='<option>';
	  }
	  $ovars["LVE_NCPUOPT"].= $i."</option>\n";
	}

//--------------------------------------------------------------------------------------
   
	return $ovars;
    }
}