<?php
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved                                                                                                   
 *                                                                                                                                                           
 * Licensed under CLOUD LINUX LICENSE AGREEMENT                                                                                                              
 * http://cloudlinux.com/docs/LICENSE.TXT                                                                                                                    
*/ 

require_once('modules/plesk-lvemanager/veParser.php');
require_once('modules/plesk-lvemanager/veProcParser.php');
require_once('modules/plesk-lvemanager/roundmem.php');
require_once('modules/plesk-lvemanager/checkInput.php');

class EditPage{                                                                                                                                     
    private $module_pointer;                                                                                                                                 
                                                                                                                                                             
    public function _construct($ptr){                                                                                                                        
        $module_pointer=$ptr;                                                                                                                                
    }                                                                                                                                                        
                                                                                                                                                             
    public function getResult($vars){                                                                                                                        
        $ovars=$vars;                                                                                                                                        
                                                                                                                                                             
//--------------Generate content here--------------------------
	$ver = getLveVesrion();
	$uid = trim($_GET['uid']);
	if(isset($_POST['b2d']))
	{
	    if($_GET['uid']!="default"){
        	exec('/usr/bin/sudo /usr/sbin/lvectl delete '.$uid);
	    }
	}
	if(isset($_POST['cpu']))
	{
    	    $cpu = checkNumber($_POST['cpu'], 1, 100);
    	    $ep = checkNumber($_POST['ep'], 1, 1000);
    	    $mem = checkNumber($_POST['mem'], 0, 16384, 1);
    	    $ncpu = checkNumber($_POST['ncpu'], 1, 5000);
	    if($ver>=6){
		$pmem = checkNumber($_POST['pmem'], 0, 16384, 1);
		$nproc = checkNumber($_POST['nproc'], 0, 10000);
		$io = checkNumber($_POST['io'], 0, 1000000);
	    }
	    if($ver>=7){
		$write = checkNumber($_POST['write'], 0, 10000);
		$read = checkNumber($_POST['read'], 0, 10000);
	    }

	    $command = '/usr/bin/sudo /usr/sbin/lvectl set '.trim($uid).' --cpu='.trim($cpu).' --ncpu='.trim($ncpu).' --mem='.trim($mem).' --maxEntryProcs='.trim($ep);
	    if($ver>=6){
		$command.=" --pmem=".trim($pmem)." --nproc=".trim($nproc)." --io=".trim($io); 
	    }
	    
	    if($ver>=7){
		$command.=" --read=".trim($read)." --write=".trim($write); 
	    }

	    exec($command);
	
	}


	$veCfg = veParser();
	$pckCfg = getUserPackages();
	$vepckCfg = pckgParser();
	$avail_names = getAvailNames($ver);
	$name_to_titles = getnameToTitle();

	$ovars["LVE_ACCOUNTINO"] = "<b>Edit settings - account: ".$_GET['acc']." - lveId : ".$_GET['uid']."</b>";
	if ($_GET['uid']=="default"){
	    $res=getDefault($ver, $veCfg, $pckCfg, $vepckCfg, $avail_names);
	    $res2=getDefault($ver, $veCfg, $pckCfg, $vepckCfg, $avail_names);
	} else {
	    $res=getUserLimits(intval($_GET['uid']), $ver, $veCfg, $pckCfg, $vepckCfg, $avail_names);                                                                                                                                                    
    	    $res2=getDefaultLimits(intval($_GET['uid']), $ver, $veCfg, $pckCfg, $vepckCfg, $avail_names);
	}
	$default = 1;
	for($i=0;$i<count($avail_names);$i++){
	    if ($res[$avail_names[$i]]!=$res2[$avail_names[$i]]){
		$default = 0;
	    }
	}

	
	$ovars["LVE_CURRENT"]="<legend>Default settings for user: (/etc/container/ve.cfg)</legend>
				    <table class='formFields' width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
					    <td class='name'>CPU</td>
					    <td>".$res2['CPU']."%</td>
					</tr>
					<tr>
					    <td class='name'>Virtual memeory (vMem)</td>
					    <td>".($res2['MEM']==0?'Disabled':roundMemB($res2['MEM'] * 4096))."</td>
				        </tr>
					<tr>
					    <td class='name'>Entry processes (EP)</td>
					    <td>".$res2['OTHER']."</td>
					</tr>
					<tr>
					    <td class='name'>Number of cores per LVE</td>
					    <td>".$res2['NCPU']."</td>
					</tr>";
	    if($ver>=6){
		$ovars["LVE_CURRENT"].="<tr>
					    <td class='name'>Physical memory (pMEM)</td>
					    <td>".($res2['PMEM']==0?'Disabled':roundMemB($res2['PMEM'] * 4096))."</td>
					</tr>
					<tr>
					    <td class='name'>Number of procecces (nPROC)</td>
					    <td>".$res2['NPROC']."</td>
					</tr>
					<tr>
					    <td class='name'>IO Limits</td>
					    <td>".$res2['IO']."</td>
					</tr>";
	    } 
	    if($ver>7){
		$ovars["LVE_CURRENT"].="<tr>
					    <td class='name'>Read IO limit</td>
					    <td>".$res2['READ']."%</td>
					</tr>
					<tr>
					    <td class='name'>Write IO limit</td>
					    <td>".$res2['WRITE']."%</td>
					</tr>";
	    } 
			    
	    $ovars["LVE_CURRENT"].="</table>";

	
	$ovars["LVE_RUNNING"]="";
	if ($default == 1){
	    $ovars["LVE_RUNNING"]="<legend>Running from default settings: (/etc/container/ve.cfg)</legend>
				    <table class='formFields' width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
					    <td class='name'>CPU</td>
					    <td>".$res2['CPU']."%</td>
					</tr>
					<tr>
					    <td class='name'>Virtual memeory (vMem)</td>
					    <td>".($res2['MEM']==0?'Disabled':roundMemB($res2['MEM'] * 4096))."</td>
				        </tr>
					<tr>
					    <td class='name'>Entry processes (EP)</td>
					    <td>".$res2['OTHER']."</td>
					</tr>
					<tr>
					    <td class='name'>Number of cores per LVE</td>
					    <td>".$res2['NCPU']."</td>
					</tr>";
	    if($ver>=6){
		$ovars["LVE_RUNNING"].="<tr>
					    <td class='name'>Physical memory (pMEM)</td>
					    <td>".($res2['PMEM']==0?'Disabled':roundMemB($res2['PMEM'] * 4096))."</td>
					</tr>
					<tr>
					    <td class='name'>Number of procecces (nPROC)</td>
					    <td>".$res2['NPROC']."</td>
					</tr>
					<tr>
					    <td class='name'>IO Limits</td>
					    <td>".$res2['IO']."</td>
					</tr>";
	    } 
	    if($ver>=7){
		$ovars["LVE_RUNNING"].="<tr>
					    <td class='name'>Read IO limit</td>
					    <td>".$res2['READ']."%</td>
					</tr>
					<tr>
					    <td class='name'>Write IO limit</td>
					    <td>".$res2['WRITE']."%</td>
					</tr>";
	    } 
			    
	    $ovars["LVE_RUNNING"].="</table>";
	}else {
	    $ovars["LVE_RUNNING"]="<legend>Running from settings: (/etc/container/ve.cfg)</legend>
				    <table class='formFields' width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
					    <td class='name'>CPU</td>
					    <td>".$res['CPU']."%</td>
					</tr>
					<tr>
					    <td class='name'>Virtual memeory (vMem)</td>
					    <td>".($res['MEM']==0?'Disabled':roundMemB($res['MEM'] * 4096))."</td>
				        </tr>
					<tr>
					    <td class='name'>Entry processes (EP)</td>
					    <td>".$res['OTHER']."</td>
					</tr>
					<tr>
					    <td class='name'>Number of cores per LVE</td>
					    <td>".$res['NCPU']."</td>
					</tr>";
	    if($ver>=6){
		$ovars["LVE_RUNNING"].="<tr>
					    <td class='name'>Physical memory (pMEM)</td>
					    <td>".($res['PMEM']==0?'Disabled':roundMemB($res['PMEM'] * 4096))."</td>
					</tr>
					<tr>
					    <td class='name'>Number of procecces (nPROC)</td>
					    <td>".$res['NPROC']."</td>
					</tr>
					<tr>
					    <td class='name'>IO Limits</td>
					    <td>".$res['IO']."</td>
					</tr>";
	    } 
	    if($ver>=7){
		$ovars["LVE_RUNNING"].="<tr>
					    <td class='name'>Read IO limit</td>
					    <td>".$res['READ']."%</td>
					</tr>
					<tr>
					    <td class='name'>Write IO limit</td>
					    <td>".$res['WRITE']."%</td>
					</tr>";
	    } 
			    
	    $ovars["LVE_RUNNING"].="</table><form id='form1' name='form1' method='post' action=''>
					<input type='submit' value='Switch back to default' name='b2d'>
				    </form>";

	}
 
	$ovars["LVE_EDIT"]="<legend>Change settings:</legend> 
	<form id=\"form1\" name=\"form1\" method=\"post\" action=\"\">
	<table class=\"formFields\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">
	    <tr>
		<td class=\"name\">CPU</td>
		<td><input name=\"cpu\" size=\"4\" value=\"".$res["CPU"]."\">%</td>
	    </tr>
	    <tr>
		<td class=\"name\">MEM </td>
		<td><select name=\"mem\" size=\"1\">";
	$ovars["LVE_OPTMEM"]="";
	if ($res["MEM"] == 0) { 
	    $ovars["LVE_OPTMEM"].='<option value="0M" selected="selected">'; 
	} else {
	    $ovars["LVE_OPTMEM"].='<option value="0M">';
	}
	$ovars["LVE_OPTMEM"].="Disabled</option>\n";
	$prev=0;
	$val = $res["MEM"]/256;
	for ($mem = 128; $mem <= 16256; $mem+=128) {
	    if ($prev < $val && $val <= $mem) {
    		$ovars["LVE_OPTMEM"].='<option selected="selected">';
	    } else {
    		$ovars["LVE_OPTMEM"].='<option>';
	    }
	    $ovars["LVE_OPTMEM"].=$mem."M</option>\n";
	    $prev=$mem;
	}

	$ovars["LVE_EDIT"].=$ovars["LVE_OPTMEM"];
	$ovars["LVE_EDIT"].="	    </select>
		</td>
	    </tr>
	    <tr>
		<td class=\"name\">Entry processes </td>
		<td><input type=\"text\" size=\"4\" name=\"ep\" size=\"1\" value=\"".$res["OTHER"]."\"></td>
	    </tr>
	    <tr>
		<td class=\"name\">Number of cores per LVE</td>
		<td><select name=\"ncpu\" size=\"1\">";

	$ovars["LVE_OPTNCPU"]="";

	$cpus=0;
	foreach (file('/proc/cpuinfo') as $line) {
	     $pos = strpos($line, 'proc');
	    if ($pos !== false && $pos == 0) { $cpus++; }
	}
	for ($i=1; $i<=$cpus; $i++) {
	    if ($i == $lncpu) {
		$ovars["LVE_OPTNCPU"].='<option selected="selected">';
	    } else {
		$ovars["LVE_OPTNCPU"].='<option>';
	    }
	    $ovars["LVE_OPTNCPU"].=$i."</option>\n";
	}

	$ovars["LVE_EDIT"].=$ovars["LVE_OPTNCPU"];

	$ovars["LVE_EDIT"].="</select> 
		    <font size='-1' color='red'><i>* change requires reboot</i></font>
		</td>
	    </tr>";
	if($ver>=6){
	
	$ovars["LVE_OPTMEM"]="";
	if ($res["MEM"] == 0) { 
	    $ovars["LVE_OPTMEM"].='<option value="0M" selected="selected">'; 
	} else {
	    $ovars["LVE_OPTMEM"].='<option value="0M">';
	}
	$ovars["LVE_OPTMEM"].="Disabled</option>\n";
	$prev=0;
	$val = $res["PMEM"]/256;
	for ($mem = 128; $mem <= 16256; $mem+=128) {
	    if ($prev < $val && $val <= $mem) {
    		$ovars["LVE_OPTMEM"].='<option selected="selected">';
	    } else {
    		$ovars["LVE_OPTMEM"].='<option>';
	    }
	    $ovars["LVE_OPTMEM"].=$mem."M</option>\n";
	    $prev=$mem;
	}
	
	    $ovars["LVE_EDIT"].="<tr>
		<td class=\"name\">pMem</td>
		<td><select name=\"pmem\" size=\"1\">".$ovars["LVE_OPTMEM"].
		"</select></td>
	    </tr>
	    <tr>
		<td class=\"name\">nProc</td>
		<td><input name=\"nproc\" size=\"4\" value=\"".$res["NPROC"]."\"></td>
	    </tr>
	    <tr>
		<td class=\"name\">IO</td>
		<td><input name=\"io\" size=\"4\" value=\"".$res["IO"]."\"></td>
	    </tr>";
	}
	if($ver>=7){
	    $ovars["LVE_EDIT"].="<tr>
		<td class=\"name\">Read</td>
		<td><input name=\"read\" size=\"4\" value=\"".$res["READ"]."\"></td>
	    </tr>
	    <tr>
		<td class=\"name\">Write</td>
		<td><input name=\"write\" size=\"4\" value=\"".$res["WRITE"]."\"></td>
	    </tr>";
	}
	$ovars["LVE_EDIT"].="</table>
	<input type=\"submit\"><br/>
    </form>";

	
	

//-------------------------------------------------------------
	return $ovars;                                                                                                                                       
    }     
}