<?php
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved                                                                                                   
 *                                                                                                                                                           
 * Licensed under CLOUD LINUX LICENSE AGREEMENT                                                                                                              
 * http://cloudlinux.com/docs/LICENSE.TXT                                                                                                                    
*/ 

require_once('modules/plesk-lvemanager/checkInput.php');                                                                                                                              
require_once('modules/plesk-lvemanager/roundmem.php');
require_once('modules/plesk-lvemanager/veParser.php');

class HistoryPage{
    private $module_pointer;                                                                                                                                 
                                                                                                                                                             
    public function _construct($ptr){                                                                                                                        
        $module_pointer=$ptr;                                                                                                                                
    }                                                                                                                                                        
                                                                                                                                                             
    public function getResult($vars){                                                                                                                        
        $ovars=$vars;                                                                                                                                        
                                                                                                                                                             
//--------------Generate content here--------------------------
	// find cur uid
	$uid = $_GET['uid'];

	$ver = getLveVesrion();

	// open lve info
	$lveinfo = file("/var/lve/info");
	$lveinfoResultOk = 0;

	foreach ($lveinfo as $line_num => $line) 
	{
    	    $lveTmp = explode(',', $line);
    	    if($lveTmp[0] == $uid)
    	    {
                $MEP_INDEX = $lveTmp[1];
                $LEP_INDEX = $lveTmp[2];
                $CPU_INDEX = $lveTmp[3];
                $LCPU_INDEX = $lveTmp[4];
                $MEM_INDEX = $lveTmp[5];
                $LMEM_INDEX = $lveTmp[6];
                $MEMF_INDEX = $lveTmp[7];
                $MEPF_INDEX = $lveTmp[8];
		if ($ver>=6){
		    $LMEMPHY = $lveTmp[9];
		    $MEMPHY = $lveTmp[10];
		    $MEMPHY_FAULT = $lveTmp[11];
		    $LNPROC = $lveTmp[12];
		    $NPROC = $lveTmp[13];
		    $NPROC_FAULT = $lveTmp[14];
		}
		if($ver>=7){
		    $LCPUW = $lveTmp[15];
		    $IOREAD = $lveTmp[16];
		    $IOWRITE = $lveTmp[17];
		}
                
                // mark result OK
                $lveinfoResultOk = 1;
    	    }
	}

	if($lveinfoResultOk == 0)
	{
    	    $MEP_INDEX = '0';
    	    $LEP_INDEX = '0';
    	    $CPU_INDEX = '0';
    	    $LCPU_INDEX = '0';
    	    $MEM_INDEX = '0';
    	    $LMEM_INDEX = '0';
    	    $MEMF_INDEX = '';
    	    $MEPF_INDEX = '';
	    
	    if ($ver>=6){
		    $LMEMPHY = '0';
		    $MEMPHY = '0';
		    $MEMPHY_FAULT = '0';
		    $LNPROC = '0';
		    $NPROC = '0';
		    $NPROC_FAULT = '0';
		}
		if($ver>=7){
		    $LCPUW = '0';
		    $IOREAD = '0';
		    $IOWRITE = '0';
		}
	}       

	$cpuUsage = ceil(@($CPU_INDEX / $LCPU_INDEX) * 100);
	$memUsage = ceil(@($MEM_INDEX / $LMEM_INDEX) * 100);
	$procUsage = ceil(@($MEP_INDEX / $LEP_INDEX) * 100);
	if ($ver>=6){
	    $mempUsage = ceil(@($MEMPHY / $LMEMPHY) * 100);
	    $nprocUsage = ceil(@($NPROC / $LNPROC) * 100);
	}


	// period post
	if(isset($_POST['period']))
	{
    	    $period = checkPeriod($_POST['period']);
	}
	else
	{
    	    $period = '1d';
	}

	$ovars["LVE_ACCOUNTINFO"]="<b>Resource Usage Details - account: ".$_GET['acc']." - lveId : ".$_GET['uid']."</b>";

      $veCfg = veParser();                                                                                                                                                                                                                 
        $pckCfg = getUserPackages();                                                                                                                                                                                                         
        $vepckCfg = pckgParser();                                                                                                                                                                                                            
        $avail_names = getAvailNames($ver);                                                                                                                                                                                                  
        $name_to_titles = getnameToTitle();

	$res=getUserLimits(intval($_GET['uid']), $ver, $veCfg, $pckCfg, $vepckCfg, $avail_names);

	$ovars["LVE_CPUUSAGE"]=$cpuUsage;
	$ovars["LVE_roundMemB"]=roundMemB($res["MEM"] * 4096);
	$ovars["LVE_MEMUSAGE"]=$memUsage;
	$ovars["LVE_lep"]=$res["OTHER"];
	$ovars["LVE_PROCUSAGE"]=$procUsage;

if($ver>=6){
	$ovars["LVE_LPMEM"]=$res["PMEM"];
	$ovars["LVE_PMEM"]=$mempUsage;
	$ovars["LVE_lNPROC"]=$res["NPROC"];
	$ovars["LVE_NPROC"]=$nprocUsage;

}

	$ovars["LVE_JAVA"]= <<<EOM

<strong>Cpu usage:</strong><br />
<table><tr><td>0% </td>
<td>
<table border="0" width="300" cellspacing="0" cellpadding="0" background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_BG_BLUE.gif">
                                <tr>
                                        <td width=3 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_LEFT_GREEN.gif" width="3" height="17"></td>
                                        <td id=cpu_bar background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif"></td>
                                        <td width=1 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif" width="1" height="17"></td>
                                        <td width=100%></td>
                                        <td width=1 align=right><img src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_BLUE.gif" width="1" height="17"></td>
                                </tr>
                        </table>
</td>
<td> 100%</td></tr>
</table>
                                        <script language="Javascript">
                                        <!--

                                        cpu_bar_top={$ovars["LVE_CPUUSAGE"]};
                                        cpu_bar_current=0;

                                        function cpu_bar_scroll()
                                        {
                                                increase = 10;
                                                again = true;
                                                cpu_bar_current += increase;
                                                if (cpu_bar_current >= cpu_bar_top)
                                                {
                                                        cpu_bar_current = cpu_bar_top;
                                                        again=false;
                                                }

                                                if (document.getElementById)
                                                {
                                                        my_style = document.getElementById("cpu_bar").style;
                                                }
                                                else if (document.all)
                                                {
                                                        my_style = document.all["cpu_bar"].style;
                                                }
                                                else if (document.layers)
                                                {
                                                        my_style = document.layers["cpu_bar"];
                                                }

                                                my_style.width=cpu_bar_current+"%";
						
                                                if (again)
                                                        setTimeout("cpu_bar_scroll();", 50);
                                        }

                                        setTimeout("cpu_bar_scroll();", 1000);

                                        //-->
                                        </script>

<br /><br />
<strong> Memory usage:</strong> </br />
<table><tr><td>0 </td>
<td><table border="0" width="300" cellspacing="0" cellpadding="0" background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_BG_BLUE.gif">
                                <tr>
                                      <td width=3 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_LEFT_GREEN.gif" width="3" height="17"></td>
                                        <td width="1%" id=memory_bar background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif"></td>
                                        <td width=1 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif" width="1" height="17"></td>
                                        <td width=100%></td>
                                        <td width=1 align=right><img src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_BLUE.gif" width="1" height="17"></td>
                                </tr>
                        </table>
</td>
<td>{$ovars["LVE_roundMemB"]}</td></tr>
</table>
                                        <script language="Javascript">
                                        <!--

                                        memory_bar_top={$ovars["LVE_MEMUSAGE"]};
                                        memory_bar_current=0;

                                        function memory_bar_scroll()
                                        {
                                                increase = 10;
                                                again = true;
                                                memory_bar_current += increase;
                                                if (memory_bar_current >= memory_bar_top)
                                                {
                                                        memory_bar_current = memory_bar_top;
                                                        again=false;
                                                }

                                                if (document.getElementById)
                                                {
                                                        my_style = document.getElementById("memory_bar").style;
                                                }
                                                else if (document.all)
                                                {
                                                        my_style = document.all["memory_bar"].style;
                                                }
                                                else if (document.layers)
                                                {
                                                        my_style = document.layers["memory_bar"];
                                                }

                                                my_style.width=memory_bar_current+"%";

                                                if (again)
                                                        setTimeout("memory_bar_scroll();", 50);
                                        }

                                        setTimeout("memory_bar_scroll();", 1000);

                                        //-->
                                        </script>

<br /><br />
<strong> Entry Processes:</strong> </br />
<table><tr><td>0 </td>
<td><table border="0" width="300" cellspacing="0" cellpadding="0" background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_BG_BLUE.gif">
                                <tr>
                                      <td width=3 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_LEFT_GREEN.gif" width="3" height="17"></td>
                                        <td width="1%" id=entry_proces_bar background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif"></td>
                                        <td width=1 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif" width="1" height="17"></td>
                                        <td width=100%></td>
                                        <td width=1 align=right><img src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_BLUE.gif" width="1" height="17"></td>
                                </tr>
                        </table>
</td>
<td> {$ovars["LVE_lep"]}</td></tr>
</table>
                                        <script language="Javascript">
                                        <!--

                                        entry_proces_bar_top={$ovars["LVE_PROCUSAGE"]};
                                        entry_proces_bar_current=0;

                                        function entry_proces_bar_scroll()
                                        {
                                                increase = 10;
                                                again = true;
                                                entry_proces_bar_current += increase;
                                                if (entry_proces_bar_current >= entry_proces_bar_top)
                                                {
                                                        entry_proces_bar_current = entry_proces_bar_top;
                                                        again=false;
                                                }

                                                if (document.getElementById)
                                                {
                                                        my_style = document.getElementById("entry_proces_bar").style;
                                                }
                                                else if (document.all)
                                                {
                                                        my_style = document.all["entry_proces_bar"].style;
                                                }
                                                else if (document.layers)
                                                {
                                                        my_style = document.layers["entry_proces_bar"];
                                                }

                                                my_style.width=entry_proces_bar_current+"%";

                                                if (again)
                                                        setTimeout("entry_proces_bar_scroll();", 50);
                                        }

                                        setTimeout("entry_proces_bar_scroll();", 1000);

                                        //-->
                                        </script>

EOM;
	if($ver>=6){
	    $ovars["LVE_JAVA"].=<<<EOM

<br /><br />
<strong> Physical memory:</strong> </br />
<table><tr><td>0 </td>
<td><table border="0" width="300" cellspacing="0" cellpadding="0" background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_BG_BLUE.gif">
                                <tr>
                                      <td width=3 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_LEFT_GREEN.gif" width="3" height="17"></td>
                                        <td width="1%" id=pmem_bar background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif"></td>
                                        <td width=1 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif" width="1" height="17"></td>
                                        <td width=100%></td>
                                        <td width=1 align=right><img src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_BLUE.gif" width="1" height="17"></td>
                                </tr>
                        </table>
</td>
<td> {$ovars["LVE_LPMEM"]}</td></tr>
</table>
                                        <script language="Javascript">
                                        <!--

                                        pmem_bar_top={$ovars["LVE_PMEM"]};
                                        pmem_bar_current=0;

                                        function pmem_bar_scroll()
                                        {
                                                increase = 10;
                                                again = true;
                                                pmem_bar_current += increase;
                                                if (pmem_bar_current >= pmem_bar_top)
                                                {
                                                        pmem_bar_current = pmem_bar_top;
                                                        again=false;
                                                }

                                                if (document.getElementById)
                                                {
                                                        my_style = document.getElementById("pmem_bar").style;
                                                }
                                                else if (document.all)
                                                {
                                                        my_style = document.all["pmem_bar"].style;
                                                }
                                                else if (document.layers)
                                                {
                                                        my_style = document.layers["pmem_bar"];
                                                }

                                                my_style.width=pmem_bar_current+"%";

                                                if (again)
                                                        setTimeout("pmem_bar_scroll();", 50);
                                        }

                                        setTimeout("pmem_bar_scroll();", 1000);

                                        //-->
                                        </script>


<br /><br />
<strong> Number of processes:</strong> </br />
<table><tr><td>0 </td>
<td><table border="0" width="300" cellspacing="0" cellpadding="0" background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_BG_BLUE.gif">
                                <tr>
                                      <td width=3 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_LEFT_GREEN.gif" width="3" height="17"></td>
                                        <td width="1%" id=nproc_bar background="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif"></td>
                                        <td width=1 align=left><img border="0" src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_GREEN.gif" width="1" height="17"></td>
                                        <td width=100%></td>
                                        <td width=1 align=right><img src="/images/modules/plesk-lvemanager/IMG_SKIN_BAR_RIGHT_BLUE.gif" width="1" height="17"></td>
                                </tr>
                        </table>
</td>
<td> {$ovars["LVE_LNPROC"]}</td></tr>
</table>
                                        <script language="Javascript">
                                        <!--

                                        nproc_bar_top={$ovars["LVE_NPROC"]};
                                        nproc_bar_current=0;

                                        function nproc_bar_scroll()
                                        {
                                                increase = 10;
                                                again = true;
                                                nproc_bar_current += increase;
                                                if (nproc_bar_current >= nproc_bar_top)
                                                {
                                                        nproc_bar_current = nproc_bar_top;
                                                        again=false;
                                                }

                                                if (document.getElementById)
                                                {
                                                        my_style = document.getElementById("nproc_bar").style;
                                                }
                                                else if (document.all)
                                                {
                                                        my_style = document.all["nproc_bar"].style;
                                                }
                                                else if (document.layers)
                                                {
                                                        my_style = document.layers["nproc_bar"];
                                                }

                                                my_style.width=nproc_bar_current+"%";

                                                if (again)
                                                        setTimeout("nproc_bar_scroll();", 50);
                                        }

                                        setTimeout("nproc_bar_scroll();", 1000);

                                        //-->
                                        </script>


EOM;
	}



	$ovars["LVE_PERIOD"]="<option value='10m' ".(($period == '10m')?'selected="selected"':"").">Last 10 minutes</option>
			      <option value='30m' ".(($period == '30m')?'selected="selected"':"").">Last 30 minutes</option>
			      <option value='1h' ".(($period == '1h')?'selected="selected"':"").">Last hour</option>
			      <option value='4h' ".(($period == '4h')?'selected="selected"':"").">Last 4 hours</option>
			      <option value='1d' ".(($period == '1d')?'selected="selected"':"").">Last 24 hours</option>
			      <option value='today' ".(($period == 'today')?'selected="selected"':"").">Today</option>
			      <option value='yesterday' ".(($period == 'yesterday')?'selected="selected"':"").">Yesterday</option>
			      <option value='7d' ".(($period == '7d')?'selected="selected"':"").">Last 7 days</option>
			      <option value='30d' ".(($period == '30d')?'selected="selected"':"").">Last 30 days</option>";
	$ovars["LVE_CHARTPERIOD"]="/modules/plesk-lvemanager/chart.php?period=".$period."&uid=".$uid."&rand=".rand();

	ob_start();
	passthru("/usr/sbin/lveinfo --csv --period=$period --id=$uid");
	$lveInfoTmp = ob_get_contents();
	ob_end_clean();

	$ovars["LVE_TABLE"]="";

	$lveInfoAr = explode(chr(10), $lveInfoTmp);
	$start = 0;
	$fields=array();
	foreach ($lveInfoAr as $lveInfoVal)
	{
	    if($start==0){
		$ovars["LVE_TABLE"].= '<tr>';
		$lveInfoDet = explode(',', $lveInfoVal);
		$fields[]=$lveInfoDet[0];
		for($i=0;$i<count($lveInfoDet);$i++){
		    $ovars["LVE_TABLE"].="<th>".$lveInfoDet[$i]."</th>";
		    $fields[]=$lveInfoDet[$i];
		}
		$ovars["LVE_TABLE"].="</tr>";
	    }
    	    if($start > 0)
    	    {
                $lveInfoDet = explode(',', $lveInfoVal);
                if(strlen($lveInfoDet[0]) > 0)
                {

		    $ovars["LVE_TABLE"].= '<tr>';
            	    if($lveInfoDet[4] == 0)
            	    {
                        $lveInfoDet[4] = 100;
            	    }
            	    //$apcpu = ceil( $lveInfoDet[2] * 100 / $lveInfoDet[4]);
            	    //$mpcpu = ceil( $lveInfoDet[3] * 100 / $lveInfoDet[4]);
            	    for($i=0;$i<count($lveInfoDet);$i++){
            		if(stristr($fields[$i],"mem")===FALSE){
			    $ovars["LVE_TABLE"].="<td>".$lveInfoDet[$i]."</td>";
			} else {
			    $ovars["LVE_TABLE"].="<td>".roundMemB($lveInfoDet[$i])."</td>";
			}
		    }
            	    $ovars["LVE_TABLE"].= '</tr>';
                }
    	    }
    	    $start++;
	}


//-------------------------------------------------------------                                                                                              
                                                                                                                                                             
        return $ovars;                                                                                                                                       
    } 
}