<?php                                                                                                                                                        
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved                                                                                                   
 *                                                                                                                                                           
 * Licensed under CLOUD LINUX LICENSE AGREEMENT                                                                                                              
 * http://cloudlinux.com/docs/LICENSE.TXT                                                                                                                    
*/ 
                                                                                                                                                             
require_once('modules/plesk-lvemanager/roundmem.php');                                                                                                                                
require_once('modules/pm.php');
require_once('modules/plesk-lvemanager/checkData.php');

class ApiRequestException extends Exception {}
                                                                                                                                                             
class IndexUserPage {                                                                                                                                          
    private $module_pointer;                                                                                                                                 
                                                                                                                                                             
    public function _construct($ptr){                                                                                                                        
        $module_pointer=$ptr;                                                                                                                                
    }                                                       
                                                                                                                                                                                             
    public function getResult($vars){                                                                                                                        
        $ovars=$vars;   

//----------------------------------------------------------
        // find cur uid
        $login = getLogin();
        $uid = getUID($login);
    
        $ovars["LVE_UNM_LOGIN"]=$login;
        $ovars["LVE_UNM"]="&puid=".$uid;

        $cpu_limited_flag = 0;
        $memf_total = 0;
        $mepf_total = 0;
        $cpu_max = 0;
        $mem_max = 0;
        $lmem_max = 0;
        $ep_max = 0;
        $lep_max = 0;

        ob_start();
        passthru("/usr/sbin/lveinfo --csv --period=1d --id=$uid");
        $lveInfoTmp = ob_get_contents();
        ob_end_clean();


        $lveInfoAr = explode(chr(10), $lveInfoTmp);
        $start = 0;
        foreach ($lveInfoAr as $lveInfoValString){
            $lveInfoVal = explode(',', $lveInfoValString);
            if($start > 0){                
                if(strlen($lveInfoVal[0]) > 1){
                   $lveInfoVal[2] = ( $lveInfoVal[2] * 100 / $lveInfoVal[4]);
                   $lveInfoVal[3] = ( $lveInfoVal[3] * 100 / $lveInfoVal[4]);
                    //if($lveInfoVal[3] >= $lveInfoVal[4]){
                    if($lveInfoVal[3] >= 100){
                        $cpu_limited_flag = 1;
                    }
                    $memf_total += $lveInfoVal[11];
                    $mepf_total += $lveInfoVal[12];   
                    if($lveInfoVal[3] > $cpu_max){
                        $cpu_max = $lveInfoVal[3];
                    }
                    if($lveInfoVal[9] > $mem_max){
                        $mem_max = $lveInfoVal[9];
                    }                      
                    if($lveInfoVal[10] > $lmem_max){
                        $lmem_max = $lveInfoVal[10];
                    }
                    if($lveInfoVal[6] > $ep_max){
                        $ep_max = $lveInfoVal[6];
                    }       
                    if($lveInfoVal[7] > $lep_max){
                        $lep_max = $lveInfoVal[7];
                    }                               
                }               
            }
            $start++;
        }
        $ovars["LVE_RESULT"]="";

        if ( ($cpu_limited_flag) || ( $memf_total > 0 ) || ( $mepf_total > 0 ) ) {
            $ovars["LVE_RESULT"].='<strong>Your site has been limited within the past 24 hours</strong><br /><br />';
            if ($cpu_limited_flag) {
                $ovars["LVE_RESULT"].='CPU resources were limited for your site<br /><br />';
            }
            if ( $memf_total > 0 ) {
                $ovars["LVE_RESULT"].='Memory resources were limited for your site<br /><br />';
            }
            if ( $mepf_total > 0 ) {
                $ovars["LVE_RESULT"].='You have reached entry processes (number of simultaneously running php and cgi scripts, as well as cron jobs and shell sessions) limit <strong>'.$mepf_total.'</strong> times<br /><br />';
            }
        } else {
            $ovars["LVE_RESULT"].='<strong>Your site had no issues in the past 24 hours</strong>';
        }

        if ( ( ( !$cpu_limited_flag ) && ( $cpu_max > 90 ) ) || ( ( $memf_total == 0 ) && ( $lmem_max > 0 ) && ( $mem_max > $lmem_max * 0.9 ) ) || ( ( $mepf_total == 0 ) && ( $lep_max > 0 )  && ( $ep_max > $lep_max * 0.9 ) ) ) {
            $ovars["LVE_RESULT"].='<strong>Your site might hit resource limits soon</strong><br /><br />';
            if ( ( !$cpu_limited_flag ) && ( $cpu_max > 90 ) ) {
                $ovars["LVE_RESULT"].='Your CPU usage was at '.$cpu_max.'% out of 100%<br />';
            }
            if ( ( $memf_total == 0 ) && ( $lmem_max > 0 ) && ( $mem_max > $lmem_max * 0.9 ) ) {
                $ovars["LVE_RESULT"].='Your Memory usage was at '.RoundMemB($mem_max).' out of '.RoundMemB($lmem_max).'<br />';
            }
            if ( ( $mepf_total == 0 ) && ( $lep_max > 0 ) && ( $ep_max > $lep_max * 0.9 ) ) {
                $ovars["LVE_RESULT"].='You had '.$ep_max.' entry processes (number of simultaneously running php and cgi scripts, as well as cron jobs and shell sessions) out of '.$lep_max.' max entry processes allowed<br />';
            }
        }


//----------------------------------------------------------

        return $ovars;
    }

}