<?php
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
*/

function stripWarnsOrErrors($str){
    if ( $pos = strpos( $str, "ERROR:") !== false ) {
        $epos = strpos( $str, "\n", $pos );
        //print substr( $str, $pos, $epos+1);
        return;
    }
    while ( ( $pos = strpos( $str, "WARN:" ) ) !== false ) {
        $epos = strpos( $str, "\n", $pos );
        $warn = substr( $str, $pos, $epos+1);
        $warns[] = $warn;
        $str = str_replace( $warn, "", $str );
    }
    return $str;
}

function getSelectorData(){
    ob_start();
    passthru("/usr/bin/cl-selector --summary=php");
    $data = ob_get_contents();
    ob_end_clean();
    $data = stripWarnsOrErrors($data);
    $vData = explode( "\n", rtrim($data) );
    foreach ( $vData as $item ) {
        $vItem = explode( " ", rtrim($item) );
        $state = $vItem[1] == 'e' ? 1 : 0;
        if ( $vItem[2] == "d" ) { $state = 2; }
        $versions[ $vItem[0] ] = $state;
    }
    return $versions;
}

function getExtensionsData($version, $extDesc){
    ob_start();
    passthru("/usr/bin/cl-selector --list-extensions=php --version=" . $version);
    $data = ob_get_contents();
    ob_end_clean();
    $data = stripWarnsOrErrors($data);
    $eData = explode( "\n", rtrim($data) );
    foreach ( $eData as $ext ) {
        $eItem = explode( " ", rtrim($ext) );
        $iDesc = array_key_exists( $eItem[1], $extDesc ) ? $extDesc[ $eItem[1] ] : "no info";
        switch ( $eItem[0] ) {
            case '+':
                $ctrl = '<td title="' . $iDesc . '" style="padding:.4em 0 0 0;">' . $eItem[1] . '</td>';
                $ctrl .= '<td title="' . $iDesc . '" style="padding:0 1.6em 0 .8em;"><input type="checkbox" name="cbx_' . $eItem[1] . '" checked="checked"/></td>';
                break;
            case '-':
                $ctrl = '<td title="' . $iDesc . '" style="padding:.4em 0 0 0;">' . $eItem[1] . '</td>';
                $ctrl .= '<td title="' . $iDesc . '" style="padding:0 1.6em 0 .8em;"><input type="checkbox" name="cbx_' . $eItem[1] . '"/></td>';
                break;
            case '~':
                $ctrl = '<td title="' . $iDesc . '" style="padding:.4em 0 0 0;font-style:italic">' . $eItem[1] . '</td>';
                $ctrl .= '<td title="' . $iDesc . '" style="padding:0 1.6em 0 .8em;"><input type="checkbox" name="cbx_' . $eItem[1] . '" checked="checked" disabled="disabled"/></td>';
                break;
            default:
                $ctrl = '<td title="' . $iDesc . '" style="padding:.4em 0 0 0">' . $eItem[1] . '</td>';
                $ctrl .= '<td title="' . $iDesc . '" style="padding:0 1.6em 0 .8em;"><input type="checkbox" name="cbx_' . $eItem[1] . '"/></td>';
        }
        $extData[] = $ctrl;
    }
    return $extData;
}

function getExtensionDescriptions(){
    ob_start();
    passthru('/usr/bin/cl-phpextdesc');
    $data = split( "\n", rtrim( ob_get_contents() ) );
    ob_end_clean();
    foreach ( $data as $line ) {
        $pair = split( "=", $line );
        $desc[ $pair[0] ] = $pair[1];
    }
    return $desc;
}
?>
