<?php                                                                                                                                                        
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved                                                                                                   
 *                                                                                                                                                           
 * Licensed under CLOUD LINUX LICENSE AGREEMENT                                                                                                              
 * http://cloudlinux.com/docs/LICENSE.TXT                                                                                                                    
*/ 
                                                                                                                                                             
require_once('modules/pm.php');
require_once("modules/plesk-lvemanager/selectUserOpt.php");
require_once('modules/plesk-lvemanager/checkData.php');

class ApiRequestException extends Exception {}
                                                                                                                                                             
class SelectorUserPage {                                                                                                                                          
    private $module_pointer;                                                                                                                                 
                                                                                                                                                             
    public function _construct($ptr){                                                                                                                        
        $module_pointer=$ptr;                                                                                                                                
    }                                                       

    public function getResult($vars){                                                                                                                        
        $ovars=$vars;
        
//----------------------------------------------------------
        // find cur uid
        $login = getLogin(true);
        $uid = getUID($login);

//----------------------------------------------------------

//-- selector code
        $selectOpt = '';
        $warns = array();
        $ovars['SELECTOR_VERSION_STATE'] = "";
        $selectorData = getUserSelectorData($login);
        if ( ! array_key_exists( 'data', $selectorData ) ) {
            if (  array_key_exists( 'messages', $selectorData ) ) {
                $ovars['SELECTOR_ERRORS'] = implode( "\n", $selectorData['messages'] );
                $ovars['USER_SELECTED_VERSION'] = 'native';
                $ovars['USER_SELECTOPT_SELECT'] = '<select id="user-selector-version-select" disabled="disabled"><option>native</option>';
                $ovars["SELECTOR_CTRL_STATE"] = ' disabled="disabled"';
                $ovars["SELECTOPT_EXTTABLE"] = "";
                $ovars["SELECTUSEROPT_EXTDESC"] = "";
                $ovars["LOGIN_NAME"] = $login;
                $ovars['SELECTOR_VERSION_STATE'] = ' disabled="disabled"';
                return $ovars;
            }
        }
        
        if ( array_key_exists( 'messages', $selectorData ) ) {
            foreach ( $selectorData['messages'] as $i ) {
                $warns[] = $i;
            }
        }
        foreach ( $selectorData['data'] as $key => $value ) {
            if ( $value == 0 ) {
                continue;
            }
            elseif( $value == 3 ) {
                    $selectOpt .= '<option selected="selected">' . $key . '</option>';
                    $ovars["USER_SELECTED_VERSION"] = $key;
            }
            else {
                    $selectOpt .= '<option>' . $key . '</option>';
            }
        }
        $selectOpt .= "</select>";
        $ovars["USER_SELECTOPT_SELECT"] = '<select id="user-selector-select-version">' . $selectOpt;
        $extString = "";
        $extDesc = getUserExtensionDescriptions();
        $extList = getUserExtensionsData( $ovars["USER_SELECTED_VERSION"], $login, $extDesc );
    
        if ( ! array_key_exists( 'data', $extList ) ) {
            if ( array_key_exists( 'messages', $extList ) ) {
                $ovars['SELECTOR_ERRORS'] = implode( "\n", $extList['messages'] );
                $ovars['USER_SELECTED_VERSION'] = 'native';
                $ovars['USER_SELECTOPT_SELECT'] = '<select id="user-selector-select-version" disabled="disabled"><option>native</option>';
                $ovars["SELECTOR_CTRL_STATE"] = ' disabled="disabled"';
                $ovars["SELECTOPT_EXTTABLE"] = "";
                $ovars["SELECTUSEROPT_EXTDESC"] = "";
                $ovars["LOGIN_NAME"] = $login;
                $ovars['SELECTOR_VERSION_STATE'] = ' disabled="disabled"';
                return $ovars;
            }
        }
        if ( array_key_exists( 'messages', $extList ) ) {
            foreach ( $extList['messages'] as $i ) {
                $warns[] = $i;
            }
        }
        $extTotal = count($extList['data']);
        $colnum = 5;
        $rownum = intval( $extTotal / $colnum );
        if ( $extTotal % $colnum ) {
            $rownum += 1;
        }
        for ( $r=1; $r<=$rownum; $r++ ) {
            $color = $r == $rownum ? '#444444' : '#D8D8D8';
            $extString .= '<tr style="border-bottom:1px solid ' . $color . ';">';
            for ( $c=0; $c<$colnum; $c++ ) {
                $cellid = ($rownum * $c + $r - 1);
                if ( $cellid < $extTotal ) {
                    $extString .= $extList['data'][$cellid];
                }
                else {
                    $extString .= "<td></td><td></td>";
                }
            }
            $extString .= "</tr>";
        }
        $ovars["SELECTOR_CTRL_STATE"] = $ovars["USER_SELECTED_VERSION"] == 'native' ? ' disabled="disabled"' : "";
        $ovars["SELECTOPT_EXTTABLE"] = $extString;
        $ovars["SELECTUSEROPT_EXTDESC"] = json_encode($extDesc);
        $ovars["LOGIN_NAME"] = $login;
        if ( count($warns) > 0 ) {
            $ovars['SELECTOR_ERRORS'] = implode( "\n", $warns );
        }
        else {
            $ovars['SELECTOR_ERRORS'] = "";
        }
//-- end of selector code
        return $ovars;
    }

}
