<?
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved                                                                                                   
 *                                                                                                                                                           
 * Licensed under CLOUD LINUX LICENSE AGREEMENT                                                                                                              
 * http://cloudlinux.com/docs/LICENSE.TXT                                                                                                                    
*/ 

require_once('modules/plesk-lvemanager/checkInput.php');                                                                                                                              
require_once('modules/plesk-lvemanager/roundmem.php'); 
require_once('modules/plesk-lvemanager/veParser.php');                                                                                                                                                                                       
require_once('modules/plesk-lvemanager/veProcParser.php');

class StatsPage{                                                                                                                                           
    private $module_pointer;                                                                                                                                 
                                                                                                                                                             
    public function _construct($ptr){                                                                                                                        
        $module_pointer=$ptr;                                                                                                                                
    }                                                                                                                                                        
                                                                                                                                                             
    public function getResult($vars){                                                                                                                        
        $ovars=$vars;

//--------------Generate content here--------------------------


	if(isset($_POST['st']))
	{
	    $period = checkPeriod($_POST['timeframe']);
	    $st = checkSt($_POST['st']);
	    $orderBy = checkOrder($_POST['order-by']);
	    $byUsage = checkOrder($_POST['by-usage']);
	    $limit = checkNumber($_POST['limit']);
	    $percentage = checkNumber($_POST['percentage']);
	    $treshold = checkNumber($_POST['threshold']);
	    $byFault = checkFault($_POST['by-fault']);

	    if($st == 'order-by')
	    {
	        ob_start();
    		passthru("/usr/sbin/lveinfo --csv --period=$period --order-by=$orderBy --limit=$limit");
    		$lveInfoTmp = ob_get_contents();
    		ob_end_clean();
	    }elseif($st == 'by-usage'){
	        ob_start();
    		passthru("/usr/sbin/lveinfo --csv --period=$period --by-usage=$byUsage --percentage=$percentage");
	        $lveInfoTmp = ob_get_contents();
    		ob_end_clean();
	    }elseif($st == 'by-fault'){
	        ob_start();
	        passthru("/usr/sbin/lveinfo --csv --period=$period --by-fault=$byFault --threshold=$treshold");
	        $lveInfoTmp = ob_get_contents();
	        ob_end_clean();
	    }
	} else {
            $st = 'order-by';
            $period = 'today';
	}

	$result = "";

	$result.= "Timeframe: 
	    <select name='timeframe' size='1'>
	    <option value='10m' ".(($period == '10m')?'selected="selected"':"").">Last 10 minutes</option>
	    <option value='30m' ".(($period == '30m')?'selected="selected"':"").">Last 30 minutes</option>
	    <option value='1h' ".(($period == '1h')?'selected="selected"':"").">Last hour</option>
	    <option value='4h' ".(($period == '4h')?'selected="selected"':"").">Last 4 hours</option>
	    <option value='today' ".(($period == 'today')?'selected="selected"':"").">Today</option>
	    <option value='yesterday' ".(($period == 'yesterday')?'selected="selected"':"").">Yesterday</option>
	    <option value='7d' ".(($period == '7d')?'selected="selected"':"").">Last 7 days</option>
	    <option value='30d' ".(($period == '30d')?'selected="selected"':"").">Last 30 days</option>
	    </select>";
	$result.="<br />
	    <input type='radio' name='st' value='order-by' ".(($st == 'order-by')?'CHECKED':"").">Show TOP LVEs By 
	    <select name='order-by' size='1'>
	    <option value='cpu_max' ".(($orderBy == 'cpu_max')?'selected="selected"':"").">Max CPU</option>
	    <option value='cpu_avg' ".(($orderBy == 'cpu_avg')?'selected="selected"':"").">Average CPU</option>
	    <option value='mep_max' ".(($orderBy == 'mep_max')?'selected="selected"':"").">Max EP</option>
	    <option value='mep_avg' ".(($orderBy == 'mep_avg')?'selected="selected"':"").">Average EP</option>
	    <option value='mem_max' ".(($orderBy == 'mem_max')?'selected="selected"':"").">Max MEM</option>
	    <option value='mem_avg' ".(($orderBy == 'mem_avg')?'selected="selected"':"").">Average MEM</option> 
	    <option value='total_mem_faults' ".(($orderBy == 'total_mem_faults')?'selected="selected"':"").">Memory Faults</option>
	    <option value='total_mep_faults' ".(($orderBy == 'total_mep_faults')?'selected="selected"':"").">Entry Procs Faults</option>
	    </select> ";
	$result .= "Limit: <select name='limit' size='1'>
	    <option ".(($limit == '10')?'selected="selected"':"").">10</option>
	    <option ".(($limit == '25')?'selected="selected"':"").">25</option>
	    <option ".(($limit == '50')?'selected="selected"':"").">50</option>
	    <option ".(($limit == '100')?'selected="selected"':"").">100</option>
	    </select> <br/> 
	    <input type='radio' name='st' value='by-usage' ".(($st == 'by-usage')?'CHECKED':"").">Show LVEs Approaching Limit 
	    <select name='by-usage' size='1'>
	    <option value='cpu_max' ".(($byUsage == 'cpu_max')?'selected="selected"':"").">Max CPU</option>
	    <option value='cpu_avg' ".(($byUsage == 'cpu_avg')?'selected="selected"':"").">Average CPU</option>
	    <option value='mep_max' ".(($byUsage == 'mep_max')?'selected="selected"':"").">Max EP</option>
	    <option value='mep_avg' ".(($byUsage == 'mep_avg')?'selected="selected"':"").">Average EP</option>
	    <option value='mem_max' ".(($byUsage == 'mem_max')?'selected="selected"':"").">Max MEM</option>
	    <option value='mem_avg' ".(($byUsage == 'mem_avg')?'selected="selected"':"").">Average MEM</option>
	    </select> ";
	$result.=" Using: 
	    <select name='percentage' size='1'>
	    <option ".(($percentage == '50')?'selected="selected"':"").">50</option>
	    <option ".(($percentage == '75')?'selected="selected"':"").">75</option>
	    <option ".(($percentage == '90')?'selected="selected"':"").">90</option>
	    <option ".(($percentage == '95')?'selected="selected"':"").">95</option>
	    </select>% <br/> 
	    <input type='radio' name='st' value='by-fault' ".(($st == 'by-fault')?'CHECKED':"").">By Fault 
	    <select name='by-fault' size='1'>
	    <option value='mep' ".(($byFault == 'mep')?'selected="selected"':"").">Max Entry Processes</option>
	    <option value='mem' ".(($byFault == 'mem')?'selected="selected"':"").">Max Memory Limit</option>
	    </select> ";
	$result.=" Treshold: 
	    <select name='threshold' size='1'>
	    <option ".(($treshold == '1')?'selected="selected"':"").">1</option>
	    <option ".(($treshold == '10')?'selected="selected"':"").">10</option>
	    <option ".(($treshold == '50')?'selected="selected"':"").">50</option>
	    <option ".(($treshold == '75')?'selected="selected"':"").">75</option>
	    <option ".(($treshold == '1000')?'selected="selected"':"").">1000</option>%
	    </select>
	    <br/> 
	    <input type='submit'><input type='reset'><br/>
	    ";
	$ovars["LVE_FIELDS"]=$result;

	$result2 = "";
	$lveInfoAr = explode(chr(10), $lveInfoTmp);
	$start = 0;

        $ver = getLveVesrion();
        $avail_names = getAvailNames($ver);
        $name_to_titles = getnameToTitle();

	$fields=array();
	foreach ($lveInfoAr as $lveInfoVal){
	    if($start == 0){
		$lveInfoDet = explode(',', $lveInfoVal);
		if(count($lveInfoDet)>2) {
		    $result2.= "<tr>";
		    $result2.="<th>LVE Id</th><th>User</th>";
		}
		$fields[]=$lveInfoDet[0];
		for($i=1;$i<count($lveInfoDet);$i++){
		    $result2.="<th>".$lveInfoDet[$i]."</th>";
		    $fields[]=$lveInfoDet[$i];
		}
		if(count($lveInfoDet)>2) {
		    $result2.="</tr>";
		}
		$result2.="</tr>";
	    }
    	    if($start > 0){
                $lveInfoDet = explode(',', $lveInfoVal);
                if(strlen($lveInfoDet[0]) > 0){
            	    if($lveInfoDet[3] == 0){
                        $lveInfoDet[3] = 100;
            	    }
            	    $apcpu = ( $lveInfoDet[1] * 100 / $lveInfoDet[3]);
            	    $mpcpu = ( $lveInfoDet[2] * 100 / $lveInfoDet[3]);

            	    $uname = exec("/usr/bin/getent passwd $lveInfoDet[0] | cut -d: -f1");

		    if(($start%2)==0){                                                                                                                           
            		$result2 .= "<tr class=\"oddrowbg\">\n";                                                                                                      
        	    } else {                                                                                                                                         
            		$result2 .= "<tr class=\"evenrowbg\">\n";                                                                                                     
        	    }

		    $result2.= '<td> <a href="?tab=accounts&action=history&uid='.$lveInfoDet[0].'&acc='.$uname.'">'.$lveInfoDet[0].'</a></td>';
            	    $result2.= '<td><a href="?tab=accounts&action=history&uid='.$lveInfoDet[0].'&acc='.$uname.'">'.$uname.'</a></td>';		

                    for($i=1;$i<count($lveInfoDet);$i++){
                        if(stristr($fields[$i],"mem")===FALSE){
                            $result2.="<td>".$lveInfoDet[$i]."</td>";
                        } else {
                            $result2.="<td>".roundMemB($lveInfoDet[$i])."</td>";
                        }
                    }
                    $result2.= '</tr>';
                }
    	    }
    	    $start++;
	}
	$ovars["LVE_TABLE"]=$result2;

//-------------------------------------------------------------
                                                                                                                                                             
        return $ovars;                                                                                                                                       
    }

}