<?php
/* Copyright Cloud Linux Inc 2010-2011 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
*/

function getNameToProc(){
$name_to_proc=array(
	 "CPU"=>"lCPU",
	 "NCPU"=>"nCPU",
	 "IO"=>"lIO",
	 "MEM"=>"lMEM",
	 "OTHER"=>"lEP",
	 "PMEM"=>"lPMEM",
	 "NPROC"=>"lNPROC",
	 "READ"=>"lIOR",
	 "WRITE"=>"lIOW"
);
return $name_to_proc;
}

function getnameToTitle(){
$name_to_title=array(
	 "CPU"=>"CPU",
	 "NCPU"=>"nCPU",
	 "IO"=>"IO",
	 "MEM"=>"vMem",
	 "OTHER"=>"EP",
	 "PMEM"=>"pMem",
	 "NPROC"=>"nPROC",
	 "READ"=>"IOR",
	 "WRITE"=>"IOW"
);
return $name_to_title;
}

function getLveVesrion(){
    ob_start();
    passthru("/usr/bin/sudo /usr/sbin/lvectl --lve-version");
    $version=intval(ob_get_contents());
    ob_end_clean();
    return $version;
}

function getUserLimits($user_id, $ver, $veCfg, $pckCfg, $vepckCfg, $avail_names){

	//Get default
	$var=array();
	for($i=0;$i<count($avail_names);$i++){
	    $var[$avail_names[$i]]=0;
	}
	foreach($veCfg["DEFAULTS"] as $key=>$value){
	    if(isset($var[$key])){
		$var[$key]=$value;
	    }
	}
	
	//Get package
	foreach($pckCfg as $plan=>$user){
	    $fnd_user=0;
	    for($i=0;$i<count($user);$i++){
		if($user_id==$user[$i]){
		    $fnd_user=1;
		    break;
		}
	    }
	    if ($fnd_user==1){
		if(isset($vepckCfg[$plan])){
		    foreach($vepckCfg[$plan] as $key=>$value){
			if(isset($var[$key])){
			    $var[$key]=$value;
			}
		    }
		}
	    }
	}

	//Get ve id
	if (isset($veCfg[$user_id])){
	    foreach($veCfg[$user_id] as $key=>$value){
		if(isset($var[$key])){
		    $var[$key]=$value;
		}
	    }
	}
	return $var;
	
}

function getDefaultLimits($user_id, $ver, $veCfg, $pckCfg, $vepckCfg, $avail_names){
    	//Get default
	$var=array();
	for($i=0;$i<count($avail_names);$i++){
	    $var[$avail_names[$i]]=0;
	}
	foreach($veCfg["DEFAULTS"] as $key=>$value){
	    if(isset($var[$key])){
		$var[$key]=$value;
	    }
	}
	
	//Get package
	foreach($pckCfg as $plan=>$user){
	    $fnd_user=0;
	    for($i=0;$i<count($user);$i++){
		if($user_id==$user[$i]){
		    $fnd_user=1;
		    break;
		}
	    }

	    if ($fnd_user==1){
		if(isset($vepckCfg[$plan])){
		    foreach($vepckCfg[$plan] as $key=>$value){
			if(isset($var[$key])){
			    $var[$key]=$value;
			}
		    }
		}
	    }
	}

	return $var;

}

function getDefaultPckg($pkgName, $ver, $veCfg, $pckCfg, $vepckCfg, $avail_names){
    	//Get default
	$var=array();
	for($i=0;$i<count($avail_names);$i++){
	    $var[$avail_names[$i]]=0;
	}
	foreach($veCfg["DEFAULTS"] as $key=>$value){
	    if(isset($var[$key])){
		$var[$key]=$value;
	    }
	}
	
	if(isset($vepckCfg[$pkgName])){
	    foreach($vepckCfg[$pkgName] as $key=>$value){
		if(isset($var[$key])){
		    $var[$key]=$value;
		}
	    }
	}


	return $var;

}

function getDefault($ver, $veCfg, $pckCfg, $vepckCfg, $avail_names){
    	//Get default
	$var=array();
	for($i=0;$i<count($avail_names);$i++){
	    $var[$avail_names[$i]]=0;
	}
	foreach($veCfg["DEFAULTS"] as $key=>$value){
	    if(isset($var[$key])){
		$var[$key]=$value;
	    }
	}
	
	return $var;

}


function getUserPackages(){
    $ul=array();
    ob_start();
    passthru("/usr/bin/sudo /usr/bin/getcontrolpaneluserspackages --list-all");
    $pkgs=ob_get_contents();
    ob_end_clean();
    $result = explode(chr(10), $pkgs);
    foreach ($result as $val){
	$rs=explode(" ", $val);
	if(count($rs>1)){
	    $user=$rs[0];
	    $plan="";
	    for($i=1;$i<(count($rs));$i++){
		$plan.=$rs[$i]." ";
	    }
	    $user=trim($user);
	    $plan=trim($plan);
	    if(isset($ul[$plan])){
		$ul[$plan][]=$user;
	    } else {
		$ul[$plan]=array();
		$ul[$plan][]=$user;
	    }
	}
    }
    return $ul;
}

function veParser()
{
$file = "/etc/container/ve.cfg";
$params=array();

if( $xml = simplexml_load_string(file_get_contents($file)) ) {
    foreach ($xml->children() as $lveid){
	if($lveid->getName()!="lve" && $lveid->getName()!="defaults") continue;
	$lve_name="";
	if ($lveid->getName()=="defaults")
	    $lve_name = "DEFAULTS";
	else {
	    foreach($lveid->attributes() as $a => $b){
		if ($a=="id"){
		    $lve_name=trim($b);
		    break;
		}
	    }
	}
	if($lve_name!=""){
	    foreach( $lveid as $element ){
		$value="";
		foreach($element->attributes() as $key=>$val){
		    $value=(string)$val;
		    break;
		}
		$params[$lve_name][strtoupper($element->getName())]=$value;
	    }
	}
    }
}
return $params;
}


function pckgParser(){
$file = "/etc/container/ve.cfg";
$params=array();

if( $xml = simplexml_load_string(file_get_contents($file)) ) {
    foreach ($xml->children() as $lveid){
	if($lveid->getName()!="package") continue;
	$lve_name="";
	foreach($lveid->attributes() as $a => $b){
	    if ($a=="id"){
		$lve_name=trim($b);
		break;
	    }
	}
	if($lve_name!=""){
	    foreach( $lveid as $element ){
		$value="";
		foreach($element->attributes() as $key=>$val){
		    $value=(string)$val;
		    break;
		}
		$params[$lve_name][strtoupper($element->getName())]=$value;
	    }
	}
    }
}
return $params;

}

function getAvailNames($ver){
	if($ver==4){
	    $avail_names=array(
		"CPU",
		"NCPU",
		//"IO",
		"MEM",
		"OTHER"
	    );
	} else if ($ver==6){
	    $avail_names=array(
		"CPU",
		"NCPU",
		"IO",
		"MEM",
		"OTHER",
		"PMEM",
		"NPROC"
	    );
	} else {
	    $avail_names=array(
		"CPU",
		"NCPU",
		"IO",
		"MEM",
		"OTHER",
		"PMEM",
		"NPROC",
		"READ",
		"WRITE"
	    );
	}
	return $avail_names;

}

?>
